/*************************************
 * Adconverter.c
 *   
 * : 06.10.2018 11:04:47
 * :  .
 *************************************/

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include "Adconverter.h"
#include "Main.h"
#include "Systemcontrol.h"
#include "Operatingmode.h"

word adcoffsetvoltage=0; //    

EEMEM static word Adc_DividerVoltage[97]={0,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER, //[1-6]
											ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER,ADCNIMHCD_DIVIDER, //[7-12]
											ADC2NIMH_DIVIDER,ADC2NIMH_DIVIDER,ADC3NIMH_DIVIDER,ADC3NIMH_DIVIDER,ADC4NIMH_DIVIDER,ADC4NIMH_DIVIDER,ADC5NIMH_DIVIDER, //[13-19]
											ADC5NIMH_DIVIDER,ADC6NIMH_DIVIDER,ADC6NIMH_DIVIDER,ADC7NIMH_DIVIDER,ADC7NIMH_DIVIDER,ADC8NIMH_DIVIDER,ADC8NIMH_DIVIDER, //[20-26]
											ADCNIZN_DIVIDER,ADCNIZN_DIVIDER,ADCNIZN_DIVIDER,ADCNIZN_DIVIDER, //[27-30]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[31-35]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[36-40]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[41-45]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[46-50]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[51-56]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[57-62]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[63-68]
											ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER,ADCLITHIUM1_DIVIDER, //[69-74]
											ADCLITHIUM3_DIVIDER,ADCLITHIUM3_DIVIDER,ADCLITHIUM3_DIVIDER,ADCLITHIUM3_DIVIDER,ADCLITHIUM3_DIVIDER,ADCLITHIUM3_DIVIDER, //[75-80]
											ADCLITHIUM2_DIVIDER,ADCLITHIUM2_DIVIDER,ADCLITHIUM2_DIVIDER,ADCLITHIUM2_DIVIDER,ADCLITHIUM2_DIVIDER,ADCLITHIUM2_DIVIDER, //[81-86]
											ADCLIFEPO4_DIVIDER,ADCLIFEPO4_DIVIDER,ADCSLA2V_DIVIDER,ADCSLA2V_DIVIDER,ADCSLA4V_DIVIDER,ADCSLA4V_DIVIDER, //[87-92]
											ADCSLA6V_DIVIDER,ADCSLA6V_DIVIDER,ADCSLA12V_DIVIDER,ADCSLA12V_DIVIDER}; //[93-96]         
											
EEMEM static dword Adc_FirstchargeResistance=ADCMEASCUR_RESISTOR; //      1
EEMEM static dword Adc_FirstdischargeResistance=ADCMEASCUR_RESISTOR; //      1
EEMEM static dword Adc_SecondchargeResistance=ADCMEASCUR_RESISTOR; //      2
EEMEM static dword Adc_SeconddischargeResistance=ADCMEASCUR_RESISTOR; //      2

word ADC_ReadMeasuredata(byte measureinput_prm) //    
	{
	word adconvertdata_tmp=0; //  
	dword measurevoltage_tmp=0;
	ADMUX=measureinput_prm|(ADCBASE_REFTYPE&255); //   
	_delay_loop_2(40); // 10       
	ADCSRA|=64; //  
	while((ADCSRA&16)==0); //   
	ADCSRA|=16; //    
	adconvertdata_tmp=ADCW; //   
	measurevoltage_tmp=(dword)adconvertdata_tmp*ADCAREF_VOLTAGE/1024; //     
	return (word)measurevoltage_tmp; //   
	}

void ADC_InitializeDevice(void) //   
	{
	ADMUX=ADCBASE_REFTYPE&255; //   1,1 
	ADCSRA=ADCMODE_DATA; //   125 
	_delay_loop_2(640); //     160 
	adcoffsetvoltage=ADC_OffsetMeasure(); //  
	}

word ADC_OffsetMeasure(void) //     
	{
	byte countcycle_tmp=0; //  
	word measuredata_tmp=0;
	while(countcycle_tmp<100) //    
		{
		measuredata_tmp+=ADC_ReadMeasuredata(ADCOFFSET_AGND); //    
		countcycle_tmp++; //  
		SYS_TimeWaiting(10); // 10 
		}
	measuredata_tmp/=countcycle_tmp; //    
	return measuredata_tmp; //   
	}

word ADC_AverageMeasuredata(byte numbercycle_prm,byte measureinput_prm) //     
	{
	byte countmeasure_tmp=0; // 
	dword measurevoltage_tmp=0; 
	word offsetdata_tmp=0;
	while(countmeasure_tmp<numbercycle_prm) //   
		{
		measurevoltage_tmp+=ADC_ReadMeasuredata(measureinput_prm); //  
		offsetdata_tmp+=adcoffsetvoltage; //   
		countmeasure_tmp++; //  
		SYS_TimeWaiting(1); // 1 
		}
	if(measurevoltage_tmp>=offsetdata_tmp) measurevoltage_tmp-=offsetdata_tmp; //  
	measurevoltage_tmp/=countmeasure_tmp; //  
	return (word)measurevoltage_tmp; //  
	}

word ADC_MeasureVoltage(byte numbercycle_prm,byte measureinput_prm) //    
	{
	bit indxprocessnumber_tmp=FALSE; // 
	byte numbersensor_tmp=0;
	word measurevoltage_tmp=0;
	dword datadivider_tmp=0;
	dword extrameasuredata_tmp=0;
	dword limitvoltagebattery_tmp=0;
	measurevoltage_tmp=ADC_AverageMeasuredata(numbercycle_prm,measureinput_prm); //    
	switch(measureinput_prm) //  
		{
		case ADCFIRST_VOLTAGE: indxprocessnumber_tmp=FALSE; //  1
								break;
		case ADCSECOND_VOLTAGE: indxprocessnumber_tmp=TRUE; //  2
		}
	numbersensor_tmp=OPR_ReadnumberSensor(indxprocessnumber_tmp); //  
	datadivider_tmp=(dword)ADC_ReadingDivider(numbersensor_tmp); //    
	extrameasuredata_tmp=(dword)measurevoltage_tmp*datadivider_tmp/1000; //   
	if(extrameasuredata_tmp>100) //   100 
		{
		switch(numbersensor_tmp) //   
			{
			case 1 ... 12: limitvoltagebattery_tmp=ADCLIMIT_NIMHCD; //     Ni-Cd  Ni-Mh 
					break;
			case 13 ... 14: limitvoltagebattery_tmp=ADCLIMIT_2NIMH; //       2- Ni-Mh 
					break;
			case 15 ... 16: limitvoltagebattery_tmp=ADCLIMIT_3NIMH; //       3- Ni-Mh 
					break;
			case 17 ... 18: limitvoltagebattery_tmp=ADCLIMIT_4NIMH; //       4- Ni-Mh 
					break;
			case 19 ... 20: limitvoltagebattery_tmp=ADCLIMIT_5NIMH; //       5- Ni-Mh 
					break;
			case 21 ... 22: limitvoltagebattery_tmp=ADCLIMIT_6NIMH; //       6- Ni-Mh 
					break;
			case 23 ... 24: limitvoltagebattery_tmp=ADCLIMIT_7NIMH; //       7- Ni-Mh 
					break;
			case 25 ... 26: limitvoltagebattery_tmp=ADCLIMIT_8NIMH; //       8- Ni-Mh 
					break;
			case 27 ... 30: limitvoltagebattery_tmp=ADCLIMIT_NIZN; //     Ni-Zn 
					break;
			case 31 ... 74: limitvoltagebattery_tmp=ADCLIMIT_LITHIUM1; //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc 
					break;
			case 75 ... 80: limitvoltagebattery_tmp=ADCLIMIT_LITHIUM3; //     Li-Ti 
					break;
			case 81 ... 86: limitvoltagebattery_tmp=ADCLIMIT_LITHIUM2; //     Li-Fe 
					break;
			case 87 ... 88: limitvoltagebattery_tmp=ADCLIMIT_LIFEPO4; //     LiFePo4 
					break;
			case 89 ... 90: limitvoltagebattery_tmp=ADCLIMIT_SLA2V; //     Sla-2v 
					break;
			case 91 ... 92: limitvoltagebattery_tmp=ADCLIMIT_SLA4V; //     Sla-4v 
					break;
			case 93 ... 94: limitvoltagebattery_tmp=ADCLIMIT_SLA6V; //     Sla-6v 
					break;
			case 95 ... 96: limitvoltagebattery_tmp=ADCLIMIT_SLA12V; //     Sla-12v 
			}
		extrameasuredata_tmp=extrameasuredata_tmp+limitvoltagebattery_tmp/extrameasuredata_tmp; //     
		}
	return (word)extrameasuredata_tmp; //   
	}

word ADC_MeasureCurrent(byte numbercycle_prm,byte measureinput_prm) //   /  
	{
	byte numberparameters_tmp=0; // 
	word measurevoltage_tmp=0;
	word resistancedata_tmp=0;
	dword extrameasuredata_tmp=0;
	measurevoltage_tmp=ADC_AverageMeasuredata(numbercycle_prm,measureinput_prm); //      
	switch(measureinput_prm) //      
		{
		case ADCSECOND_CURRCHARGE: numberparameters_tmp=2; //     2
					break;
		case ADCSECOND_CURRDISCHARGE: numberparameters_tmp=4; //     2
					break;
		case ADCFIRST_CURRCHARGE: numberparameters_tmp=1; //     1
					break;
		case ADCFIRST_CURRDISCHARGE: numberparameters_tmp=3; //     1
		}
	resistancedata_tmp=ADC_ReadingParameters(numberparameters_tmp); //   
	extrameasuredata_tmp=(dword)measurevoltage_tmp*10000/resistancedata_tmp; //  / 
	if(extrameasuredata_tmp>99) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMIT_CURRENT/extrameasuredata_tmp; //   100   
	else if((extrameasuredata_tmp>4)&&(extrameasuredata_tmp<100)) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMIT_CURRENT/120; //   100 
	return (word)extrameasuredata_tmp; //  
	}

dword ADC_ReadingParameters(byte numberparameters_prm) //         
	{
	dword dataconstants_tmp=0; // 
	switch(numberparameters_prm) //   
		{
		case 0: dataconstants_tmp=ADCAREF_VOLTAGE; //     
				break;
		case 1: dataconstants_tmp=eeprom_read_dword(&Adc_FirstchargeResistance); //      1
				break;
		case 2: dataconstants_tmp=eeprom_read_dword(&Adc_SecondchargeResistance); //      2
				break;
		case 3: dataconstants_tmp=eeprom_read_dword(&Adc_FirstdischargeResistance); //      1
				break;
		case 4: dataconstants_tmp=eeprom_read_dword(&Adc_SeconddischargeResistance); //      2
		}
	return dataconstants_tmp; //   
	}

void ADC_UpdateDivider(byte numbersensor_prm,word divisionfactor_prm) //     
	{
	eeprom_update_word(&Adc_DividerVoltage[numbersensor_prm],divisionfactor_prm); //     
	}

void ADC_UpdateResistance(byte countmodecalibrate_prm,dword measuredvaluesdata_prm) //    
	{
	switch(countmodecalibrate_prm) //  
		{
		case 0: break; // 
		case 1: eeprom_update_dword(&Adc_FirstchargeResistance,measuredvaluesdata_prm); //      1
				break;
		case 2: eeprom_update_dword(&Adc_SecondchargeResistance,measuredvaluesdata_prm); //      2
				break;
		case 3: eeprom_update_dword(&Adc_FirstdischargeResistance,measuredvaluesdata_prm); //      1
				break;
		case 4: eeprom_update_dword(&Adc_SeconddischargeResistance,measuredvaluesdata_prm); //      2
		}
	}

word ADC_ReadingDivider(byte numbersensor_prm) //    
	{
	word datadivider_tmp=0; // 
	datadivider_tmp=eeprom_read_word(&Adc_DividerVoltage[numbersensor_prm]); //     
	return datadivider_tmp; //   
	}

void ADC_DefaultDivider(byte numbersensor_prm) //      
	{
	word valuedivider_tmp=0; //  
	switch(numbersensor_prm) //    
		{
		case 1 ... 12: valuedivider_tmp=ADCNIMHCD_DIVIDER; //      Ni-Cd  Ni-Mh 
				break;
		case 13 ... 14: valuedivider_tmp=ADC2NIMH_DIVIDER; //        2- Ni-Mh 
				break;
		case 15 ... 16: valuedivider_tmp=ADC3NIMH_DIVIDER; //        3- Ni-Mh 
				break;
		case 17 ... 18: valuedivider_tmp=ADC4NIMH_DIVIDER; //        4- Ni-Mh 
				break;
		case 19 ... 20: valuedivider_tmp=ADC5NIMH_DIVIDER; //        5- Ni-Mh 
				break;
		case 21 ... 22: valuedivider_tmp=ADC6NIMH_DIVIDER; //        6- Ni-Mh 
				break;
		case 23 ... 24: valuedivider_tmp=ADC7NIMH_DIVIDER; //        7- Ni-Mh 
				break;
		case 25 ... 26: valuedivider_tmp=ADC8NIMH_DIVIDER; //        8- Ni-Mh 
				break;
		case 27 ... 30: valuedivider_tmp=ADCNIZN_DIVIDER; //      Ni-Zn 
				break;
		case 31 ... 74: valuedivider_tmp=ADCLITHIUM1_DIVIDER; //      Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc 
				break;
		case 75 ... 80: valuedivider_tmp=ADCLITHIUM3_DIVIDER; //      Li-Ti 
				break;
		case 81 ... 86: valuedivider_tmp=ADCLITHIUM2_DIVIDER; //      Li-Fe 
				break;
		case 87 ... 88: valuedivider_tmp=ADCLIFEPO4_DIVIDER; //      LiFePo4 
				break;
		case 89 ... 90: valuedivider_tmp=ADCSLA2V_DIVIDER; //      Sla-2v 
				break;
		case 91 ... 92: valuedivider_tmp=ADCSLA4V_DIVIDER; //      Sla-4v 
				break;
		case 93 ... 94: valuedivider_tmp=ADCSLA6V_DIVIDER; //      Sla-6v 
				break;
		case 95 ... 96: valuedivider_tmp=ADCSLA12V_DIVIDER; //      Sla-12v 
		}
	ADC_UpdateDivider(numbersensor_prm,valuedivider_tmp); //    
	}

void ADC_DefaultResistance(byte countmodecalibrate_prm) //      
	{
	ADC_UpdateResistance(countmodecalibrate_prm,ADCMEASCUR_RESISTOR); //     
	}






