	/***********************************************
* Calibrationmode.c
*    
* : 08.06.2022 10:26:31
* :  .
************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <math.h>
#include <avr/sfr_defs.h>
#include "Main.h"
#include "Calibrationmode.h"
#include "Systemcontrol.h"
#include "Symbolout.h"
#include "Keybuttscan.h"
#include "Adconverter.h"
#include "Operatingmode.h"

bit_cal indx_cal={0,0,0,0,0,0}; // 
var_cal alter_cal={0,0,0}; // 

void CAL_MainMode(bit indxupdateline_prm) //    
	{
	byte datacodecontrol_tmp=0; //  
	byte spotpositioncursor_tmp=0; 	
	if(indxupdateline_prm==TRUE) indx_cal.updatecalibrateline=TRUE; //         
	datacodecontrol_tmp=KEY_DecoderButton(); //  
	if(datacodecontrol_tmp>0) CAL_ControlCalibrate(datacodecontrol_tmp); //    
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.counterpositioncursor) //     
						{
						case 0: spotpositioncursor_tmp=0; //       
								break;
						case 1: spotpositioncursor_tmp=4; //     
								break;
						case 2: spotpositioncursor_tmp=8; //    / 
								break;
						case 3:	spotpositioncursor_tmp=11; //        
								break;
						case 4: spotpositioncursor_tmp=12; //        
						}
					break;
		case TRUE: switch(alter_cal.counterpositioncursor) //    
						{
						case 0: spotpositioncursor_tmp=0; //      
								break;
						case 1: spotpositioncursor_tmp=3; //     
								break;
						case 2: spotpositioncursor_tmp=8; //    /  
						}
		}
	if(indx_cal.updatecalibrateline==TRUE) //     
		{
		indx_cal.updatecalibrateline=FALSE; //  
		CAL_UpdateOutline(); //   
		}
	CAL_UpdateOutdata(); //   
	SYM_CursorPosition(spotpositioncursor_tmp); //    
	SYS_TimeWaiting(300); // 300  
	}

void CAL_UpdateOutline(void) //   
	{
	switch(indx_cal.calibrationswitch) //   /
		{
		case FALSE:	switch(alter_cal.countercurrentcalibrate) //     
						{
						case 0: SYM_WordLineout(FALSE,18,0); // : . 
								break;
						case 1: switch(indx_cal.switchdataresults) //  /   1
									{
									case FALSE:	SYM_ByteLineout(FALSE,5,23,35,0,0); //     : I:  ,    
												break;
									case TRUE: SYM_ByteLineout(FALSE,5,25,42,0,0); //      : R:  0,     
									}
								break;
						case 2: switch(indx_cal.switchdataresults) //  /   2
									{
									case FALSE:	SYM_ByteLineout(TRUE,5,23,35,0,0); //     : I:  ,    
												break;
									case TRUE: SYM_ByteLineout(TRUE,5,25,42,0,0); //      : R:  0,     
									}
								break;
						case 3: switch(indx_cal.switchdataresults) //  /   1
									{
									case FALSE:	SYM_ByteLineout(FALSE,5,24,35,0,0); //     : I:  ,    
												break;
									case TRUE: SYM_ByteLineout(FALSE,5,25,42,0,0); //      : R:  0,     
									}
								break;
						case 4: switch(indx_cal.switchdataresults) //  /   2
									{
									case FALSE:	SYM_ByteLineout(TRUE,5,24,35,0,0); //     : I:  ,    
												break;
									case TRUE: SYM_ByteLineout(TRUE,5,25,42,0,0); //      : R:  0,     
									}
						}
					break;
		case TRUE: switch(alter_cal.countervoltagecalibrate) //    
						{
						case 0: SYM_WordLineout(FALSE,17,0); // : . 
								break;
						case 1: switch(indx_cal.switchdataresults) //  /  1
									{
									case FALSE: SYM_ByteLineout(FALSE,4,27,34,0,0); //    : A:      ,    
												break;
									case TRUE: SYM_ByteLineout(FALSE,5,26,38,0,0); //      : K:     ,
									}
								break;
						case 2: switch(indx_cal.switchdataresults) //  /  2
									{
									case FALSE: SYM_ByteLineout(TRUE,4,27,34,0,0); //    : A:      ,    
												break;
									case TRUE: SYM_ByteLineout(TRUE,5,26,38,0,0); //      : K:     ,
									}
						}
		}
	}

void CAL_UpdateOutdata(void) //   
	{
	byte numbersensor_tmp=0; //  
	word measuredvaluesdata_tmp=0;
	dword calibrationvalue_tmp=0;
	switch(indx_cal.calibrationswitch) //   /
		{
		case FALSE:	switch(alter_cal.countercurrentcalibrate) //    
						{
						case 0: break; // 
						case 1 ... 2: switch(indx_cal.numberbattery) //  
										{
										case FALSE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
													break;
										case TRUE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
										}
									if(indx_cal.calibrationcurrent==TRUE) //    
										{
										indx_cal.calibrationcurrent=FALSE; // 
										CAL_CalibrmeasCurrent(measuredvaluesdata_tmp); //   
										}
									switch(indx_cal.switchdataresults) //  / 
										{
										case FALSE:	SYM_OutdataNumber0_000(measuredvaluesdata_tmp,8); //  
													break;
										case TRUE: calibrationvalue_tmp=ADC_ReadingParameters(alter_cal.countercurrentcalibrate); //    
													SYM_OutdataNumber0000((word)calibrationvalue_tmp,9); //    
										}
								break;
						case 3 ... 4: switch(indx_cal.numberbattery) //  
										{
										case FALSE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
													break;
										case TRUE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //    2
										}
									if(indx_cal.calibrationcurrent==TRUE) //    
										{
										indx_cal.calibrationcurrent=FALSE; // 
										CAL_CalibrmeasCurrent(measuredvaluesdata_tmp); //   
										}
									switch(indx_cal.switchdataresults) //  / 
										{
										case FALSE:	SYM_OutdataNumber0_000(measuredvaluesdata_tmp,8); //  
													break;
										case TRUE: calibrationvalue_tmp=ADC_ReadingParameters(alter_cal.countercurrentcalibrate); //    
													SYM_OutdataNumber0000((word)calibrationvalue_tmp,9); //    
										}
						}
					break;
		case TRUE: switch(alter_cal.countervoltagecalibrate) //    
						{
						case 0: break; // 
						case 1 ... 2: switch(indx_cal.numberbattery) //  
										{
										case FALSE: measuredvaluesdata_tmp=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //    1
													break;
										case TRUE: measuredvaluesdata_tmp=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //    2
										}
									numbersensor_tmp=OPR_ReadnumberSensor(indx_cal.numberbattery); //  
									if(indx_cal.calibrationvoltage==TRUE) //    
										{
										indx_cal.calibrationvoltage=FALSE; // 
										CAL_CalibrmeasVoltage(numbersensor_tmp,measuredvaluesdata_tmp); //       
										}
									switch(indx_cal.switchdataresults) //  / 
										{
										case FALSE:	SYM_OutdataNumber00_000(measuredvaluesdata_tmp,8); //   
													break;
										case TRUE: calibrationvalue_tmp=ADC_ReadingDivider(numbersensor_tmp); //       
													SYM_OutdataNumber00_000((word)calibrationvalue_tmp,8); //   
										}
						}
		}
	}

void CAL_CalibrmeasVoltage(byte numbersensor_prm,word measuredvaluesdata_prm) //       
	{
	dword divisionfactor_tmp=0; //  
	switch(numbersensor_prm) //    
		{
		case 1 ... 12: if((measuredvaluesdata_prm>CALMINRANGE_NIMHCD)&&(measuredvaluesdata_prm<CALMAXRANGE_NIMHCD)) //      
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALNIMHCD_VOLTAGE,CALNIMHCD_DIVIDER); //    Ni-Mh  Ni-Cd  
							}
						break;
		case 13 ... 14: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*2))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*2))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL2NIMH_VOLTAGE,CAL2NIMH_DIVIDER); //      2-x Ni-Mh 
							}
						break;
		case 15 ... 16: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*3))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*3))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL3NIMH_VOLTAGE,CAL3NIMH_DIVIDER); //      3-x Ni-Mh 
							}
						break;
		case 17 ... 18: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*4))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*4))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL4NIMH_VOLTAGE,CAL4NIMH_DIVIDER); //      4-x Ni-Mh 
							}
						break;
		case 19 ... 20: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*5))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*5))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL5NIMH_VOLTAGE,CAL5NIMH_DIVIDER); //      5- Ni-Mh 
							}
						break;
		case 21 ... 22: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*6))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*6))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL6NIMH_VOLTAGE,CAL6NIMH_DIVIDER); //      6- Ni-Mh 
							}
						break;
		case 23 ... 24: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*7))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*7))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL7NIMH_VOLTAGE,CAL7NIMH_DIVIDER); //      7- Ni-Mh 
							}
						break;
		case 25 ... 26: if((measuredvaluesdata_prm>(CALMINRANGE_NIMHCD*8))&&(measuredvaluesdata_prm<(CALMAXRANGE_NIMHCD*8))) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CAL8NIMH_VOLTAGE,CAL8NIMH_DIVIDER); //      8- Ni-Mh 
							}
						break;
		case 27 ... 30: if((measuredvaluesdata_prm>CALMINRANGE_NIZN)&&(measuredvaluesdata_prm<CALMAXRANGE_NIZN)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALNIZN_VOLTAGE,CALNIZN_DIVIDER); //    Ni-Zn 
							}
						break;
		case 31 ... 74: if((measuredvaluesdata_prm>CALMINRANGE_LITHIUM1)&&(measuredvaluesdata_prm<CALMAXRANGE_LITHIUM1)) //      
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALLITHIUM1_VOLTAGE,CALLITHIUM1_DIVIDER); //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
							}
						break;
		case 75 ... 80: if((measuredvaluesdata_prm>CALMINRANGE_LITHIUM3)&&(measuredvaluesdata_prm<CALMAXRANGE_LITHIUM3)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALLITHIUM3_VOLTAGE,CALLITHIUM3_DIVIDER); //    Li-Ti 
							}
						break;
		case 81 ... 86: if((measuredvaluesdata_prm>CALMINRANGE_LITHIUM2)&&(measuredvaluesdata_prm<CALMAXRANGE_LITHIUM2)) //      
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALLITHIUM2_VOLTAGE,CALLITHIUM2_DIVIDER); //    Li-Fe 
							}
						break;
		case 87 ... 88: if((measuredvaluesdata_prm>CALMINRANGE_LIFEPO4)&&(measuredvaluesdata_prm<CALMAXRANGE_LIFEPO4)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALLIFEPO4_VOLTAGE,CALLIFEPO4_DIVIDER); //    LiFePo4 
							}
						break;
		case 89 ... 90: if((measuredvaluesdata_prm>CALMINRANGE_SLA2V)&&(measuredvaluesdata_prm<CALMAXRANGE_SLA2V)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALSLA2V_VOLTAGE,CALSLA2V_DIVIDER); //    Sla-2v 
							}
						break;
		case 91 ... 92: if((measuredvaluesdata_prm>CALMINRANGE_SLA4V)&&(measuredvaluesdata_prm<CALMAXRANGE_SLA4V)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALSLA4V_VOLTAGE,CALSLA4V_DIVIDER); //    Sla-4v 
							}
						break;
		case 93 ... 94: if((measuredvaluesdata_prm>CALMINRANGE_SLA6V)&&(measuredvaluesdata_prm<CALMAXRANGE_SLA6V)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALSLA6V_VOLTAGE,CALSLA6V_DIVIDER); //    Sla-6v 
							}
						break;
		case 95 ... 96: if((measuredvaluesdata_prm>CALMINRANGE_SLA12V)&&(measuredvaluesdata_prm<CALMAXRANGE_SLA12V)) //     
							{
							divisionfactor_tmp=CAL_CalculateDivider(measuredvaluesdata_prm,CALSLA12V_VOLTAGE,CALSLA12V_DIVIDER); //    Sla-12v 
							}
		}
	ADC_UpdateDivider(numbersensor_prm,(word)divisionfactor_tmp); //   
	}

word CAL_CalculateDivider(word measuredata_prm,dword calibrvoltage_prm,dword divisordefault_tmp) //    
	{
	dword divisibledata_tmp=0; // 
	divisibledata_tmp=calibrvoltage_prm; // 
	divisibledata_tmp*=divisordefault_tmp;
	divisibledata_tmp/=(dword)measuredata_prm; //  
	return (word)divisibledata_tmp; //  
	}


void CAL_CalibrmeasCurrent(word measuredvaluesdata_prm) //    
	{
	dword resistancedata_tmp=0; // 
	resistancedata_tmp=(dword)measuredvaluesdata_prm*CALVALUE_RESISTANCE/CALMEASURE_CURRENT; //    
	if((resistancedata_tmp>CALMIN_RESISTANCE)&&(resistancedata_tmp<CALMAX_RESISTANCE)&&(resistancedata_tmp!=CALMEASURE_CURRENT)) //      
		{
		ADC_UpdateResistance(alter_cal.countercurrentcalibrate,resistancedata_tmp); //     
		}
	}

void CAL_LeftbuttonControl(void) //   Left
	{
	switch(indx_cal.calibrationswitch) //   /    Left
		{
		case FALSE:	switch(alter_cal.countercurrentcalibrate) //    
						{
						case 0: break; // 
						case 1 ... 2: if(alter_cal.counterpositioncursor>0) alter_cal.counterpositioncursor--; //          
								else alter_cal.counterpositioncursor=2; //    
								break;
						case 3 ... 4: if(alter_cal.counterpositioncursor>0) alter_cal.counterpositioncursor--; //          
								else alter_cal.counterpositioncursor=4; //    
						}
					break;
		case TRUE: switch(alter_cal.countervoltagecalibrate) //    
						{
						case 0: break; // 
						case 1 ... 2: if(alter_cal.counterpositioncursor>0) alter_cal.counterpositioncursor--; //         
								else alter_cal.counterpositioncursor=2; //    
						}
		}
	}

void CAL_RigtbuttonControl(void) //   Rigt
	{
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.countercurrentcalibrate) //    
						{
						case 0: break; // 
						case 1 ... 2: alter_cal.counterpositioncursor++; //       
								if(alter_cal.counterpositioncursor>2) alter_cal.counterpositioncursor=0; //      
								break;
						case 3 ... 4: alter_cal.counterpositioncursor++; //       
								if(alter_cal.counterpositioncursor>4) alter_cal.counterpositioncursor=0; //      
						}
					break;
		case TRUE: switch(alter_cal.countervoltagecalibrate) //   
						{
						case 0: break; // 
						case 1 ... 2: alter_cal.counterpositioncursor++; //      
								if(alter_cal.counterpositioncursor>2) alter_cal.counterpositioncursor=0; //     
						}
		}
	}

void CAL_UpbuttonControl(void) //   Up
	{
	word comparedata_tmp=0; // 
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.counterpositioncursor) //      
						{
						case 0: alter_cal.countercurrentcalibrate++; //    
								if(alter_cal.countercurrentcalibrate>4) alter_cal.countercurrentcalibrate=0; //    
								CAL_SettnumberBattery(); //   
								break;
						case 1: CAL_SettdataDefault(); //       
								break;
						case 2: switch(indx_cal.switchdataresults) //   /
									{
									case FALSE: indx_cal.switchdataresults=TRUE; //      
												break;
									case TRUE: indx_cal.switchdataresults=FALSE; //     
									}
								indx_cal.updatecalibrateline=TRUE; //    
								break;
						case 3: switch(alter_cal.countercurrentcalibrate) //    
									{
									case 0 ... 2: break; // 
									case 3: comparedata_tmp=OPRFIRST_DISCHARGE; //       1 
											if(comparedata_tmp>10) comparedata_tmp-=10; //   10   10 
											OPRFIRST_DISCHARGE=comparedata_tmp; //      1 
											break;
									case 4: comparedata_tmp=OPRSECOND_DISCHARGE; //       2
											if(comparedata_tmp>10) comparedata_tmp-=10; //   10   10
											OPRSECOND_DISCHARGE=comparedata_tmp; //      2
									}
								break;
						case 4: switch(alter_cal.countercurrentcalibrate) //     
									{
									case 0 ... 2: break; // 
									case 3: comparedata_tmp=OPRFIRST_DISCHARGE; //       1
											if(comparedata_tmp>1) comparedata_tmp--; //    1
											OPRFIRST_DISCHARGE=comparedata_tmp; //      1
											break;
									case 4: comparedata_tmp=OPRSECOND_DISCHARGE; //       2
											if(comparedata_tmp>1) comparedata_tmp--; //     1
											OPRSECOND_DISCHARGE=comparedata_tmp; //      2
									}
						}
					break;
		case TRUE: switch(alter_cal.counterpositioncursor) //    
						{
						case 0: alter_cal.countervoltagecalibrate++; //    
								if(alter_cal.countervoltagecalibrate>2) alter_cal.countervoltagecalibrate=0; //    
								CAL_SettnumberBattery(); //  
								break;
						case 1: CAL_SettdataDefault(); //     
								break;
						case 2: switch(indx_cal.switchdataresults) //   /
									{
									case FALSE: indx_cal.switchdataresults=TRUE; //      
												break;
									case TRUE: indx_cal.switchdataresults=FALSE; //     
									}
								indx_cal.updatecalibrateline=TRUE; //    
						}
		}
	}

void CAL_DownbuttonControl(void) //   Down
	{
	word comparedata_tmp=0; // 
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.counterpositioncursor) //      
						{
						case 0: if(alter_cal.countercurrentcalibrate>0) alter_cal.countercurrentcalibrate--; //     
								else alter_cal.countercurrentcalibrate=4; //    
								CAL_SettnumberBattery(); //  
								break;
						case 1: CAL_SettdataDefault(); //       
								break;
						case 2: switch(indx_cal.switchdataresults) //   /
									{
									case FALSE: indx_cal.switchdataresults=TRUE; //      
												break;
									case TRUE: indx_cal.switchdataresults=FALSE; //     
									}
								indx_cal.updatecalibrateline=TRUE; //    
								break;
						case 3: switch(alter_cal.countercurrentcalibrate) //    
									{
									case 0 ... 2: break; // 
									case 3: comparedata_tmp=OPRFIRST_DISCHARGE; //       1
											if(comparedata_tmp<245) comparedata_tmp+=10; //   10   245
											OPRFIRST_DISCHARGE=comparedata_tmp; //      1
											break;
									case 4: comparedata_tmp=OPRSECOND_DISCHARGE; //       2 
											if(comparedata_tmp<245) comparedata_tmp+=10; //   10   245 
											OPRSECOND_DISCHARGE=comparedata_tmp; //      2 
									}
								break;
						case 4: switch(alter_cal.countercurrentcalibrate) //     
									{
									case 0 ... 2: break; // 
									case 3: comparedata_tmp=OPRFIRST_DISCHARGE; //       1
											if(comparedata_tmp<254) comparedata_tmp++; //    254
											OPRFIRST_DISCHARGE=comparedata_tmp; //      1
											break;
									case 4: comparedata_tmp=OPRSECOND_DISCHARGE; //       2
											if(comparedata_tmp<254) comparedata_tmp++; //    254
											OPRSECOND_DISCHARGE=comparedata_tmp; //      2
									}
						}
					break;
		case TRUE: switch(alter_cal.counterpositioncursor) //      
						{
						case 0: if(alter_cal.countervoltagecalibrate>0) alter_cal.countervoltagecalibrate--; //     
								else alter_cal.countervoltagecalibrate=2; //    
								CAL_SettnumberBattery(); //  
								break;
						case 1: CAL_SettdataDefault(); //     
								break;
						case 2: switch(indx_cal.switchdataresults) //   /
									{
									case FALSE: indx_cal.switchdataresults=TRUE; //      
												break;
									case TRUE: indx_cal.switchdataresults=FALSE; //     
									}
								indx_cal.updatecalibrateline=TRUE; //    
						}
		}
	}

void CAL_EnterbuttonControl(void) //   Enter
	{
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.counterpositioncursor) //      
						{
						case 0: if(alter_cal.countercurrentcalibrate==0) //     
									{
									indx_cal.calibrationswitch=TRUE; //    
									indx_cal.updatecalibrateline=TRUE; //    
									}
								break;
						case 1: switch(alter_cal.countercurrentcalibrate) //     
									{
									case 0: break; //  
									case 1 ... 2: indx_cal.calibrationcurrent=TRUE; //     
									}
								break;
						case 2 ... 4: asm("nop"); // 
						}
					break;
		case TRUE: switch(alter_cal.counterpositioncursor) //       
						{
						case 0: if(alter_cal.countervoltagecalibrate==0) //      
									{
									indx_cal.calibrationswitch=FALSE; //     
									SYS_SwitchWorkmode(); //       
									}
								break;
						case 1: switch(alter_cal.countervoltagecalibrate) //     
									{
									case 0: break; // 
									case 1 ... 2: indx_cal.calibrationvoltage=TRUE; //     
									}
								break;
						case 2: asm("nop"); // 
						}
		}
	}

void CAL_ControlCalibrate(byte datacodecontrol_prm) //   
	{
	switch(datacodecontrol_prm) //  
		{
		case 1: CAL_LeftbuttonControl(); //  Left 
				break;
		case 2: CAL_RigtbuttonControl(); //  Rigt 
				break;
		case 3: CAL_UpbuttonControl(); //  Up 
				break;
		case 4: CAL_DownbuttonControl(); //  Down 
				break;
		case 5: CAL_EnterbuttonControl(); //  Enter 
		}
	}

void CAL_SettnumberBattery(void) //      
	{
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE:	switch(alter_cal.countercurrentcalibrate) //    
						{
						case 0: CAL_SettpermitControl(0); //   
								break; 
						case 1: CAL_SettpermitControl(1); //            1  
								if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1     
								break;
						case 2: CAL_SettpermitControl(2); //            2 
								if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2     
								break;
						case 3: CAL_SettpermitControl(3); //            1  
								if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1     
								break;
						case 4: CAL_SettpermitControl(4); //            2 
								if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2     
						}
					break;
		case TRUE: switch(alter_cal.countervoltagecalibrate) //    
						{
						case 0: CAL_SettpermitControl(0); //   
								break; 
						case 1: CAL_SettpermitControl(0); //       1  
								if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1
								break;
						case 2: CAL_SettpermitControl(0); //       2 
								if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2
						}
		}
	indx_cal.updatecalibrateline=TRUE; //    
	}

void CAL_SettdataDefault(void) //          
	{
	byte numbersensor_tmp=0; //  
	switch(indx_cal.calibrationswitch) //   / 
		{
		case FALSE: ADC_DefaultResistance(alter_cal.countercurrentcalibrate); //     
					break;
		case TRUE: numbersensor_tmp=OPR_ReadnumberSensor(indx_cal.numberbattery); //    
					ADC_DefaultDivider(numbersensor_tmp); //       
		}
	}

void CAL_SettpermitControl(byte numberpermission_prm) //   
	{
	switch(numberpermission_prm) //   
		{
		case 0: if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTDISCH); //     1   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTGRANT); //      1   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDISCH); //     2   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDGRANT); //      2   
				break;
		case 1: if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTDISCH); //     1   
				if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTGRANT)) SetBit(CALONOFF_PERMISSION,CALBYTE_FIRSTGRANT); //      1   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDISCH); //     2  
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDGRANT); //      2   
				break;
		case 2: if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTDISCH); //     1   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTGRANT); //      1   
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDISCH); //     2  
				if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_SECONDGRANT)) SetBit(CALONOFF_PERMISSION,CALBYTE_SECONDGRANT); //      2   
				break;
		case 3: if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTDISCH)) SetBit(CALONOFF_PERMISSION,CALBYTE_FIRSTDISCH); //     1  
				if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTGRANT)) SetBit(CALONOFF_PERMISSION,CALBYTE_FIRSTGRANT); //      1  
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDISCH); //     2  
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_SECONDGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_SECONDGRANT); //      2  
				break;
		case 4: if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTDISCH)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTDISCH); //     1  
				if(bit_is_set(CALONOFF_PORTCONTROL,CALCONTROL_FIRSTGRANT)) ClearBit(CALONOFF_PERMISSION,CALBYTE_FIRSTGRANT); //      1  
				if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_SECONDISCH)) SetBit(CALONOFF_PERMISSION,CALBYTE_SECONDISCH); //     2  
				if(bit_is_clear(CALONOFF_PORTCONTROL,CALCONTROL_SECONDGRANT)) SetBit(CALONOFF_PERMISSION,CALBYTE_SECONDGRANT); //      2  
		}
	}
















