/********************************************
* Calibrationmode.h
*    
* : 08.06.2022 10:23:50
* :  .
*********************************************/

#pragma once

#include "Main.h"                                            

#define CALONOFF_PERMISSION PORTC //   / 
#define CALBYTE_FIRSTDISCH PORTC5 //    1
#define CALBYTE_SECONDISCH PORTC6 //    2
#define CALBYTE_FIRSTGRANT PORTC4 //      1
#define CALBYTE_SECONDGRANT PORTC7 //      2
#define CALONOFF_PORTCONTROL PINC //   
#define CALCONTROL_FIRSTDISCH PINC5 //     1
#define CALCONTROL_SECONDISCH PINC6 //     2
#define CALCONTROL_FIRSTGRANT PINC4 //       1
#define CALCONTROL_SECONDGRANT PINC7 //       1
#define CALNIMHCD_DIVIDER 2000 //      Ni-Cd  Ni-Mh  
#define CALNIZN_DIVIDER 2167 //      Ni-Zn  
#define CALLITHIUM1_DIVIDER 4533 //      Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define CALLITHIUM2_DIVIDER 3767 //      Li-Fe  
#define CALLITHIUM3_DIVIDER 2933 //      Li-Ti  
#define CALSLA2V_DIVIDER 2600 //      Sla-2v  
#define CALSLA4V_DIVIDER 5500 //      Sla-4v  
#define CALSLA6V_DIVIDER 7500 //      Sla-6v  
#define CALSLA12V_DIVIDER 14500 //      Sla-12v  
#define CALLIFEPO4_DIVIDER 14500 //      LiFePo4  
#define CAL2NIMH_DIVIDER 3767 //        2- Ni-Mh  
#define CAL3NIMH_DIVIDER 5500 //        3- Ni-Mh  
#define CAL4NIMH_DIVIDER 7500 //        4- Ni-Mh 
#define CAL5NIMH_DIVIDER 8833 //        5- Ni-Mh 
#define CAL6NIMH_DIVIDER 10500 //        6- Ni-Mh 
#define CAL7NIMH_DIVIDER 12500 //        7- Ni-Mh 
#define CAL8NIMH_DIVIDER 14500 //        8- Ni-Mh 
#define CALNIMHCD_VOLTAGE 1500 //    Ni-Cd  Ni-Mh  
#define CALNIZN_VOLTAGE 1700 //    Ni-Zn  
#define CALLITHIUM1_VOLTAGE 4200 //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define CALLITHIUM2_VOLTAGE 3600 //    Li-Fe  
#define CALLITHIUM3_VOLTAGE 2800 //    Li-Ti  
#define CALSLA2V_VOLTAGE 2400 //    Sla-2v 
#define CALSLA4V_VOLTAGE 4500 //    Sla-4v 
#define CALSLA6V_VOLTAGE 6000 //    Sla-6v 
#define CALSLA12V_VOLTAGE 12000 //    Sla-12v 
#define CALLIFEPO4_VOLTAGE 12000 //    LiFePo4 
#define CAL2NIMH_VOLTAGE 3000 //      2- Ni-Mh  
#define CAL3NIMH_VOLTAGE 4500 //      3- Ni-Mh  
#define CAL4NIMH_VOLTAGE 6000 //      4- Ni-Mh  
#define CAL5NIMH_VOLTAGE 7500 //      5- Ni-Mh  
#define CAL6NIMH_VOLTAGE 9000 //      6- Ni-Mh 
#define CAL7NIMH_VOLTAGE 10500 //      7- Ni-Mh 
#define CAL8NIMH_VOLTAGE 12000 //      8- Ni-Mh 
#define CALMEASURE_CURRENT 1250 //   
#define CALVALUE_RESISTANCE 4700 //     0,47  
#define CALMIN_RESISTANCE 4230 //     0,423  
#define CALMAX_RESISTANCE 5170 //     0,517  
#define CALMINRANGE_NIMHCD 1350 //     Ni-Cd  Ni-Mh  
#define CALMAXRANGE_NIMHCD 1650 //     Ni-Cd  Ni-Mh  
#define CALMINRANGE_NIZN 1530 //     Ni-Zn 
#define CALMAXRANGE_NIZN 1870 //     Ni-Zn 
#define CALMINRANGE_LITHIUM1 3780 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define CALMAXRANGE_LITHIUM1 4620 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define CALMINRANGE_LITHIUM2 3240 //     Li-Fe  
#define CALMAXRANGE_LITHIUM2 3960 //     Li-Fe  
#define CALMINRANGE_LITHIUM3 2520 //     Li-Ti 
#define CALMAXRANGE_LITHIUM3 3080 //     Li-Ti  
#define CALMINRANGE_SLA2V 2160 //     Sla-2v 
#define CALMAXRANGE_SLA2V 2640 //     Sla-2v 
#define CALMINRANGE_SLA4V 4050 //     Sla-4v 
#define CALMAXRANGE_SLA4V 4950 //     Sla-4v 
#define CALMINRANGE_SLA6V 5400 //     Sla-6v 
#define CALMAXRANGE_SLA6V 6600 //     Sla-6v 
#define CALMINRANGE_SLA12V 10800 //     Sla-12v 
#define CALMAXRANGE_SLA12V 13200 //     Sla-12v 
#define CALMINRANGE_LIFEPO4 10800 //     LiFePo4 
#define CALMAXRANGE_LIFEPO4 13200 //     LiFePo4 

typedef struct
	{
	bit updatecalibrateline:1; //   
	bit numberbattery:1; //     
	bit calibrationvoltage:1; //   
	bit calibrationcurrent:1; //    
	bit calibrationswitch:1; //    
	bit switchdataresults:1; //  /  
	}bit_cal;

typedef struct
	{
	byte countercurrentcalibrate; //     
	byte countervoltagecalibrate; //     
	byte counterpositioncursor; //   
	}var_cal;

void CAL_MainMode(bit indxupdateline_prm); //   
void CAL_CalibrmeasVoltage(byte numbersensor_prm,word measuredvaluesdata_prm); //   
void CAL_CalibrmeasCurrent(word measuredvaluesdata_prm); //   
void CAL_ControlCalibrate(byte datacodecontrol_prm); //   
void CAL_SettnumberBattery(void); //       
void CAL_SettdataDefault(void); //          
void CAL_LeftbuttonControl(void); //    Left 
void CAL_RigtbuttonControl(void); //    Rigt 
void CAL_UpbuttonControl(void); //    Up 
void CAL_DownbuttonControl(void); //    Down 
void CAL_EnterbuttonControl(void); //    Enter 
void CAL_UpdateOutline(void); //     
void CAL_UpdateOutdata(void); //    
void CAL_SettpermitControl(byte numberpermission_prm); //   
word CAL_CalculateDivider(word measuredata_prm,dword calibrvoltage_prm,dword divisordefault_tmp); //    





