/*******************************************************
* Lcdworkunit.c
*     LCD  WH1601L
* : 10.06.2022 10:54:01
* :  .
*******************************************************/

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/sfr_defs.h>
#include "Lcdworkunit.h"
#include "Systemcontrol.h"

void LCD_CommonFunction(byte commondata_prm) //      LCD  4- 
	{
	byte outputdata_tmp=0; // 
	outputdata_tmp=LCD_SwapNibbles(commondata_prm); //      
	LCD_SetbyteData(outputdata_tmp); //      LCD
	_delay_loop_2(8); // 2 
	SetBit(LCDOUT_DATA,LCDOUT_EN); //     LCD
	_delay_loop_2(20); // 5 
	ClearBit(LCDOUT_DATA,LCDOUT_EN); // 
	outputdata_tmp=commondata_prm; //      
	LCD_SetbyteData(outputdata_tmp); //      LCD
	_delay_loop_2(8); // 2 
	SetBit(LCDOUT_DATA,LCDOUT_EN); //     LCD
	_delay_loop_2(20); // 5 
	ClearBit(LCDOUT_DATA,LCDOUT_EN); // 
	_delay_loop_2(200); // 50 
	}

void LCD_SetbyteData(byte outputdata_prm) //       LCD
	{
	byte settbytedata_tmp=0; // 
	settbytedata_tmp=outputdata_prm&1; //  0
	if((settbytedata_tmp>0)&&(bit_is_clear(LCDIN_DATA,LCDIN_BYTE0))) SetBit(LCDOUT_DATA,LCDOUT_BYTE0); //  0  
	else if((settbytedata_tmp==0)&&(bit_is_set(LCDIN_DATA,LCDIN_BYTE0))) ClearBit(LCDOUT_DATA,LCDOUT_BYTE0); //  0  
	settbytedata_tmp=outputdata_prm&2; //  1
	if((settbytedata_tmp>0)&&(bit_is_clear(LCDIN_DATA,LCDIN_BYTE1))) SetBit(LCDOUT_DATA,LCDOUT_BYTE1); //  1  
	else if((settbytedata_tmp==0)&&(bit_is_set(LCDIN_DATA,LCDIN_BYTE1))) ClearBit(LCDOUT_DATA,LCDOUT_BYTE1); //  1  
	settbytedata_tmp=outputdata_prm&4; //  2
	if((settbytedata_tmp>0)&&(bit_is_clear(LCDIN_DATA,LCDIN_BYTE2))) SetBit(LCDOUT_DATA,LCDOUT_BYTE2); //  2  
	else if((settbytedata_tmp==0)&&(bit_is_set(LCDIN_DATA,LCDIN_BYTE2))) ClearBit(LCDOUT_DATA,LCDOUT_BYTE2); //  2  
	settbytedata_tmp=outputdata_prm&8; //  3
	if((settbytedata_tmp>0)&&(bit_is_clear(LCDIN_DATA,LCDIN_BYTE3))) SetBit(LCDOUT_DATA,LCDOUT_BYTE3); //  3  
	else if((settbytedata_tmp==0)&&(bit_is_set(LCDIN_DATA,LCDIN_BYTE3))) ClearBit(LCDOUT_DATA,LCDOUT_BYTE3); //  3  
	}

void LCD_WaitDevice(void) //   LCD
	{
	byte numberdata_tmp=0; // 
	LCDOUT_DIRECT&=240; //  4-    
	LCDOUT_DATA|=15; //   
	SetBit(LCDOUT_DATA,LCDOUT_RW); //    LCD
	_delay_loop_2(8); // 2 
	ClearBit(LCDOUT_DATA,LCDOUT_RS); //    LCD
	do //   LCD
		{
		_delay_loop_2(8); // 2 
		SetBit(LCDOUT_DATA,LCDOUT_EN);	//  
		_delay_loop_2(20); // 5 
		numberdata_tmp=LCDIN_DATA&15; //      LCD
		ClearBit(LCDOUT_DATA,LCDOUT_EN); //  
		numberdata_tmp=LCD_SwapNibbles(numberdata_tmp); //   
		_delay_loop_2(8); // 2 
		SetBit(LCDOUT_DATA,LCDOUT_EN); //  
		_delay_loop_2(20); // 5 
		numberdata_tmp|=LCDIN_DATA&15; //      LCD
		ClearBit(LCDOUT_DATA,LCDOUT_EN); //  
		}
	while((numberdata_tmp&(1<<WAIT_FLAG))!=0); //   LCD 
	ClearBit(LCDOUT_DATA,LCDOUT_RW); //    LCD
	LCDOUT_DIRECT|=15; //   
	_delay_loop_2(200); // 50 
	}

void LCD_WriteCommon(byte commondata_prm) //    LCD
	{
	LCD_WaitDevice(); //  LCD
	ClearBit(LCDOUT_DATA,LCDOUT_RS); //   
	_delay_loop_2(8); // 2 
	LCD_CommonFunction(commondata_prm); //   
	}

void LCD_WriteData(byte outputdata_prm) //     LCD
	{
	LCD_WaitDevice(); //  LCD
	SetBit(LCDOUT_DATA,LCDOUT_RS); //   
	_delay_loop_2(8); // 2 
	LCD_CommonFunction(outputdata_prm); //  
	}

void LCD_InitializeDevice(void) //  LCD
	{
	SYS_TimeWaiting(60); // 60  
	LCD_WriteCommon(40); //  4-  
	_delay_loop_2(200); // 50 
	LCD_WriteCommon(12);  //   LCD,   
	_delay_loop_2(200); // 50 
	LCD_WriteCommon(1); // 
	SYS_TimeWaiting(3); // 3 
	}

void LCD_SetpositionCursor(byte spotpositioncursor_prm) //   
	{
	byte cursorposity_tmp=0; // 
	if(spotpositioncursor_prm>7) cursorposity_tmp=spotpositioncursor_prm+56; //     8
	else cursorposity_tmp=spotpositioncursor_prm; //     8
	LCD_WriteCommon(128+cursorposity_tmp); //  
	SYS_TimeWaiting(3); // 3 
	}

byte LCD_SwapNibbles(byte numberdata_prm) //     
	{
	asm volatile("swap %0":"=r"(numberdata_prm):"0"(numberdata_prm)); //   
	return numberdata_prm; //  
	}





