/***********************************************************
* Lifebattery.c
*     Li-Fe 
* : 02.03.2023 12:02:53
* :  .
*************************************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Lifebattery.h"
#include "Operatingmode.h"
#include "Liferrumgroup.h"

EEMEM static byte Lfe_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Lfe_CurrentStatusprocess[2]={0,0}; //       
EEMEM static byte Lfe_AlgorithmEmergency[2]={0,0}; //      
EEMEM static byte Lfe_CurrentstatusEmergency[2]={0,0}; //      


word LFE_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Li-Po 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(LFG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						LFG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LFENUMBER_BATTERY); //    1
						}
					settingcurrentbattery_tmp=LFG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(LFG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						LFG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LFENUMBER_BATTERY); //    2
						}
					settingcurrentbattery_tmp=LFG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //   
	}

void LFE_WriteDeferred(bit indxnumberbattery_prm) //     Li-Fe 
	{
	byte datadeferred_tmp=0; // 
	datadeferred_tmp=LFG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lfe_CountcycleAlgorithm[indxnumberbattery_prm],datadeferred_tmp); //     
	datadeferred_tmp=LFG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lfe_CurrentStatusprocess[indxnumberbattery_prm],datadeferred_tmp); //   
	}

void LFE_ReadDeferred(bit indxnumberbattery_prm) //     Li-Fe 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Lfe_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Lfe_CurrentStatusprocess[indxnumberbattery_prm]); //   
	LFG_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp); //       
	}

void LFE_WriteEmergency(bit indxnumberbattery_prm) //      Li-Fe  
	{
	byte dataemergency_tmp=0; // 
	dataemergency_tmp=LFG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lfe_AlgorithmEmergency[indxnumberbattery_prm],dataemergency_tmp); //     
	dataemergency_tmp=LFG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lfe_CurrentstatusEmergency[indxnumberbattery_prm],dataemergency_tmp); //   
	}

void LFE_ReadEmergency(bit indxnumberbattery_prm) //      Li-Fe 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Lfe_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Lfe_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	LFG_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp); //       
	}










