/**************************************************************
* Liferrumgroup.h
*     Li-Fe, LiFePo4 
* : 17.06.2022 21:54:38
* :  .
***************************************************************/

#pragma once

#include "Main.h"

#define LFGMINBATT_VOLTAGE 2800 //        
#define LFGMINFINAL_VOLTAGE 2400 //      
#define LFGMAXBATT_VOLTAGE 3500 //        
#define LFGMAXFINAL_VOLTAGE 3600 //      
#define LFGMINLOAD_VOLTAGE 2300 //   
#define LFGMAXLOAD_VOLTAGE 3650 //   
#define LFGMAXLIMIT_CURRENT 2300 //   / 
#define LFGMINLIMIT_CURRENT 10 //   / 
#define LFGMAXPOWER_CHARGE 8000 //     
#define LFGMAXPOWER_DISCHARGE 10000 //    

typedef struct
	{
	bit updatingfirstdata:1; //      1 
	bit updatingseconddata:1; //      2 
	}bit_lfg;

typedef struct
	{
	byte countergeneralusage[2]; //   
	byte countercyclesalgorithm[2]; //    / 
	byte currentstatusprocess[2]; //     1[0]  2[1]
	byte currentmethodbattery[2]; //     1[0]  2[1] 
	word numbercellsbattery[2]; //     1[0]  2[1] 
	word limitfirstparameters[4]; //   ,     1 
	word limitsecondparameters[4]; //   ,     2 
	}var_lfg;

void LFG_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm); //   
void LFG_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LFG_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LFG_ResetVariables(bit indxnumberbattery_prm); //  
void LFG_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm); //       
bit LFG_ReadindxUpdatig(bit indxnumberbattery_prm); //     
byte LFG_ReadcurrentAlgorithm(bit indxnumberbattery_prm); //       
byte LFG_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm); //   
word LFG_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word LFG_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word LFG_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word LFG_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LFG_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LFG_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //   
















