/************************************************************
* Limnbattery.c
*     Li-Mn 
* : 09.12.2022 21:29:04
* :  .
*************************************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Limnbattery.h"
#include "Operatingmode.h"
#include "Lithiumgroup.h"

EEMEM static byte Lmn_CountcycleAlgorithm[2]={0,0}; //     Li-Po 
EEMEM static byte Lmn_CurrentStatusprocess[2]={0,0}; //     Li-Po  
EEMEM static byte Lmn_AlgorithmEmergency[2]={0,0}; //     Li-Po 
EEMEM static byte Lmn_CurrentstatusEmergency[2]={0,0}; //     Li-Po  

word LMN_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Li-Mn 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(LGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						LGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LMNNUMBER_BATTERY); //    1
						}
					settingcurrentbattery_tmp=LGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(LGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						LGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LMNNUMBER_BATTERY); //    2
						}
					settingcurrentbattery_tmp=LGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //   
	}

void LMN_WritDeferred(bit indxnumberbattery_prm) //     Li-Mn 
	{
	byte datadeferred_tmp=0; // 
	datadeferred_tmp=LGR_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lmn_CountcycleAlgorithm[indxnumberbattery_prm],datadeferred_tmp); //    
	datadeferred_tmp=LGR_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lmn_CurrentStatusprocess[indxnumberbattery_prm],datadeferred_tmp); //  
	}

void LMN_ReadDeferred(bit indxnumberbattery_prm) //     Li-Mn 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Lmn_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Lmn_CurrentStatusprocess[indxnumberbattery_prm]); //   
	LGR_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp); //       
	}

void LMN_WritEmergency(bit indxnumberbattery_prm) //     Li-Mn  
	{
	byte dataemergency_tmp=0; // 
	dataemergency_tmp=LGR_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lmn_AlgorithmEmergency[indxnumberbattery_prm],dataemergency_tmp); //    
	dataemergency_tmp=LGR_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lmn_CurrentstatusEmergency[indxnumberbattery_prm],dataemergency_tmp); //  
	}

void LMN_ReadEmergency(bit indxnumberbattery_prm) //      Li-Mn 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Lmn_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Lmn_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	LGR_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp); //        
	}















