/************************************************************
* Lionbattery.c
*     Li-Ion 
* : 29.11.2022 20:31:21
* :  .
*************************************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Lionbattery.h"
#include "Operatingmode.h"
#include "Lithiumgroup.h"

EEMEM static byte Lio_CountcycleAlgorithm[2]={0,0}; //     Li-Ion 
EEMEM static byte Lio_CurrentStatusprocess[2]={0,0}; //     Li-Ion  
EEMEM static byte Lio_AlgorithmEmergency[2]={0,0}; //     Li-Ion 
EEMEM static byte Lio_CurrentstatusEmergency[2]={0,0}; //     Li-Ion 

word LIO_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Li-Ion 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(LGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						LGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LIONUMBER_BATTERY); //    1
						}
					settingcurrentbattery_tmp=LGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(LGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						LGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,LIONUMBER_BATTERY); //    2
						}
					settingcurrentbattery_tmp=LGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //   
	}

void LIO_WriteDeferred(bit indxnumberbattery_prm) //     Li-Ion 
	{
	byte datadeferred_tmp=0; // 
	datadeferred_tmp=LGR_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lio_CountcycleAlgorithm[indxnumberbattery_prm],datadeferred_tmp); //    
	datadeferred_tmp=LGR_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lio_CurrentStatusprocess[indxnumberbattery_prm],datadeferred_tmp); //  
	}

void LIO_ReadDeferred(bit indxnumberbattery_prm) //     Li-Ion 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Lio_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Lio_CurrentStatusprocess[indxnumberbattery_prm]); //   
	LGR_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp); //       
	}

void LIO_WriteEmergency(bit indxnumberbattery_prm) //     Li-Ion 
	{
	byte dataemergency_tmp=0; // 
	dataemergency_tmp=LGR_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Lio_AlgorithmEmergency[indxnumberbattery_prm],dataemergency_tmp); //    
	dataemergency_tmp=LGR_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Lio_CurrentstatusEmergency[indxnumberbattery_prm],dataemergency_tmp); //  
	}

void LIO_ReadEmergency(bit indxnumberbattery_prm) //     Li-Ion  
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Lio_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Lio_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	LGR_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp); //        
	}







