/***********************************************************************************************
* Lithiumgroup.h
*     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
* : 08.12.2022 16:55:26
* :  .
************************************************************************************************/

#pragma once

#include "Main.h"

#define LGRMINBATT_VOLTAGE 3300 //        
#define LGRMINFINAL_VOLTAGE 3000 //     
#define LGRMAXBATT_VOLTAGE 4150 //        
#define LGRMAXFINAL_VOLTAGE 4200 //     
#define LGRMINLOAD_VOLTAGE 2800 //   
#define LGRMAXLOAD_VOLTAGE 4300 //   
#define LGRMAXLIMIT_CURRENT 2300 //   /
#define LGRMINLIMIT_CURRENT 10 //   /
#define LGRMAXPOWER_CHARGE 8000 //    
#define LGRMAXPOWER_DISCHARGE 10000 //    

typedef struct
	{
	bit updatingfirstdata:1; //     1
	bit updatingseconddata:1; //     2
	}bit_lgr;

typedef struct
	{
	byte countergeneralusage[2]; //  
	byte countercyclesalgorithm[2]; //   /  
	byte currentstatusprocess[2]; //    1[0]  2[1] 
	byte currentmethodbattery[2]; //    1[0]  2[1] 
	word numbercellsbattery[2]; //     1[0]  2[1] 
	word limitfirstparameters[4]; //   ,     1 
	word limitsecondparameters[4]; //   ,     2 
	}var_lgr;

void LGR_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm); //   
void LGR_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LGR_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LGR_ResetVariables(bit indxnumberbattery_prm); //   
void LGR_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm); //       
bit LGR_ReadindxUpdatig(bit indxnumberbattery_prm); //      
byte LGR_ReadcurrentAlgorithm(bit indxnumberbattery_prm); //       
byte LGR_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm); //   
word LGR_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //    
word LGR_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word LGR_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word LGR_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LGR_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LGR_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //  














