/***********************************************************
* Litibattery.c
*     Li-Ti 
* : 06.12.2022 10:37:15
* :  .
************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Litibattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_lti indx_lti={0,0,0,0}; // 
var_lti alter_lti={{0,0},{0,0},{0,0},{0,0},{0,0,0,0},{0,0,0,0}}; // 

PROGMEM const byte Lti_DischargeBattery[3][2][4]={{{5,0,64,0}, //   : I<=0,2 U>=1900  <40*
											{10,1,0,100}}, // : I=0,1C U>=1800   I<0.01C  10   
											{{3,0,64,0}, //   : I<=0,33 U>=1900  <40*
											{10,1,0,100}}, // : I=0,1C U>=1800   I<0.01C  10   
											{{2,0,64,0}, //   : I<=0,5 U>=1900  <40*
											{5,1,0,100}}}; // : I=0,2C U>=1800   I<0.01C  10   
PROGMEM const byte Lti_ChargeBattery[3][2][4]={{{5,0,64,0}, //    1: I<=0,2C U<=2800  <40*C
											{10,1,0,100}}, // : I<=0,1C U<=2850   I<0,01C  10   
											{{3,0,64,0}, //    1: I<=0,33C U<=2800  <40*C
											{10,1,0,100}}, // : I<=0,1C U<=2850   I<0,01C  10   
											{{1,0,64,0}, //    1: I<=1C U<=2800  <40*C
											{5,1,0,100}}}; // : I<=0,2C U<=2850   I<0,01C  10   

EEMEM static byte Lti_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Lti_CurrentStatusprocess[2]={0,0}; //      
EEMEM static byte Lti_AlgorithmEmergency[2]={0,0}; //      
EEMEM static byte Lti_CurrentstatusEmergency[2]={0,0}; //      

word LTI_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //   Li-Ti 
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(indx_lti.updatingfirstmethod==FALSE) //      1 
						{
						alter_lti.currentmethodbattery[indxnumberbattery_prm]=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						indx_lti.updatingfirstmethod=TRUE; //      1
						}
					if(indx_lti.updatingfirstdata==FALSE) //     1 
						{
						indx_lti.updatingfirstdata=TRUE; //    
						LTI_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=LTI_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     /
					break;
		case TRUE: if(indx_lti.updatingsecondmethod==FALSE) //      2 
						{
						alter_lti.currentmethodbattery[indxnumberbattery_prm]=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						indx_lti.updatingsecondmethod=TRUE; //      2
						}
					if(indx_lti.updatingseconddata==FALSE) //     2 
						{
						indx_lti.updatingseconddata=TRUE; //    
						LTI_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=LTI_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     /
		}
	return settingcurrentbattery_tmp; //  
	}

void LTI_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm) //    Li-Ti 
	{
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: LTI_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
					break;
		case TRUE: LTI_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
		}
	}

word LTI_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //     
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: settingcurrentbattery_tmp=LTI_ChargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=LTI_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    /
	}

void LTI_ResetVariables(bit indxnumberbattery_prm) //  
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: while(counterindxarray_tmp<4) //     1
						{
						alter_lti.limitfirstparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_lti.updatingfirstdata==TRUE) indx_lti.updatingfirstdata=FALSE; //     
					if(indx_lti.updatingfirstmethod==TRUE) indx_lti.updatingfirstmethod=FALSE; //    
					break;
		case TRUE: while(counterindxarray_tmp<4) //     2
						{
						alter_lti.limitsecondparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_lti.updatingseconddata==TRUE) indx_lti.updatingseconddata=FALSE; //     
					if(indx_lti.updatingsecondmethod==TRUE) indx_lti.updatingsecondmethod=FALSE; //    
		}
	alter_lti.countergeneralusage[indxnumberbattery_prm]=0; //   
	alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   / 
	alter_lti.currentstatusprocess[indxnumberbattery_prm]=0; //  
	alter_lti.currentmethodbattery[indxnumberbattery_prm]=0; //   
	}

void LTI_WriteDeferred(bit indxnumberbattery_prm) //     Li-Ti 
	{
	eeprom_write_byte(&Lti_CountcycleAlgorithm[indxnumberbattery_prm],alter_lti.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Lti_CurrentStatusprocess[indxnumberbattery_prm],alter_lti.currentstatusprocess[indxnumberbattery_prm]); //   
	}

void LTI_ReadDeferred(bit indxnumberbattery_prm) //     Li-Ti  
	{
	alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Lti_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	alter_lti.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Lti_CurrentStatusprocess[indxnumberbattery_prm]); //   
	}

void LTI_WriteEmergency(bit indxnumberbattery_prm) //     Li-Ti  
	{
	eeprom_write_byte(&Lti_AlgorithmEmergency[indxnumberbattery_prm],alter_lti.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Lti_CurrentstatusEmergency[indxnumberbattery_prm],alter_lti.currentstatusprocess[indxnumberbattery_prm]); //   
	}

void LTI_ReadEmergency(bit indxnumberbattery_prm) //     Li-Ti  
	{
	alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Lti_AlgorithmEmergency[indxnumberbattery_prm]); //    
	alter_lti.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Lti_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	}

void LTI_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //    
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][0]); //      1 
					alter_lti.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_lti.limitfirstparameters[0]>LTIMAXLIMIT_CURRENT) alter_lti.limitfirstparameters[0]=LTIMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_lti.limitfirstparameters[1]=LTIMAXBATT_VOLTAGE; //           
					else alter_lti.limitfirstparameters[1]=LTIMAXFINAL_VOLTAGE; //           
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_lti.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lti.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_lti.limitfirstparameters[3]<LTIMINLIMIT_CURRENT) alter_lti.limitfirstparameters[3]=LTIMINLIMIT_CURRENT; //    10  
						}
					else alter_lti.limitfirstparameters[3]=algoritmdata_tmp; //   
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][0]); //      2 
					alter_lti.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_lti.limitsecondparameters[0]>LTIMAXLIMIT_CURRENT) alter_lti.limitsecondparameters[0]=LTIMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_lti.limitsecondparameters[1]=LTIMAXBATT_VOLTAGE; //           
					else alter_lti.limitsecondparameters[1]=LTIMAXFINAL_VOLTAGE; //           
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_lti.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Lti_ChargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lti.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_lti.limitsecondparameters[3]<LTIMINLIMIT_CURRENT) alter_lti.limitsecondparameters[3]=LTIMINLIMIT_CURRENT; //    10  
						}
					else alter_lti.limitsecondparameters[3]=algoritmdata_tmp; //   
		}
	}

void LTI_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_lti.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_lti.limitfirstparameters[0]>LTIMAXLIMIT_CURRENT) alter_lti.limitfirstparameters[0]=LTIMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_lti.limitfirstparameters[1]=LTIMINBATT_VOLTAGE; //           1900 
					else alter_lti.limitfirstparameters[1]=LTIMINFINAL_VOLTAGE; //          1800 
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_lti.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lti.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_lti.limitfirstparameters[3]<LTIMINLIMIT_CURRENT) alter_lti.limitfirstparameters[3]=LTIMINLIMIT_CURRENT; //    10  
						}
					else alter_lti.limitfirstparameters[3]=algoritmdata_tmp; //  
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_lti.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_lti.limitsecondparameters[0]>LTIMAXLIMIT_CURRENT) alter_lti.limitsecondparameters[0]=LTIMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_lti.limitsecondparameters[1]=LTIMINBATT_VOLTAGE; //           1900 
					else alter_lti.limitsecondparameters[1]=LTIMINFINAL_VOLTAGE; //          1800 
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_lti.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Lti_DischargeBattery[alter_lti.currentmethodbattery[indxnumberbattery_prm]][alter_lti.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lti.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    /
						if(alter_lti.limitsecondparameters[3]<LTIMINLIMIT_CURRENT) alter_lti.limitsecondparameters[3]=LTIMINLIMIT_CURRENT; //    10  
						}
					else alter_lti.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word LTI_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	word intresistancebattery_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_lti.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0:	intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     
								switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0: limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //       
											break;
									case 1: if((intresistancebattery_tmp<300)&&(measuredtemperature_prm<alter_lti.limitfirstparameters[2])) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]*3/2; //    1,5           0,3     40*
											else limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //           0,3      40*  
											break;
									case 2: if(measuredtemperature_prm>=alter_lti.limitfirstparameters[2]) //   40*      
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/3; //   3       0,3  
												else limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/4; //   4      0,3     
												}
											else //    40*   
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //         0,3  
												else limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/2; //   2      0,3     
												}
									}
								limitvoltageparameters_tmp=alter_lti.limitfirstparameters[1]; //       
								settingcurrentbattery_tmp=LTI_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=2) alter_lti.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								if(measuredvoltagebattery_prm>=alter_lti.limitfirstparameters[1]) //         
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_lti.updatingfirstdata=FALSE; //    
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<LTIMINFINAL_VOLTAGE)) //   5     1  
									{
									settingcurrentbattery_tmp=0; //         
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_lti.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_lti.limitfirstparameters[1]; //     
								settingcurrentbattery_tmp=LTI_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=3) alter_lti.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								if((measuredcurrentbattery_prm<=alter_lti.limitfirstparameters[3])&&(measuredvoltagebattery_prm>=alter_lti.limitfirstparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          1
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_lti.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE: switch(alter_lti.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     
								switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0: limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //       
											break;
									case 1: if((intresistancebattery_tmp<300)&&(measuredtemperature_prm<alter_lti.limitsecondparameters[2])) limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]*3/2; //    1,5           0,3     40*
											else limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //           0,3      40*  
											break;
									case 2: if(measuredtemperature_prm>=alter_lti.limitsecondparameters[2]) //   40*     
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/3; //   3       0,3 
												else limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/4; //   4      0,3    
												}
											else //    40*   
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]/2; //   2      0,3    
												}
									}
								limitvoltageparameters_tmp=alter_lti.limitsecondparameters[1]; //        
								settingcurrentbattery_tmp=LTI_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=2) alter_lti.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								if(measuredvoltagebattery_prm>=alter_lti.limitsecondparameters[1]) //        
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_lti.updatingseconddata=FALSE; //    
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<LTIMINFINAL_VOLTAGE)) //   5      
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_lti.updatingseconddata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_lti.limitsecondparameters[1]; //     
								settingcurrentbattery_tmp=LTI_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=3) alter_lti.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								if((measuredcurrentbattery_prm<=alter_lti.limitsecondparameters[3])&&(measuredvoltagebattery_prm>=alter_lti.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_lti.updatingseconddata=FALSE; //    
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word LTI_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0; 
	word intresistancebattery_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_lti.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     
								switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //         
											break;
									case 2: if(measuredtemperature_prm>=alter_lti.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]/2; //    2     40*     
											else //E    40*   
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]*2/3; //    1,5      0,3   
												}
									}
								limitvoltageparameters_tmp=alter_lti.limitfirstparameters[1]; //         
								settingcurrentbattery_tmp=LTI_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=6) alter_lti.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								if(measuredvoltagebattery_prm<=alter_lti.limitfirstparameters[1]) //          
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_lti.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lti.limitfirstparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_lti.limitfirstparameters[1]; //      
								settingcurrentbattery_tmp=LTI_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=7) alter_lti.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								if((measuredcurrentbattery_prm<=alter_lti.limitfirstparameters[3])&&(measuredvoltagebattery_prm<=alter_lti.limitfirstparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          1
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_lti.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE: switch(alter_lti.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     
								switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //         
											break;
									case 2: if(measuredtemperature_prm>=alter_lti.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]/2; //    2     40*     
											else //E    40*   
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]*2/3; //    1,5      0,3   
												}
									}
								limitvoltageparameters_tmp=alter_lti.limitsecondparameters[1]; //      2    
								settingcurrentbattery_tmp=LTI_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=6) alter_lti.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								if(measuredvoltagebattery_prm<=alter_lti.limitsecondparameters[1]) //   2        
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_lti.updatingseconddata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lti.limitsecondparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_lti.limitsecondparameters[1]; //      
								settingcurrentbattery_tmp=LTI_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lti.currentstatusprocess[indxnumberbattery_prm]!=7) alter_lti.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								if((measuredcurrentbattery_prm<=alter_lti.limitsecondparameters[3])&&(measuredvoltagebattery_prm<=alter_lti.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lti.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_lti.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_lti.updatingseconddata=FALSE; //    
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word LTI_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=LTI_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm<LTIMAXLOAD_VOLTAGE)&&(currentvaluepower_tmp<LTIMAXPOWER_CHARGE)) //         
		{
		switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm>limitvoltageparameters_prm)||(measvoltageloadedbattery_prm>=LTIMAXLOAD_VOLTAGE)||(currentvaluepower_tmp>LTIMAXPOWER_CHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //               
	else asm("nop"); //  
	return settingcurrentbattery_tmp; //   
	}

word LTI_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=LTI_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm>limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm>LTIMINLOAD_VOLTAGE)&&(currentvaluepower_tmp<LTIMAXPOWER_DISCHARGE)) //          
		{
		switch(alter_lti.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_lti.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else //   
		{
		if((limitvoltageparameters_prm==LTIMINFINAL_VOLTAGE)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //        1800 
		else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm<limitvoltageparameters_prm)||(measvoltageloadedbattery_prm<=LTIMINLOAD_VOLTAGE)||(currentvaluepower_tmp>LTIMAXPOWER_DISCHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //            
		else asm("nop"); //  
		}
	return settingcurrentbattery_tmp; //   
	}

byte LTI_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm) //  
	{
	byte currentparameters_tmp=0; // 
	switch(indxparameters_prm) //  
		{
		case FALSE: currentparameters_tmp=alter_lti.currentstatusprocess[indxnumberbattery_prm]; //   
					break;
		case TRUE: currentparameters_tmp=LTINUMBER_BATTERY; //     
		}
	return currentparameters_tmp; //  
	}

word LTI_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm) //     
	{
	dword currentvaluepower_tmp=0; // 
	currentvaluepower_tmp=(dword)measuredcurrentbattery_prm*(dword)measuredvoltagebattery_prm/1000; //  
	return (word)currentvaluepower_tmp; //  
	}






















