/**************************************************************
* Litibattery.h
*     Li-Ti 
* : 06.12.2022 10:36:48
* :  .
***************************************************************/

#pragma once

#include "Main.h"

#define LTIMINBATT_VOLTAGE 1900 //       
#define LTIMINFINAL_VOLTAGE 1800 //     
#define LTIMAXBATT_VOLTAGE 2800 //       
#define LTIMAXFINAL_VOLTAGE 2850 //     
#define LTIMINLOAD_VOLTAGE 1700 //   
#define LTIMAXLOAD_VOLTAGE 2950 //   
#define LTIMAXLIMIT_CURRENT 2300 //   /
#define LTIMINLIMIT_CURRENT 10 //   /
#define LTINUMBER_BATTERY 1 //   
#define LTIMAXPOWER_CHARGE 8000 //    
#define LTIMAXPOWER_DISCHARGE 10000 //    

typedef struct
	{
	bit updatingfirstdata:1; //      1
	bit updatingseconddata:1; //      2
	bit updatingfirstmethod:1; //     1
	bit updatingsecondmethod:1; //     2
	}bit_lti;

typedef struct
	{
	byte countergeneralusage[2]; //  
	byte countercyclesalgorithm[2]; //    / 
	byte currentstatusprocess[2]; //     1[0]  2[1]
	byte currentmethodbattery[2]; //     1[0]  2[1]
	word limitfirstparameters[4]; //   ,     1
	word limitsecondparameters[4]; //   ,     2
	}var_lti;

void LTI_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm); //   
void LTI_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LTI_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LTI_ResetVariables(bit indxnumberbattery_prm); //  
void LTI_WriteDeferred(bit indxnumberbattery_prm); //     Li-Ti 
void LTI_ReadDeferred(bit indxnumberbattery_prm); //     Li-Ti  
void LTI_WriteEmergency(bit indxnumberbattery_prm); //     Li-Ti 
void LTI_ReadEmergency(bit indxnumberbattery_prm); //     Li-Ti 
byte LTI_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm); //  
word LTI_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //    
word LTI_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word LTI_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word LTI_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word LTI_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LTI_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LTI_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //  



























