/*******************************************************************
* Nicdbattery.c
*     Ni-Cd 
* : 28.11.2022 12:48:32
* :  .
********************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Nicdbattery.h"
#include "Nigroupbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

EEMEM static byte Ncd_CountcycleAlgorithm[2]={0,0}; //      Ni-Cd 
EEMEM static byte Ncd_CurrentStatusprocess[2]={0,0}; //      Ni-Cd 
EEMEM static word Ncd_LimitsParameters[2]={0,0}; //     Ni-Cd 
EEMEM static byte Ncd_AlgorithmEmergency[2]={0,0}; //      Ni-Cd  
EEMEM static byte Ncd_CurrentstatusEmergency[2]={0,0}; //      Ni-Cd  
EEMEM static word Ncd_LimitparameterEmergency[2]={0,0}; //      Ni-Cd  

word NCD_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Ni-Cd 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(NGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						NGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,NCDNUMBER_BATTERY); //   
						}
					settingcurrentbattery_tmp=NGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(NGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						NGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,NCDNUMBER_BATTERY); //   
						}
					settingcurrentbattery_tmp=NGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //    
	}

void NCD_WriteDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	word datadeferred_tmp=0; // 
	datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,0); //     
	eeprom_write_byte(&Ncd_CountcycleAlgorithm[indxnumberbattery_prm],(byte)datadeferred_tmp); //    
	datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,1); //   
	eeprom_write_byte(&Ncd_CurrentStatusprocess[indxnumberbattery_prm],(byte)datadeferred_tmp); //  
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       1
						eeprom_write_word(&Ncd_LimitsParameters[indxnumberbattery_prm],datadeferred_tmp); //       1
						break;
			case TRUE: datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       2
						eeprom_write_word(&Ncd_LimitsParameters[indxnumberbattery_prm],datadeferred_tmp); //       2
			}
		}
	}

void NCD_ReadDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	word minimumchargebattery_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Ncd_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Ncd_CurrentStatusprocess[indxnumberbattery_prm]); //   
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: minimumchargebattery_tmp=eeprom_read_word(&Ncd_LimitsParameters[indxnumberbattery_prm]); //       1
						break;
			case TRUE: minimumchargebattery_tmp=eeprom_read_word(&Ncd_LimitsParameters[indxnumberbattery_prm]); //       2
			}
		}
	NGR_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp,minimumchargebattery_tmp); //    
	}

void NCD_WriteEmergency(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	word dataemergency_tmp=0; // 
	dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,0); //     
	eeprom_write_byte(&Ncd_AlgorithmEmergency[indxnumberbattery_prm],(byte)dataemergency_tmp); //     
	dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,1); //   
	eeprom_write_byte(&Ncd_CurrentstatusEmergency[indxnumberbattery_prm],(byte)dataemergency_tmp); //   
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       1
						eeprom_write_word(&Ncd_LimitparameterEmergency[indxnumberbattery_prm],dataemergency_tmp); //       1
						break;
			case TRUE: dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       2
						eeprom_write_word(&Ncd_LimitparameterEmergency[indxnumberbattery_prm],dataemergency_tmp); //       2
			}
		}
	}

void NCD_ReadEmergency(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	word minimumchargebattery_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Ncd_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Ncd_CurrentstatusEmergency[indxnumberbattery_prm]); //   
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: minimumchargebattery_tmp=eeprom_read_word(&Ncd_LimitparameterEmergency[indxnumberbattery_prm]); //       1
						break;
			case TRUE: minimumchargebattery_tmp=eeprom_read_word(&Ncd_LimitparameterEmergency[indxnumberbattery_prm]); //       2
			}
		}
	NGR_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp,minimumchargebattery_tmp); //   Ni-Cd 
	}





