/*******************************************************************
* Nigroupbattery.c
*     Ni-Mh  Ni-Cd 
* : 15.06.2022 19:32:56
* :  .
********************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Nigroupbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_ngr indx_ngr={0,0}; //  
var_ngr alter_ngr={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0,0,0,0},{0,0,0,0,0}}; //  
	
PROGMEM const byte Ngr_DischargeBattery[3][3][4]={{{10,105,1,0}, //   1: I<=0,1 U>=1050   0,01(1%)  U<1050 
											{5,105,0,0}, //    2: I<=0,2C U>=1050   U<1050 
											{10,80,0,100}}, //    3: I=0,1C U>=800   U<800   I<0.01C
											{{10,105,1,0}, //   1: I<=0,1 U>=1050   0,01(1%)  U<1050 
											{3,105,0,0}, //    2: I<=0,33C U>=1050   U<1050 
											{10,80,0,100}}, //    3: I=0,1C U>=800   U<800   I<0.01C 
											{{5,105,1,0}, //   1: I<=0,2 U>=1050   0,01(1%)  U<1050 
											{2,105,0,0}, //    2: I<=0,5C U>=1050   U<1050 
											{5,80,0,100}}}; //    3: I=0,2C U>=800   U<800   I<0.01C
PROGMEM const byte Ngr_ChargeBattery[3][3][4]={{{10,100,1,0}, //   1: I<=0,1C U>1000   0,0033(0,33%)   0,01C(1%) 
											{5,0,105,40}, //    2: I<=0,2C  */>1000, /=0  >0,8C  >40*C  >1,05C 
											{10,0,0,0}}, //   3:  10  I<=0,1C 
											{{10,100,1,0}, //   1: I<=0,1C U>1000   0,0033(0,33%)   0,01C(1%)
											{3,0,105,40}, //    2: I<=0,33C  */>1000, /=0  >0,8C  >40*C  >1,05C
											{10,0,0,0}}, //   3:  10  I<=0,1C 
											{{5,100,1,0}, //   1: I<=0,2C U>1000   0,0033(0,33%)   0,01C(1%)
											{1,0,105,40}, //    2: I<=1C  */>1000, /=0  >0,8C  >40*C  >1,05C
											{5,0,0,0}}}; //   3:  10  I<=0,2C 

void NGR_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm) //    Ni-Mh Ni-Cd 
	{
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indx_ngr.updatingfirstdata=TRUE; //       1
					alter_ngr.currentmethodbattery[indxnumberbattery_prm]=currentmethodbattery_prm; //    1
					if(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==0) alter_ngr.numbercellsbattery[indxnumberbattery_prm]=numberbatterysources_prm; //    
					break;
		case TRUE: indx_ngr.updatingseconddata=TRUE; //       2
					alter_ngr.currentmethodbattery[indxnumberbattery_prm]=currentmethodbattery_prm; //    2
					if(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==0) alter_ngr.numbercellsbattery[indxnumberbattery_prm]=numberbatterysources_prm; //    
		}
	switch(indxchargedischarge_prm) //  /
		{
		case FALSE: NGR_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
					break;
		case TRUE: NGR_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
		}
	}

word NGR_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //     
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: NGR_IncreaseParameters(indxnumberbattery_prm,measuredvoltagebattery_prm,measuredtemperature_prm); //       1
					settingcurrentbattery_tmp=NGR_ChargeController(indxnumberbattery_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=NGR_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    /
	}

void NGR_ResetVariables(bit indxnumberbattery_prm) //  
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: while(counterindxarray_tmp<5) //   
						{
						alter_ngr.limitfirstparameters[counterindxarray_tmp]=0; //    1
						counterindxarray_tmp++; //   
						}
					if(indx_ngr.updatingfirstdata==TRUE) indx_ngr.updatingfirstdata=FALSE; //      
					break;
		case TRUE: while(counterindxarray_tmp<5) //   
						{
						alter_ngr.limitsecondparameters[counterindxarray_tmp]=0; //    2
						counterindxarray_tmp++; //   
						}
					if(indx_ngr.updatingseconddata==TRUE) indx_ngr.updatingseconddata=FALSE; //      
					}
	alter_ngr.countergeneralusage[indxnumberbattery_prm]=0; //   
	alter_ngr.counterdeltadetected[indxnumberbattery_prm]=0; //    
	alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   / 
	alter_ngr.currentstatusprocess[indxnumberbattery_prm]=0; //  
	alter_ngr.currentmethodbattery[indxnumberbattery_prm]=0; //    
	alter_ngr.numbercellsbattery[indxnumberbattery_prm]=0; //      
	alter_ngr.previousvoltagebattery[indxnumberbattery_prm]=0; //    
	alter_ngr.previoustemperature[indxnumberbattery_prm]=0; //    
	alter_ngr.increaseratevoltage[indxnumberbattery_prm]=0; //     
	alter_ngr.increasetemperature[indxnumberbattery_prm]=0; //     
	}

void NGR_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	dword chargedischargedata_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_ngr.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_ngr.limitfirstparameters[0]>NGRMAXVALUE_CURRENT) alter_ngr.limitfirstparameters[0]=NGRMAXVALUE_CURRENT; //     1
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp>0) alter_ngr.limitfirstparameters[1]=(word)algoritmdata_tmp*(word)alter_ngr.numbercellsbattery[indxnumberbattery_prm]*10; //     1     
					else alter_ngr.limitfirstparameters[1]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      1
					alter_ngr.limitfirstparameters[2]=(word)chargedischargedata_tmp; //    
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						chargedischargedata_tmp=(dword)algoritmdata_tmp*10000/625; //     
						alter_ngr.limitfirstparameters[3]=(word)chargedischargedata_tmp; //   
						}
					else alter_ngr.limitfirstparameters[3]=algoritmdata_tmp; //   
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_ngr.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_ngr.limitsecondparameters[0]>NGRMAXVALUE_CURRENT) alter_ngr.limitsecondparameters[0]=NGRMAXVALUE_CURRENT; //     2
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp>0) alter_ngr.limitsecondparameters[1]=(word)algoritmdata_tmp*(word)alter_ngr.numbercellsbattery[indxnumberbattery_prm]*10; //     2     
					else alter_ngr.limitsecondparameters[1]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      2
					alter_ngr.limitsecondparameters[2]=(word)chargedischargedata_tmp; //    
					algoritmdata_tmp=pgm_read_byte(&Ngr_ChargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						chargedischargedata_tmp=(dword)algoritmdata_tmp*10000/625; //     
						alter_ngr.limitsecondparameters[3]=(word)chargedischargedata_tmp; //   
						}
					else alter_ngr.limitsecondparameters[3]=algoritmdata_tmp; //   
		}
	}

void NGR_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	dword chargedischargedata_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_ngr.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_ngr.limitfirstparameters[0]<NGRMINVALUE_CURRENT) alter_ngr.limitfirstparameters[0]=NGRMINVALUE_CURRENT; //     10- 
					else if(alter_ngr.limitfirstparameters[0]>NGRMAXVALUE_CURRENT) alter_ngr.limitfirstparameters[0]=NGRMAXVALUE_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					alter_ngr.limitfirstparameters[1]=(word)algoritmdata_tmp*(word)alter_ngr.numbercellsbattery[indxnumberbattery_prm]*10; //     1
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					if(algoritmdata_tmp>0) //    
						{
						chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      1
						alter_ngr.limitfirstparameters[2]=(word)chargedischargedata_tmp; //    
						}
					else alter_ngr.limitfirstparameters[2]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_ngr.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_ngr.limitfirstparameters[3]<NGRMINVALUE_CURRENT) alter_ngr.limitfirstparameters[3]=NGRMINVALUE_CURRENT; //     10- 
						}
					else alter_ngr.limitfirstparameters[3]=algoritmdata_tmp; //  
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_ngr.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_ngr.limitsecondparameters[0]<NGRMINVALUE_CURRENT) alter_ngr.limitsecondparameters[0]=NGRMINVALUE_CURRENT; //     10- 
					else if(alter_ngr.limitsecondparameters[0]>NGRMAXVALUE_CURRENT) alter_ngr.limitsecondparameters[0]=NGRMAXVALUE_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					alter_ngr.limitsecondparameters[1]=(word)algoritmdata_tmp*(word)alter_ngr.numbercellsbattery[indxnumberbattery_prm]*10; //     2
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					if(algoritmdata_tmp>0) //    
						{
						chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      2
						alter_ngr.limitsecondparameters[2]=(word)chargedischargedata_tmp; //   
						}
					else alter_ngr.limitsecondparameters[2]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Ngr_DischargeBattery[alter_ngr.currentmethodbattery[indxnumberbattery_prm]][alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_ngr.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_ngr.limitsecondparameters[3]<NGRMINVALUE_CURRENT) alter_ngr.limitsecondparameters[3]=NGRMINVALUE_CURRENT; //     10- 
						}
					else alter_ngr.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word NGR_ChargeController(bit indxnumberbattery_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //   
	{
	bit indxdetectdelta_tmp=FALSE; // 
	word settingcurrentbattery_tmp=0;
	word minimumchargebattery_tmp=0;
	word limitcurrentparameters_tmp=0;
	word intresystancebattery_tmp=0; 
	dword generalpurpose_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0: if((measuredchargebattery_prm>=alter_ngr.limitfirstparameters[4])&&(measuredchargebattery_prm<alter_ngr.limitfirstparameters[2])) //    0,01C(1%)
									{
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitfirstparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //    
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=1) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=1; // : 
									}
								minimumchargebattery_tmp=alter_ngr.limitfirstparameters[2]/3; //     0,0033C
								if((measuredchargebattery_prm>=minimumchargebattery_tmp)&&(measuredvoltagebattery_prm>=alter_ngr.limitfirstparameters[1])) //      0,0033C      
									{
									alter_ngr.limitfirstparameters[4]=minimumchargebattery_tmp; //     
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingfirstdata=FALSE; //       
									}
								else if((measuredchargebattery_prm>=alter_ngr.limitfirstparameters[2])&&(measuredvoltagebattery_prm<alter_ngr.limitfirstparameters[1])) //    0,01C(1%)    1   
									{
									settingcurrentbattery_tmp=0; //          1
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_ngr.limitfirstparameters[4]=0; //    
									alter_ngr.currentstatusprocess[indxnumberbattery_prm]=9; // :   1
									indx_ngr.updatingfirstdata=FALSE; //      
									}
								break;
						case 1: if((measuredchargebattery_prm>=alter_ngr.limitfirstparameters[4])&&(measuredchargebattery_prm<alter_ngr.limitfirstparameters[2])) //    0,0033    1,05C(105%)
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     1
									if(indxonlycharging_prm==FALSE) //    
										{
										switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //   
											{
											case 0: limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //       
													break;
											case 1: if((intresystancebattery_tmp<300)&&(measuredtemperature_prm<alter_ngr.limitfirstparameters[3])) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]*3/2; //    1,5           0,3     40*
													else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //            0,3      40*  
													break;
											case 2: if(measuredtemperature_prm>=alter_ngr.limitfirstparameters[3]) //   40*      
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/3; //     3-        0,3 
														else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/4; //     4-      0,3   
														}
													else //    40*    
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //               0,3 
														else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/2; //     2      0,3    
														}
											}
										}
									else //    
										{
										switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //   
											{
											case 0 ... 1: limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //         
													break;
											case 2: if(measuredtemperature_prm>=alter_ngr.limitfirstparameters[3]) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/4; //     4         40*  
													else //    40*    
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/2; //    2       0,3  
														else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/3; //    3      0,3   
														}
											}
										}
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //    
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=2) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=2; // :  
									}
								if(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1) indxdetectdelta_tmp=NGR_DetectionDerivative(indxnumberbattery_prm); //       1
								if(indxonlycharging_prm==TRUE) //    
									{
									if(((indxdetectdelta_tmp==TRUE)&&(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1))||(measuredtemperature_prm>(alter_ngr.limitfirstparameters[3]))||(measuredchargebattery_prm>=alter_ngr.limitfirstparameters[2])) //       40*       105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //      
										alter_ngr.countergeneralusage[indxnumberbattery_prm]=7; //    1 
										indx_ngr.updatingfirstdata=FALSE; //      
										}
									}
								else //    
									{
									generalpurpose_tmp=(dword)alter_ngr.limitfirstparameters[2]*80/105; //     0,8C
									minimumchargebattery_tmp=(word)generalpurpose_tmp; //   0,8
									if(measuredchargebattery_prm<minimumchargebattery_tmp) //    0,8
										{
										if(alter_ngr.maximumtemperature[indxnumberbattery_prm]>0) alter_ngr.maximumtemperature[indxnumberbattery_prm]=0; //     
										}
									else if(((indxdetectdelta_tmp==TRUE)&&(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1)&&(measuredchargebattery_prm>=minimumchargebattery_tmp))||(measuredchargebattery_prm>=alter_ngr.limitfirstparameters[2])) //      0,8C        105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //      
										alter_ngr.countergeneralusage[indxnumberbattery_prm]=70; //     10 
										indx_ngr.updatingfirstdata=FALSE; //      
										}
									}
								break;
						case 2: if(alter_ngr.countergeneralusage[indxnumberbattery_prm]>0) //     
									{
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitfirstparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //     
									alter_ngr.countergeneralusage[indxnumberbattery_prm]--; //   
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=3) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=3; // : 
									}
								else //   
									{
									settingcurrentbattery_tmp=0; //          1
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_ngr.limitfirstparameters[4]=0; //    
									alter_ngr.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_ngr.updatingfirstdata=FALSE; //      
									}
						}
					break;
		case TRUE: switch(alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: if((measuredchargebattery_prm>=alter_ngr.limitsecondparameters[4])&&(measuredchargebattery_prm<alter_ngr.limitsecondparameters[2])) //    0,01C(1%)
									{
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitsecondparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //   
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=1) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=1; // : 
									}
								minimumchargebattery_tmp=alter_ngr.limitsecondparameters[2]/3; //     0,0033C
								if((measuredchargebattery_prm>=minimumchargebattery_tmp)&&(measuredvoltagebattery_prm>=alter_ngr.limitsecondparameters[1])) //      0,0033C     
									{
									alter_ngr.limitsecondparameters[4]=minimumchargebattery_tmp; //     
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingseconddata=FALSE; //     
									}
								else if((measuredchargebattery_prm>=alter_ngr.limitsecondparameters[2])&&(measuredvoltagebattery_prm<alter_ngr.limitsecondparameters[1])) //    0,01C    2   
									{
				 					settingcurrentbattery_tmp=0; //          2
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_ngr.limitsecondparameters[4]=0; //    
									alter_ngr.currentstatusprocess[indxnumberbattery_prm]=9; // :   2
									indx_ngr.updatingseconddata=FALSE; //      
									}
								break;
						case 1: if((measuredchargebattery_prm>=alter_ngr.limitsecondparameters[4])&&(measuredchargebattery_prm<alter_ngr.limitsecondparameters[2])) //    0,0033   1,05(105%)
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     2
									if(indxonlycharging_prm==FALSE) //    
										{
										switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
											{
											case 0: limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //       
													break;
											case 1: if((intresystancebattery_tmp<300)&&(measuredtemperature_prm<alter_ngr.limitsecondparameters[3])) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]*3/2; //    1,5           0,3     40*
													else limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //            0,3      40*  
													break;
											case 2: if(measuredtemperature_prm>=alter_ngr.limitsecondparameters[3]) //   40*      
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/3; //     3-        0,3 
														else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/4; //     4-      0,3   
														}
													else //    40*    
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //              0,3 
														else limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]/2; //     2      0,3   
														}
											}
										}
									else //    
										{
										switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
											{
											case 0 ... 1: limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //               0,3 
													break;
											case 2: if(measuredtemperature_prm>=alter_ngr.limitsecondparameters[3]) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]/4; //     4         40*  
													else //    40*    
														{
														if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]/2; //    2       0,3 
														else limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]/3; //    3      0,3   
														}
											}
										}
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=2) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=2; // :  
									}
								if(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1) indxdetectdelta_tmp=NGR_DetectionDerivative(indxnumberbattery_prm); //       2
								if(indxonlycharging_prm==TRUE) //    
									{
									if(((indxdetectdelta_tmp==TRUE)&&(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1))||(measuredtemperature_prm>=(alter_ngr.limitsecondparameters[3]))||(measuredchargebattery_prm>=alter_ngr.limitsecondparameters[2])) //       2 40*       105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //      
										alter_ngr.countergeneralusage[indxnumberbattery_prm]=7; //    1 
										indx_ngr.updatingseconddata=FALSE; //     
										}
									}
								else //    
									{
									generalpurpose_tmp=(dword)alter_ngr.limitsecondparameters[2]*80/105; //     0,8C
									minimumchargebattery_tmp=(word)generalpurpose_tmp; //   0,8
									if(measuredchargebattery_prm<minimumchargebattery_tmp) //    0,8
										{
										if(alter_ngr.maximumtemperature[indxnumberbattery_prm]>0) alter_ngr.maximumtemperature[indxnumberbattery_prm]=0; //     
										}
									else if(((indxdetectdelta_tmp==TRUE)&&(alter_ngr.numbercellsbattery[indxnumberbattery_prm]==1)&&(measuredchargebattery_prm>=minimumchargebattery_tmp))||(measuredchargebattery_prm>=alter_ngr.limitsecondparameters[2])) //    0,8C        105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //      
										alter_ngr.countergeneralusage[indxnumberbattery_prm]=70; //    10 
										indx_ngr.updatingseconddata=FALSE; //     
										}
									}
								break;
						case 2: if(alter_ngr.countergeneralusage[indxnumberbattery_prm]>0) //     
									{
									settingcurrentbattery_tmp=NGR_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitsecondparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									alter_ngr.countergeneralusage[indxnumberbattery_prm]--; //   
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=3) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=3; // : 
									}
								else //   
									{
									settingcurrentbattery_tmp=0; //          2
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_ngr.limitsecondparameters[4]=0; //    
									alter_ngr.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_ngr.updatingseconddata=FALSE; //     
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word NGR_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word intresystancebattery_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0: if((measuredchargebattery_prm<alter_ngr.limitfirstparameters[2])&&(measuredvoltagebattery_prm>=alter_ngr.limitfirstparameters[1])) //    0,01(1%)      
									{
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitfirstparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //     
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=5) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=5; // :  
									}
								else if((measuredchargebattery_prm<alter_ngr.limitfirstparameters[2])&&(measuredvoltagebattery_prm<alter_ngr.limitfirstparameters[1])) //    0,01(1%)       
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=2; //          
									indx_ngr.updatingfirstdata=FALSE; //     
									}
								else if((measuredchargebattery_prm>=alter_ngr.limitfirstparameters[2])&&(measuredvoltagebattery_prm>=alter_ngr.limitfirstparameters[1])) //    0,01(1%)         
									{
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingfirstdata=FALSE; //     
									}
								break;
						case 1: if(measuredvoltagebattery_prm>=alter_ngr.limitfirstparameters[1]) //         
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     1
									switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
										{
										case 0 ... 1: limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //         
												break;
										case 2: if(measuredtemperature_prm>=640) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]/2; //           40*    
												else //E    40*    
													{
													if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]; //        1  0,3 
													else limitcurrentparameters_tmp=alter_ngr.limitfirstparameters[0]*2/3; //    1,5      1 0,3   
													}
										}
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=6) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=6; // :  
									}
								else //       
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingfirstdata=FALSE; //     
									}
								break;
						case 2: if(measuredvoltagebattery_prm>=alter_ngr.limitfirstparameters[1]) //   1       
									{
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitfirstparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=7) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=7; // :  
									}
								else //       
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     1
									if((measuredcurrentbattery_prm<=alter_ngr.limitfirstparameters[3])||(intresystancebattery_tmp>9000)) //      0,01  10 ,      9  
										{
										settingcurrentbattery_tmp=0; //         
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
										alter_ngr.currentstatusprocess[indxnumberbattery_prm]=8; // :  
										indx_ngr.updatingfirstdata=FALSE; //   
										}
									else if((measuredcurrentbattery_prm>alter_ngr.limitfirstparameters[3])&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //         0,01
									}
						}
					break;
		case TRUE: switch(alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: if((measuredchargebattery_prm<alter_ngr.limitsecondparameters[2])&&(measuredvoltagebattery_prm>=alter_ngr.limitsecondparameters[1])) //    0,01(1%)         
									{
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitsecondparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=5) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=5; // :  
									}
								else if((measuredchargebattery_prm<alter_ngr.limitsecondparameters[2])&&(measuredvoltagebattery_prm<alter_ngr.limitsecondparameters[1])) //    0,01(1%)       
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=2; //        
									indx_ngr.updatingseconddata=FALSE; //     
									}
								else if((measuredchargebattery_prm>=alter_ngr.limitsecondparameters[2])&&(measuredvoltagebattery_prm>=alter_ngr.limitsecondparameters[1])) //    0,01(1%)       
									{
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingseconddata=FALSE; //     
									}
								break;
						case 1: if(measuredvoltagebattery_prm>=alter_ngr.limitsecondparameters[1]) //         
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     2
									switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
										{
										case 0 ... 1: limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //         
												break;
										case 2: if(measuredtemperature_prm>=640) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]/2; //        40*      
												else //E    40*    
													{
													if(intresystancebattery_tmp<300) limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]; //         0,3 
													else limitcurrentparameters_tmp=alter_ngr.limitsecondparameters[0]*2/3; //    1,5      0,3   
													}
										}
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=6) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=6; // :  
									}
								else //       
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_ngr.updatingseconddata=FALSE; //     
									}
								break;
						case 2: if(measuredvoltagebattery_prm>=alter_ngr.limitsecondparameters[1]) //   2       
									{
									settingcurrentbattery_tmp=NGR_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_ngr.limitsecondparameters[0],measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
									if(alter_ngr.currentstatusprocess[indxnumberbattery_prm]!=7) alter_ngr.currentstatusprocess[indxnumberbattery_prm]=7; // :  
									}
								else //       
									{
									intresystancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //     2
									if((measuredcurrentbattery_prm<=alter_ngr.limitsecondparameters[3])||(intresystancebattery_tmp>9000)) //      0,01  10 ,      9  
										{
										settingcurrentbattery_tmp=0; //         
										alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
										alter_ngr.currentstatusprocess[indxnumberbattery_prm]=8; // :  
										indx_ngr.updatingseconddata=FALSE; //   
										}
									else if((measuredcurrentbattery_prm>alter_ngr.limitsecondparameters[3])&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //         0,01
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word NGR_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitsparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=NGR_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitsparameters_prm)&&(measvoltageloadedbattery_prm<(NGRMAXVALUE_VOLTAGE*alter_ngr.numbercellsbattery[indxnumberbattery_prm]))&&(currentvaluepower_tmp<NGRMAXPOWER_CHARGE)) //          
		{
		switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/3))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //          33%      2
					else stepincreasecurrent_tmp=1; //   33%      1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/2))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=3; //          50%      3
					else if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/3))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //          33%      2 
					else stepincreasecurrent_tmp=1; //   33%      1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else if(measuredcurrentbattery_prm==limitsparameters_prm) asm("nop"); //       
	else if(((measuredcurrentbattery_prm>limitsparameters_prm)||(measvoltageloadedbattery_prm>=(NGRMAXVALUE_VOLTAGE*alter_ngr.numbercellsbattery[indxnumberbattery_prm]))||(currentvaluepower_tmp>NGRMAXPOWER_CHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //            
	return settingcurrentbattery_tmp; //   
	}

word NGR_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitsparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //    
	currentvaluepower_tmp=NGR_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitsparameters_prm)&&(measvoltageloadedbattery_prm>(NGRMINVALUE_VOLTAGE*alter_ngr.numbercellsbattery[indxnumberbattery_prm]))&&(currentvaluepower_tmp<NGRMAXPOWER_DISCHARGE)) //          
		{
		switch(alter_ngr.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/3))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/2))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitsparameters_prm-limitsparameters_prm/3))&&(alter_ngr.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //           33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else if(measuredcurrentbattery_prm==limitsparameters_prm) asm("nop"); //       
	else if(((measuredcurrentbattery_prm>limitsparameters_prm)||(measvoltageloadedbattery_prm<=(NGRMINVALUE_VOLTAGE*alter_ngr.numbercellsbattery[indxnumberbattery_prm]))||(currentvaluepower_tmp>NGRMAXPOWER_DISCHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //             
	return settingcurrentbattery_tmp; //   
	}

word NGR_ReadcurrentStatus(bit indxnumberbattery_prm,byte numberparameters_prm) //     
	{
	word dataparameters_tmp=0; // 
	switch(numberparameters_prm) //  
		{
		case 0: dataparameters_tmp=(word)alter_ngr.currentstatusprocess[indxnumberbattery_prm]; //   
				break;
		case 1: dataparameters_tmp=alter_ngr.increaseratevoltage[indxnumberbattery_prm]; //     
				break;
		case 2: dataparameters_tmp=alter_ngr.increasetemperature[indxnumberbattery_prm]; //     
				break;
		case 3: dataparameters_tmp=alter_ngr.numbercellsbattery[indxnumberbattery_prm]; //     
		}
	return dataparameters_tmp; //    
	}

bit NGR_ReadindxUpdatig(bit indxnumberbattery_prm) //     
	{
	bit indxupdatingdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indxupdatingdata_tmp=indx_ngr.updatingfirstdata; //      1
					break;
		case TRUE: indxupdatingdata_tmp=indx_ngr.updatingseconddata; //      2
		}
	return indxupdatingdata_tmp;
	}

void NGR_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm,word minimumchargebattery_prm) //       
	{
	alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]=datadeferred_prm; //    
	alter_ngr.currentstatusprocess[indxnumberbattery_prm]=statusdeferred_prm; //   
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: alter_ngr.limitfirstparameters[4]=minimumchargebattery_prm; //     1
					break;
		case TRUE: alter_ngr.limitsecondparameters[4]=minimumchargebattery_prm; //     2
		}
	}

word NGR_ReadcurrentAlgorithm(bit indxnumberbattery_prm,byte numberargument_prm) //       
	{
	word dataparameters_tmp=0; // 
	switch(numberargument_prm) //   
		{
		case 0: dataparameters_tmp=alter_ngr.countercyclesalgorithm[indxnumberbattery_prm]; //    
				break;
		case 1: dataparameters_tmp=alter_ngr.currentstatusprocess[indxnumberbattery_prm]; //   
				break;
		case 2: switch(indxnumberbattery_prm) //  
					{
					case FALSE: dataparameters_tmp=alter_ngr.limitfirstparameters[4]; //     1
								break;
					case TRUE: dataparameters_tmp=alter_ngr.limitsecondparameters[4]; //     2
					}
		}
	return dataparameters_tmp; //  
	}

void NGR_IncreaseParameters(bit indxnumberbattery_prm,word measuredvoltagebattery_prm,word measuredtemperature_prm) //       
	{
	dword oneratechangedata_tmp=0; //  
	dword tworatechangedata_tmp=0; 
	if(measuredtemperature_prm>alter_ngr.previoustemperature[indxnumberbattery_prm]) //     
		{
		if(alter_ngr.previoustemperature[indxnumberbattery_prm]==0) alter_ngr.previoustemperature[indxnumberbattery_prm]=measuredtemperature_prm; //   
		oneratechangedata_tmp=(dword)measuredtemperature_prm*625; //     
		tworatechangedata_tmp=(dword)alter_ngr.previoustemperature[indxnumberbattery_prm]*625; //     
		oneratechangedata_tmp-=tworatechangedata_tmp; //      
		tworatechangedata_tmp=60*oneratechangedata_tmp/88; //     / 
		alter_ngr.increasetemperature[indxnumberbattery_prm]=(word)tworatechangedata_tmp; //      
		if(alter_ngr.increasetemperature[indxnumberbattery_prm]>alter_ngr.maximumtemperature[indxnumberbattery_prm]) alter_ngr.maximumtemperature[indxnumberbattery_prm]=alter_ngr.increasetemperature[indxnumberbattery_prm]; //     
		alter_ngr.previoustemperature[indxnumberbattery_prm]=measuredtemperature_prm; //    
		}
	if(measuredvoltagebattery_prm>alter_ngr.previousvoltagebattery[indxnumberbattery_prm]) //      
		{
		oneratechangedata_tmp=600*((dword)measuredvoltagebattery_prm-(dword)alter_ngr.previousvoltagebattery[indxnumberbattery_prm])/88; //     / 
		alter_ngr.increaseratevoltage[indxnumberbattery_prm]=(word)oneratechangedata_tmp; //      
		alter_ngr.previousvoltagebattery[indxnumberbattery_prm]=measuredvoltagebattery_prm; //    
		}
	else alter_ngr.increaseratevoltage[indxnumberbattery_prm]=0; //             
	}

bit NGR_DetectionDerivative(bit indxnumberbattery_prm) //          
	{
	bit indxdetectiondelta_tmp=FALSE; //  
	if(alter_ngr.increaseratevoltage[indxnumberbattery_prm]==0) alter_ngr.counterdeltadetected[indxnumberbattery_prm]++; //         
	else if((alter_ngr.increaseratevoltage[indxnumberbattery_prm]>0)&&(alter_ngr.counterdeltadetected[indxnumberbattery_prm]>0)) alter_ngr.counterdeltadetected[indxnumberbattery_prm]=0; //             
	if((alter_ngr.maximumtemperature[indxnumberbattery_prm]>800)&&(alter_ngr.counterdeltadetected[indxnumberbattery_prm]>=15)) indxdetectiondelta_tmp=TRUE; //    2-            0,8*/ 
	return indxdetectiondelta_tmp; //   
	}

word NGR_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm) //     
	{
	dword currentvaluepower_tmp=0; // 
	currentvaluepower_tmp=(dword)measuredcurrentbattery_prm*(dword)measuredvoltagebattery_prm/1000; //  
	return (word)currentvaluepower_tmp; //  
	}





















