/**********************************************************************
* Nigroupbattery.h
*     Ni-Mh 
* : 15.06.2022 19:19:05
* :  .
***********************************************************************/

#pragma once

#include "Main.h"

#define NGRMINVALUE_VOLTAGE 700 //     
#define NGRMAXVALUE_VOLTAGE 1800 //     
#define NGRMAXVALUE_CURRENT 2300 //   / 
#define NGRMINVALUE_CURRENT 10 //   / 
#define NGRMAXPOWER_CHARGE 8000 //    
#define NGRMAXPOWER_DISCHARGE 10000 //    

typedef struct
	{
	bit updatingfirstdata:1; //     1 
	bit updatingseconddata:1; //     2 
	}bit_ngr;

typedef struct
	{
	byte countergeneralusage[2]; //   
	byte counterdeltadetected[2]; //    
	byte countercyclesalgorithm[2]; //   /  
	byte currentstatusprocess[2]; //     1[0]  2[1] 
	byte currentmethodbattery[2]; //     1[0]  2[1] 
	word numbercellsbattery[2]; //     1[0]  2[1] 
	word previousvoltagebattery[2]; //    1[0]  2[1] 
	word previoustemperature[2]; //    1[0]  2[1] 
	word increaseratevoltage[2]; //       1[0]  2[1] 
	word increasetemperature[2]; //       1[0]  2[1] 
	word maximumtemperature[2]; //      1[0]  2[1] 
	word limitfirstparameters[5]; //   ,      1 
	word limitsecondparameters[5]; //   ,      2 
	}var_ngr; 

void NGR_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm); //    
void NGR_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //    
void NGR_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //    
void NGR_ResetVariables(bit indxnumberbattery_prm); //   
void NGR_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm,word minimumchargebattery_prm); //       
void NGR_IncreaseParameters(bit indxnumberbattery_prm,word measuredvoltagebattery_prm,word measuredtemperature_prm); //        
bit NGR_DetectionDerivative(bit indxnumberbattery_prm); //          
bit NGR_ReadindxUpdatig(bit indxnumberbattery_prm); //     
word NGR_ReadcurrentStatus(bit indxnumberbattery_prm,byte numberparameters_prm); //     
word NGR_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //     
word NGR_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm); //      
word NGR_ChargeController(bit indxnumberbattery_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm); //   
word NGR_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //   
word NGR_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //     
word NGR_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //    
word NGR_ReadcurrentAlgorithm(bit indxnumberbattery_prm,byte numberargument_prm); //       
word NGR_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //  














