/************************************************************************
* Nimh2battery.c
*       2- Ni-Mh  Ni-Cd 
* : 23.12.2022 11:11:00
* :  .
********************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Nimh2battery.h"
#include "Nigroupbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

EEMEM static byte Nm2_CountcycleAlgorithm[2]={0,0}; //        2- 
EEMEM static byte Nm2_CurrentStatusprocess[2]={0,0}; //        2- 
EEMEM static word Nm2_LimitsParameters[2]={0,0}; //       2- 
EEMEM static byte Nm2_AlgorithmEmergency[2]={0,0}; //        2- 
EEMEM static byte Nm2_CurrentstatusEmergency[2]={0,0}; //        2- 
EEMEM static word Nm2_LimitparameterEmergency[2]={0,0}; //        2- 

word NM2_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //      2- Ni-Mh  Ni-Cd 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(NGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						NGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,NM2NUMBER_BATTERY); //   
						}
					settingcurrentbattery_tmp=NGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(NGR_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						NGR_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,NM2NUMBER_BATTERY); //   
						}
					settingcurrentbattery_tmp=NGR_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //    
	}

void NM2_WriteDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //       2- Ni-Mh  Ni-Cd  
	{
	word datadeferred_tmp=0; // 
	datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,0); //     
	eeprom_write_byte(&Nm2_CountcycleAlgorithm[indxnumberbattery_prm],(byte)datadeferred_tmp); //    
	datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,1); //   
	eeprom_write_byte(&Nm2_CurrentStatusprocess[indxnumberbattery_prm],(byte)datadeferred_tmp); //  
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       1
						eeprom_write_word(&Nm2_LimitsParameters[indxnumberbattery_prm],datadeferred_tmp); //       1
						break;
			case TRUE: datadeferred_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       2
						eeprom_write_word(&Nm2_LimitsParameters[indxnumberbattery_prm],datadeferred_tmp); //       2
			}
		}
	}

void NM2_ReadDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //       2- Ni-Mh  Ni-Cd  
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	word minimumchargebattery_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Nm2_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Nm2_CurrentStatusprocess[indxnumberbattery_prm]); //   
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: minimumchargebattery_tmp=eeprom_read_word(&Nm2_LimitsParameters[indxnumberbattery_prm]); //       1
						break;
			case TRUE: minimumchargebattery_tmp=eeprom_read_word(&Nm2_LimitsParameters[indxnumberbattery_prm]); //       2
			}
		}
	NGR_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp,minimumchargebattery_tmp); //    
	}

void NM2_WriteEmergency(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //        2- Ni-Mh  Ni-Cd  
	{
	word dataemergency_tmp=0; // 
	dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,0); //     
	eeprom_write_byte(&Nm2_AlgorithmEmergency[indxnumberbattery_prm],(byte)dataemergency_tmp); //    
	dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,1); //   
	eeprom_write_byte(&Nm2_CurrentstatusEmergency[indxnumberbattery_prm],(byte)dataemergency_tmp); //  
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       1
						eeprom_write_word(&Nm2_LimitparameterEmergency[indxnumberbattery_prm],dataemergency_tmp); //       1
						break;
			case TRUE: dataemergency_tmp=NGR_ReadcurrentAlgorithm(indxnumberbattery_prm,2); //       2
						eeprom_write_word(&Nm2_LimitparameterEmergency[indxnumberbattery_prm],dataemergency_tmp); //       2
			}
		}
	}

void NM2_ReadEmergency(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //        2- Ni-Mh  Ni-Cd 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	word minimumchargebattery_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Nm2_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Nm2_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	if(indxchargedischarge_prm==FALSE) //     
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: minimumchargebattery_tmp=eeprom_read_word(&Nm2_LimitparameterEmergency[indxnumberbattery_prm]); //       1
						break;
			case TRUE: minimumchargebattery_tmp=eeprom_read_word(&Nm2_LimitparameterEmergency[indxnumberbattery_prm]); //       2
			}
		}
	NGR_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp,minimumchargebattery_tmp); //     
	}























