/***********************************************************
* Niznbattery.c
*     Ni-Zn 
* : 14.05.2023 12:35:32
* :  .
************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Niznbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_nzn indx_nzn={0,0,0,0}; // 
var_nzn alter_nzn={{0,0},{0,0},{0,0},{0,0},{0,0,0,0},{0,0,0,0}}; //  

PROGMEM const byte Nzn_DischargeBattery[3][2][4]={{{5,0,64,0}, //   : I<=0,2 U>=1550  <40*
												{10,1,0,100}}, // : I=0,1C U>=1500   I<0.01C  10   
												{{3,0,64,0}, //   : I<=0,33 U>=1550  <40*
												{10,1,0,100}}, // : I=0,1C U>=1500   I<0.01C  10   
												{{2,0,64,0}, //   : I<=0,5 U>=1550  <40*
												{5,1,0,100}}}; // : I=0,2C U>=1500   I<0.01C  10   
PROGMEM const byte Nzn_ChargeBattery[3][2][4]={{{5,0,64,0}, //    1: I<=0,2C U<=1850  <40*C
												{10,1,0,100}}, // : I<=0,1C U<=1900   I<0,01C  10   
												{{3,0,64,0}, //    1: I<=0,33C U<=1850  <40*C
												{10,1,0,100}}, // : I<=0,1C U<=1900   I<0,01C  10   
												{{1,0,64,0}, //    1: I<=1C U<=1850  <40*C
												{5,1,0,100}}}; // : I<=0,2C U<=1900   I<0,01C  10   

EEMEM static byte Nzn_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Nzn_CurrentStatusprocess[2]={0,0}; //      
EEMEM static byte Nzn_AlgorithmEmergency[2]={0,0}; //      
EEMEM static byte Nzn_CurrentstatusEmergency[2]={0,0}; //      

word NZN_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //   Ni-Zn 
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(indx_nzn.updatingfirstmethod==FALSE) //      1 
						{
						alter_nzn.currentmethodbattery[indxnumberbattery_prm]=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						indx_nzn.updatingfirstmethod=TRUE; //      1
						}
					if(indx_nzn.updatingfirstdata==FALSE) //     1 
						{
						indx_nzn.updatingfirstdata=TRUE; //    
						NZN_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=NZN_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     /
					break;
		case TRUE: if(indx_nzn.updatingsecondmethod==FALSE) //      2 
						{
						alter_nzn.currentmethodbattery[indxnumberbattery_prm]=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						indx_nzn.updatingsecondmethod=TRUE; //      2
						}
					if(indx_nzn.updatingseconddata==FALSE) //     2 
						{
						indx_nzn.updatingseconddata=TRUE; //    
						NZN_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=NZN_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     /
		}
	return settingcurrentbattery_tmp; //  
	}

void NZN_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm) //    Ni-Zn 
	{
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: NZN_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
					break;
		case TRUE: NZN_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
		}
	}

word NZN_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //     
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: settingcurrentbattery_tmp=NZN_ChargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=NZN_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    /
	}

void NZN_ResetVariables(bit indxnumberbattery_prm) //  
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: while(counterindxarray_tmp<4) //     1
						{
						alter_nzn.limitfirstparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_nzn.updatingfirstdata==TRUE) indx_nzn.updatingfirstdata=FALSE; //     
					if(indx_nzn.updatingfirstmethod==TRUE) indx_nzn.updatingfirstmethod=FALSE; //    
					break;
		case TRUE: while(counterindxarray_tmp<4) //     2
						{
						alter_nzn.limitsecondparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_nzn.updatingseconddata==TRUE) indx_nzn.updatingseconddata=FALSE; //     
					if(indx_nzn.updatingsecondmethod==TRUE) indx_nzn.updatingsecondmethod=FALSE; //    
		}
	alter_nzn.countergeneralusage[indxnumberbattery_prm]=0; //   
	alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   / 
	alter_nzn.currentstatusprocess[indxnumberbattery_prm]=0; //  
	alter_nzn.currentmethodbattery[indxnumberbattery_prm]=0; //   
	}

void NZN_WriteDeferred(bit indxnumberbattery_prm) //     Ni-Zn 
	{
	eeprom_write_byte(&Nzn_CountcycleAlgorithm[indxnumberbattery_prm],alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Nzn_CurrentStatusprocess[indxnumberbattery_prm],alter_nzn.currentstatusprocess[indxnumberbattery_prm]); //  
	}

void NZN_ReadDeferred(bit indxnumberbattery_prm) //     Ni-Zn 
	{
	alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Nzn_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	alter_nzn.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Nzn_CurrentStatusprocess[indxnumberbattery_prm]); //  
	}

void NZN_WriteEmergency(bit indxnumberbattery_prm) //     Ni-Zn 
	{
	eeprom_write_byte(&Nzn_AlgorithmEmergency[indxnumberbattery_prm],alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Nzn_CurrentstatusEmergency[indxnumberbattery_prm],alter_nzn.currentstatusprocess[indxnumberbattery_prm]); //  
	}

void NZN_ReadEmergency(bit indxnumberbattery_prm) //     Ni-Zn 
	{
	alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Nzn_AlgorithmEmergency[indxnumberbattery_prm]); //    
	alter_nzn.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Nzn_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	}

void NZN_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_nzn.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_nzn.limitfirstparameters[0]>NZNMAXLIMIT_CURRENT) alter_nzn.limitfirstparameters[0]=NZNMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_nzn.limitfirstparameters[1]=NZNMAXBATT_VOLTAGE; //           
					else alter_nzn.limitfirstparameters[1]=NZNMAXFINAL_VOLTAGE; //          
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_nzn.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nzn.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_nzn.limitfirstparameters[3]<NZNMINLIMIT_CURRENT) alter_nzn.limitfirstparameters[3]=NZNMINLIMIT_CURRENT; //      10  
						}
					else alter_nzn.limitfirstparameters[3]=algoritmdata_tmp; //   
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_nzn.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_nzn.limitsecondparameters[0]>NZNMAXLIMIT_CURRENT) alter_nzn.limitsecondparameters[0]=NZNMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_nzn.limitsecondparameters[1]=NZNMAXBATT_VOLTAGE; //           
					else alter_nzn.limitsecondparameters[1]=NZNMAXFINAL_VOLTAGE; //          
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_nzn.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Nzn_ChargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nzn.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_nzn.limitsecondparameters[3]<NZNMINLIMIT_CURRENT) alter_nzn.limitsecondparameters[3]=NZNMINLIMIT_CURRENT; //      10  
						}
					else alter_nzn.limitsecondparameters[3]=algoritmdata_tmp; //   
		}
	}

void NZN_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_nzn.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_nzn.limitfirstparameters[0]>NZNMAXLIMIT_CURRENT) alter_nzn.limitfirstparameters[0]=NZNMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_nzn.limitfirstparameters[1]=NZNMINBATT_VOLTAGE; //           1550 
					else alter_nzn.limitfirstparameters[1]=NZNMINFINAL_VOLTAGE; //          1500 
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_nzn.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nzn.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_nzn.limitfirstparameters[3]<NZNMINLIMIT_CURRENT) alter_nzn.limitfirstparameters[3]=NZNMINLIMIT_CURRENT; //      10  
						}
					else alter_nzn.limitfirstparameters[3]=algoritmdata_tmp; //   
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_nzn.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_nzn.limitsecondparameters[0]>NZNMAXLIMIT_CURRENT) alter_nzn.limitsecondparameters[0]=NZNMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_nzn.limitsecondparameters[1]=NZNMINBATT_VOLTAGE; //           1550 
					else alter_nzn.limitsecondparameters[1]=NZNMINFINAL_VOLTAGE; //          1500 
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_nzn.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Nzn_DischargeBattery[alter_nzn.currentmethodbattery[indxnumberbattery_prm]][alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nzn.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    /
						if(alter_nzn.limitsecondparameters[3]<NZNMINLIMIT_CURRENT) alter_nzn.limitsecondparameters[3]=NZNMINLIMIT_CURRENT; //      10  
						}
					else alter_nzn.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word NZN_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	word intresistancebattery_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0:	intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //    
								switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0: limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //      
											break;
									case 1: if((intresistancebattery_tmp<300)&&(measuredtemperature_prm<alter_nzn.limitfirstparameters[2])) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]*3/2; //    1,5           0,3     40*
											else limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //           0,3      40*  
											break;
									case 2: if(measuredtemperature_prm>=alter_nzn.limitfirstparameters[2]) //   40*      
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/3; //   3       0,3 
												else limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/4; //   4      0,3    
												}
											else //    40*    
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/2; //   2      0,3    
												}
									}
								limitvoltageparameters_tmp=alter_nzn.limitfirstparameters[1]; //       
								settingcurrentbattery_tmp=NZN_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=2) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								if(measuredvoltagebattery_prm>=alter_nzn.limitfirstparameters[1]) //         
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_nzn.updatingfirstdata=FALSE; //    
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<NZNMINFINAL_VOLTAGE)) //   5     1  
									{
									settingcurrentbattery_tmp=0; //         
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_nzn.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_nzn.limitfirstparameters[1]; //     
								settingcurrentbattery_tmp=NZN_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=3) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								if((measuredcurrentbattery_prm<=alter_nzn.limitfirstparameters[3])&&(measuredvoltagebattery_prm>=alter_nzn.limitfirstparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          1
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_nzn.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE: switch(alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //    
								switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0: limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //      
											break;
									case 1: if((intresistancebattery_tmp<300)&&(measuredtemperature_prm<alter_nzn.limitsecondparameters[2])) limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]*3/2; //    1,5           0,3     40*
											else limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //           0,3      40*  
											break;
									case 2: if(measuredtemperature_prm>=alter_nzn.limitsecondparameters[2]) //   40*      
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/3; //   3       0,3 
												else limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/4; //   4      0,3    
												}
											else //    40*    
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]/2; //   2      0,3    
												}
									}
								limitvoltageparameters_tmp=alter_nzn.limitsecondparameters[1]; //        
								settingcurrentbattery_tmp=NZN_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=2) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								if(measuredvoltagebattery_prm>=alter_nzn.limitsecondparameters[1]) //        
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_nzn.updatingseconddata=FALSE; //    
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<NZNMINFINAL_VOLTAGE)) //   5      
									{
									settingcurrentbattery_tmp=0; //          2
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_nzn.updatingseconddata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_nzn.limitsecondparameters[1]; //     
								settingcurrentbattery_tmp=NZN_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=3) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								if((measuredcurrentbattery_prm<=alter_nzn.limitsecondparameters[3])&&(measuredvoltagebattery_prm>=alter_nzn.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_nzn.updatingseconddata=FALSE; //    
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word NZN_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	word intresistancebattery_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //    
								switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //        
											break;
									case 2: if(measuredtemperature_prm>=alter_nzn.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]/2; //    2     40*      
											else //E    40*    
												{
												if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]*2/3; //    1,5      0,3   
												}
									}
								limitvoltageparameters_tmp=alter_nzn.limitfirstparameters[1]; //         
								settingcurrentbattery_tmp=NZN_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=6) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								if(measuredvoltagebattery_prm<=alter_nzn.limitfirstparameters[1]) //          
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_nzn.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_nzn.limitfirstparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_nzn.limitfirstparameters[1]; //      
								settingcurrentbattery_tmp=NZN_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=7) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								if((measuredcurrentbattery_prm<=alter_nzn.limitfirstparameters[3])&&(measuredvoltagebattery_prm<=alter_nzn.limitfirstparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          1
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_nzn.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE: switch(alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: intresistancebattery_tmp=OPR_ReadintResistance(indxnumberbattery_prm); //    
								switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //        
											break;
									case 2: if(measuredtemperature_prm>=alter_nzn.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]/2; //    2     40*      
									else //E    40*    
										{
										if(intresistancebattery_tmp<300) limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //         0,3 
										else limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]*2/3; //    1,5      0,3   
										}
									}
								limitvoltageparameters_tmp=alter_nzn.limitsecondparameters[1]; //      2    
								settingcurrentbattery_tmp=NZN_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=6) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								if(measuredvoltagebattery_prm<=alter_nzn.limitsecondparameters[1]) //   2        
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_nzn.updatingseconddata=FALSE; //    
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_nzn.limitsecondparameters[0]; //    0,25
								limitvoltageparameters_tmp=alter_nzn.limitsecondparameters[1]; //      
								settingcurrentbattery_tmp=NZN_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_nzn.currentstatusprocess[indxnumberbattery_prm]!=7) alter_nzn.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								if((measuredcurrentbattery_prm<=alter_nzn.limitsecondparameters[3])&&(measuredvoltagebattery_prm<=alter_nzn.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_nzn.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_nzn.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_nzn.updatingseconddata=FALSE; //    
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word NZN_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=NZN_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm<NZNMAXLOAD_VOLTAGE)&&(currentvaluepower_tmp<NZNMAXPOWER_CHARGE)) //         
		{
		switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=2; //           33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //      
		}
	else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm>limitvoltageparameters_prm)||(measvoltageloadedbattery_prm>=NZNMAXLOAD_VOLTAGE)||(currentvaluepower_tmp>NZNMAXPOWER_CHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //           
	else asm("nop"); //  
	return settingcurrentbattery_tmp; //    
	}

word NZN_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //    
	currentvaluepower_tmp=NZN_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm>limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm>NZNMINLOAD_VOLTAGE)&&(currentvaluepower_tmp<NZNMAXPOWER_DISCHARGE)) //          
		{
		switch(alter_nzn.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_nzn.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //           33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else //   
		{
		if((limitvoltageparameters_prm==NZNMINFINAL_VOLTAGE)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //        1500 
		else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm<limitvoltageparameters_prm)||(measvoltageloadedbattery_prm<=NZNMINLOAD_VOLTAGE)||(currentvaluepower_tmp>NZNMAXPOWER_DISCHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //            
		else asm("nop"); //  
		}
	return settingcurrentbattery_tmp; //   
	}

byte NZN_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm) //  
	{
	byte currentparameters_tmp=0; // 
	switch(indxparameters_prm) // 
		{
		case FALSE: currentparameters_tmp=alter_nzn.currentstatusprocess[indxnumberbattery_prm]; //   
					break;
		case TRUE: currentparameters_tmp=NZNNUMBER_BATTERY; //    
		}
	return currentparameters_tmp; //  
	}

word NZN_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm) //     
	{
	dword currentvaluepower_tmp=0; // 
	currentvaluepower_tmp=(dword)measuredcurrentbattery_prm*(dword)measuredvoltagebattery_prm/1000; //  
	return (word)currentvaluepower_tmp; //  
	}









