/**************************************************************
* Niznbattery.h
*     Ni-Zn 
* : 14.05.2023 12:36:10
* :  .
***************************************************************/

#pragma once

#include "Main.h"

#define NZNMINBATT_VOLTAGE 1550 //       
#define NZNMINFINAL_VOLTAGE 1500 //     
#define NZNMAXBATT_VOLTAGE 1850 //       
#define NZNMAXFINAL_VOLTAGE 1900 //     
#define NZNMINLOAD_VOLTAGE 1400 //   
#define NZNMAXLOAD_VOLTAGE 1950 //   
#define NZNMAXLIMIT_CURRENT 2300 //   /
#define NZNMINLIMIT_CURRENT 10 //   /
#define NZNNUMBER_BATTERY 1 //   
#define NZNMAXPOWER_CHARGE 8000 //    
#define NZNMAXPOWER_DISCHARGE 10000 //    

typedef struct
	{
	bit updatingfirstdata:1; //      1
	bit updatingseconddata:1; //      2
	bit updatingfirstmethod:1; //     1
	bit updatingsecondmethod:1; //     2
	}bit_nzn;

typedef struct
	{
	byte countergeneralusage[2]; //  
	byte countercyclesalgorithm[2]; //    / 
	byte currentstatusprocess[2]; //     1[0]  2[1]
	byte currentmethodbattery[2]; //     1[0]  2[1]
	word limitfirstparameters[4]; //   ,     1
	word limitsecondparameters[4]; //   ,     2
	}var_nzn;

void NZN_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm); //   
void NZN_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void NZN_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void NZN_ResetVariables(bit indxnumberbattery_prm); //  
void NZN_WriteDeferred(bit indxnumberbattery_prm); //     Ni-Zn 
void NZN_ReadDeferred(bit indxnumberbattery_prm); //     Ni-Zn  
void NZN_WriteEmergency(bit indxnumberbattery_prm); //     Ni-Zn 
void NZN_ReadEmergency(bit indxnumberbattery_prm); //     Ni-Zn 
byte NZN_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm); //  
word NZN_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //    
word NZN_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word NZN_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word NZN_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word NZN_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word NZN_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word NZN_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //  














