/************************************************
* Operatingmode.h
*     
* : 02.11.2021 20:03:29
* :  .
*************************************************/

#pragma once

#include "Main.h"

#define OPRPORT_ACDETECT PINA //    220  
#define OPRBITAC220_DETECT PINA3 //    
#define OPRONOFF_PERMISSION PORTC //   /  
#define OPRBYTE_FIRSTDISCH PORTC5 //    1 
#define OPRBYTE_SECONDISCH PORTC6 //    2 
#define OPRBYTE_FIRSTGRANT PORTC4 //      1 
#define OPRBYTE_SECONDGRANT PORTC7 //      2 
#define OPRONOFF_PORTCONTROL PINC //     
#define OPRCONTROL_POLARITY PINC3 //     
#define OPRCONTROL_FIRSTDISCH PINC5 //     1 
#define OPRCONTROL_SECONDISCH PINC6 //     2 
#define OPRCONTROL_FIRSTGRANT PINC4 //       1 
#define OPRCONTROL_SECONDGRANT PINC7 //       1 
#define OPRFIRST_CHARGE OCR3A //     1
#define OPRSECOND_CHARGE OCR3B //     2
#define OPRFIRST_DISCHARGE OCR1B //     1
#define OPRSECOND_DISCHARGE OCR1A //     2
#define OPRCOOLFAN_CONTROL OCR1C //    
#define OPRCIRCUIT_RESISTANCE 500 //   / 0,05 
#define OPRMAXLIMIT_NIMHCD 1800 //     Ni-Cd  Ni-Mh  
#define OPRMAXLIMIT_NIZN 2000 //     Ni-Zn  
#define OPRMAXLIMIT_LITHIUM1 4400 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define OPRMAXLIMIT_LITHIUM2 3800 //     Li-Fe  
#define OPRMAXLIMIT_LITHIUM3 3000 //     Li-Ti   
#define OPRMAXLIMIT_SLA2V 2800 //     Sla-2v 
#define OPRMAXLIMIT_SLA4V 5500 //     Sla-4v 
#define OPRMAXLIMIT_SLA6V 8000 //     Sla-6v 
#define OPRMAXLIMIT_SLA12V 15500 //     Sla-12v 
#define OPRMAXLIMIT_LIFEPO4 14600 //     LiFePo4 
#define OPRMINLIMIT_NIMHCD 120 //     Ni-Cd  Ni-Mh  
#define OPRMINLIMIT_NIZN 1000 //     Ni-Zn  
#define OPRMINLIMIT_LITHIUM1 370 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define OPRMINLIMIT_LITHIUM2 320 //     Li-Fe  
#define OPRMINLIMIT_LITHIUM3 220 //     Li-Ti   
#define OPRMINLIMIT_SLA2V 230 //     Sla-2v 
#define OPRMINLIMIT_SLA4V 460 //     Sla-4v 
#define OPRMINLIMIT_SLA6V 690 //     Sla-6v 
#define OPRMINLIMIT_SLA12V 1380 //     Sla-12v 
#define OPRMINLIMIT_LIFEPO4 1280 //     LiFePo4 
#define OPRADDLIMIT_VOLTAGE 2000 //      
#define OPRMINOUT_VOLTAGE 2400 //    
#define OPRMINFIRST_SETTBYTE 102 //      1 
#define OPRMINSECOND_SETTBYTE 408 //      2 
#define OPRFIRSTVOLTAGE_RATIO 109 //        1 
#define OPRSECONDVOLTAGE_RATIO 27 //        2
#define OPRDETECTION_NIMHCD 1700 //     Ni-Cd  Ni-Mh  
#define OPRDETECTION_NIZN 1950 //     Ni-Zn  
#define OPRDETECTION_LITHIUM1 4300 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define OPRDETECTION_LITHIUM2 3700 //     Li-Fe  
#define OPRDETECTION_LITHIUM3 2900 //     Li-Ti  
#define OPRDETECTION_SLA2V 2500 //     Sla-2v 
#define OPRDETECTION_LIFEPO4 14500 //     LiFePo4 
#define OPRMAXTYPES_BATTERY 96 //     

typedef struct
	{
	bit finishfirstonecycle:1; //     1
	bit finishsecondonecycle:1; //     2       
	bit onoffworkingservice:1; // /                  
	bit startingworkcycle:1; //     
	bit settingnumber:1; //        
	bit processnumber:1; //      
	bit firstchargedischarge:1; // /   1
	bit secondchargedischarge:1; // /   2
	bit updatetextstring:1; //    
	bit updateparameters:1; //    
	bit searchtypesbattery:1; //    
	bit startfirstservices:1; //    1
	bit startsecondservices:1; //    2
	bit stopfirstservices:1; //    1
	bit stopsecondservices:1; //    2 
	bit postponefirstservice:1; //    1 
	bit postponesecondservice:1; //    2 
	bit connectfirstbattery:1; //   1
	bit connectsecondbattery:1; //   2
	bit onlyfirstcharging:1; //    1 
	bit onlysecondcharging:1; //    2 
	bit lockfirstonlycharge:1; //       1
	bit locksecondonlycharge:1; //       2 
	bit blockfirstoutitems:1; //     1 
	bit blocksecondoutitems:1; //     2 
	bit outputfirstprotocol:1; //      1 
	bit outputsecondprotocol:1; //      2 
	bit firstfullservice:1; //     1 
	bit secondfullservice:1; //     2 
	bit prioritycomplete:1; //      
	bit firstviolacontact:1; //     1 
	bit secondviolacontact:1; //     2 
	bit emergencycasenoac:1; //     220  
	}bit_opr;

typedef struct
	{
	byte counteritemprotocol[2]; //    1[0]  2[1] 
	byte currentstatusprocess[2]; //     1[0]  2[1] 
	byte datanumbersensors[2]; //     1[0]  2[1] 
	byte counterworkcycle[2]; //    1[0]  2[1]
	byte counterpositioncursor[2]; //    1[0]  2[1]
	byte locationcursorline[2]; //         1[0]  2[1]
	byte counteroutitems[2]; //     1[0]  2[1]
	byte countertypebattery[2]; //    1[0]  2[1]
	byte countermodebattery[2]; //    1[0]  2[1]
	byte counteroutparameter[2]; //      1[0]  2[1]
	byte displaytemperature[2]; //    1[0]  2[1]
	byte countercycleservice[2]; //      1[0]  2[1]  
	byte countermethodbattery[2]; //   /  1[0]  2[1] 
	byte dataminaircooling; //     
	word counterinterrupt; //    128  
	word numbercellsbattery[2]; //     1[0]  2[1]
	word increaseratevoltage[2]; //       1[0]  2[1]
	word increasetemperature[2]; //       1[0]  2[1]
	word measuredtemperature[2]; //    1[0]  2[1] 
	word initialtemperature[2]; //    1[0]  2[1] 
	word countgeneralpurpose[2]; //   1[0]  2[1]  
	word settcapacitybattery[2]; //   1[0]  2[1]
	word measuredcurrentbattery[2]; // /  1[0]  2[1]
	word measuredvoltagebattery[2]; //    1[0]  2[1] 
	word measvoltageloadedbattery[2]; //   1[0]  2[1] 
	word maximumtemperature[2]; //   1[0]  2[1] 
	word maximumoverheating[2]; //    1[0]  2[1] 
	word measuredchargebattery[2]; //  /  /  1[0]  2[1] 
	word settingcurrentbattery[2]; //   /  1[0]  2[1] 
	word intresistancebattery[2]; //   1[0]  2[1] 
	word initialvoltagebattery[2]; //   /  1[0]  2[1] 
	word maximumcurrentbattery[2]; //   /  1[0]  2[1] 
	word miniresistancebattery[2]; //    /  1[0]  2[1] 
	dword summacurrentbattery[2]; //    1[0]  2[1]
	dword summachargebattery[2]; //  /  /  1[0]  2[1]
	}var_opr;

void OPR_MainMode(bit indxupdateline_prm); //    
void OPR_SettingParameters(void); //     
void OPR_DefineModeservice(void); //     
void OPR_OperationalBattery(void); //    
void OPR_CancellOperational(void); //     
void OPR_CompleteOperational(void); //     
void OPR_SearchconnectBattery(void); //    
void OPR_SearchtypesBattery(bit indxnumberbattery_prm); //      
void OPR_NotconnectBattery(void); //     
void OPR_WorkcycleService(void); //     
void OPR_StartstopWorkcycle(bit indxstartstop_prm); //      
void OPR_ControlWorkcycle(byte datacodecontrol_prm); //     
void OPR_SmootCurrcharge(bit indxnumberbattery_prm,bit indxsettingdirect_prm,word numbercycles_prm); //    
void OPR_SmootCurrdischarge(bit indxnumberbattery_prm,bit indxsettingdirect_prm,word numbercycles_prm); //     
void OPR_OutitemBatterytype(void); //    
void OPR_OutitemBatterymode(void); //     
void OPR_OutitemBatterymethod(void); //     
void OPR_OutserviceBatterymode(void); //     
void OPR_OutserviceParameters(void); //      
void OPR_DecodeLeftbutton(void); //   Left
void OPR_DecodeRigtbutton(void); //   Rigt 
void OPR_DecodeUpbutton(void); //   Up
void OPR_DecodeDownbutton(void); //   Down
void OPR_DecodeEnterbutton(void); //   Enter
void OPR_ResetVariables(void); //   
void OPR_ResetExternaldata(bit indxnumberbattery_prm); //    
void OPR_CalculationParameters(void); //      
void OPR_ReadvalueDeferred(void); //      
void OPR_WritevalueDeferred(bit indxnumberbattery_prm); //      
void OPR_StartConverting(bit indxtimewaiting_prm,byte numbersensors_prm); //    
void OPR_ControlAircooler(void); //     
void OPR_BlockingOutitems(void); //    
void OPR_UnblockingOutitems(void); //     
void OPR_OutputitemsProtocol(bit indxnumberbattery_prm); //    
void OPR_WritedataProtocol(bit indxnumberbattery_prm); //    
void OPR_DatachargeProtocol(bit indxnumberbattery_prm,bit indxresetdata_prm); //     
void OPR_DatadischargeProtocol(bit indxnumberbattery_prm,bit indxresetdata_prm); //     
void OPR_ResetdataProtocol(bit indxnumberbattery_prm,bit indxchargedischarge_prm); //    / 
void OPR_NocontactBattery(void); //      
void OPR_DisconnectBattery(void); //   
void OPR_NocontactMessage(bit indxnumberbattery_prm); //     
void OPR_SettingLimitvoltage(bit indxnumberbattery_prm); //    
void OPR_SettpermitControl(bit indxnumberbattery_prm,bit indxonoffdischarge_prm,bit indxonoffmaincanal_prm); //   
void OPR_ReadvalueEmergency(bit indxnumberbattery_prm); //      
void OPR_WritevalueEmergency(bit indxnumberbattery_prm); //      
bit OPR_DetectconnectBattery(void); //   
bit OPR_ControlStopindex(void); //      
bit OPR_ControlViolconnect(bit indxnumberbattery_prm,word measurecurrentbattery_prm); //       
bit OPR_ControlPolarity(void); //     
byte OPR_SearchnumberSensors(byte numbersensors_prm,byte roomsnumber_prm); //      
byte OPR_ReadnumberSensor(bit indxnumberbattery_prm); //    
byte OPR_ReadnumberProtocol(bit indxnumberbattery_prm); //      
byte OPR_ReadmethodBattery(bit indxnumberbattery_prm); //    
word OPR_TypebatteryProtocol(bit indxnumberbattery_prm); //      
word OPR_MethodbatteryProtocol(bit indxnumberbattery_prm); //       
word OPR_MonitoringParameters(void); //       
word OPR_MonitoringTypebattery(void); //       
word OPR_ReadTemperature(byte numbersensors_prm); //     
word OPR_ReadintResistance(bit indxnumberbattery_prm); //    











