/**************************************
 * Owids18b20.c
 *      1-Wire
 * : 12.06.2022 16:29:27
 * :  .
 **************************************/ 

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/sfr_defs.h>
#include "Owids18b20.h"
#include "Main.h"
#include "Operatingmode.h"

byte buffermemorydata[9]={0,0,0,0,0,0,0,0,0}; //   

EEMEM static byte Owi_SensorIdentifier[97][8]={{0,0,0,0,0,0,0,0}, //    [0]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .1 [1]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .1 [2]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .1 [3]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .1 [4]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .2 [5]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .2 [6]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .2 [7]
										{0,0,0,0,0,0,0,0}, //   Ni-Mh .2 [8]
										{0,0,0,0,0,0,0,0}, //   Ni-Cd .1 [9]
										{0,0,0,0,0,0,0,0}, //   Ni-Cd .1 [10]
										{0,0,0,0,0,0,0,0}, //   Ni-Cd .2 [11]
										{0,0,0,0,0,0,0,0}, //   Ni-Cd .2 [12]
										{0,0,0,0,0,0,0,0}, //   2Ni-Mh .1 [13]
										{0,0,0,0,0,0,0,0}, //   2Ni-Mh .2 [14]
										{0,0,0,0,0,0,0,0}, //   3Ni-Mh .1 [15]
										{0,0,0,0,0,0,0,0}, //   3Ni-Mh .2 [16]
										{0,0,0,0,0,0,0,0}, //   4Ni-Mh .1 [17]
										{0,0,0,0,0,0,0,0}, //   4Ni-Mh .2 [18]
										{0,0,0,0,0,0,0,0}, //   5Ni-Mh .1 [19]
										{0,0,0,0,0,0,0,0}, //   5Ni-Mh .2 [20]
										{0,0,0,0,0,0,0,0}, //   6Ni-Mh .1 [21]
										{0,0,0,0,0,0,0,0}, //   6Ni-Mh .2 [22]
										{0,0,0,0,0,0,0,0}, //   7Ni-Mh .1 [23]
										{0,0,0,0,0,0,0,0}, //   7Ni-Mh .2 [24]
										{0,0,0,0,0,0,0,0}, //   8Ni-Mh .1 [25]
										{0,0,0,0,0,0,0,0}, //   8Ni-Mh .2 [26]
										{0,0,0,0,0,0,0,0}, //   Ni-Zn .1 [27]
										{0,0,0,0,0,0,0,0}, //   Ni-Zn .1 [28]
										{0,0,0,0,0,0,0,0}, //   Ni-Zn .2 [29]
										{0,0,0,0,0,0,0,0}, //   Ni-Zn .2 [30]
										{0,0,0,0,0,0,0,0}, //   Li-Po .1 [31]
										{0,0,0,0,0,0,0,0}, //   Li-Po .1 [32]
										{0,0,0,0,0,0,0,0}, //   Li-Po .1 [33]
										{0,0,0,0,0,0,0,0}, //   Li-Po .1 [34]
										{0,0,0,0,0,0,0,0}, //   Li-Po .1 [35]
										{0,0,0,0,0,0,0,0}, //   Li-Po .2 [36]
										{0,0,0,0,0,0,0,0}, //   Li-Po .2 [37]
										{0,0,0,0,0,0,0,0}, //   Li-Po .2 [38]
										{0,0,0,0,0,0,0,0}, //   Li-Po .2 [39]
										{0,0,0,0,0,0,0,0}, //   Li-Po .2 [40]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .1 [41]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .1 [42]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .1 [43]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .1 [44]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .1 [45]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .2 [46]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .2 [47]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .2 [48]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .2 [49]
										{0,0,0,0,0,0,0,0}, //   Li-Ion .2 [50]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .1 [51]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .1 [52]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .1 [53]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .2 [54]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .2 [55]
										{0,0,0,0,0,0,0,0}, //   Li-Mn .2 [56]
										{0,0,0,0,0,0,0,0}, //   Li-Co .1 [57]
										{0,0,0,0,0,0,0,0}, //   Li-Co .1 [58]
										{0,0,0,0,0,0,0,0}, //   Li-Co .1 [59]
										{0,0,0,0,0,0,0,0}, //   Li-Co .2 [60]
										{0,0,0,0,0,0,0,0}, //   Li-Co .2 [61]
										{0,0,0,0,0,0,0,0}, //   Li-Co .2 [62]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .1 [63]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .1 [64]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .1 [65]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .2 [66]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .2 [67]
										{0,0,0,0,0,0,0,0}, //   Li-Nca .2 [68]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .1 [69]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .1 [70]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .1 [71]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .2 [72]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .2 [73]
										{0,0,0,0,0,0,0,0}, //   Li-Nmc .2 [74]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .1 [75]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .1 [76]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .1 [77]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .2 [78]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .2 [79]
										{0,0,0,0,0,0,0,0}, //   Li-Ti .2 [80]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .1 [81]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .1 [82]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .1 [83]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .2 [84]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .2 [85]
										{0,0,0,0,0,0,0,0}, //   Li-Fe .2 [86]
										{0,0,0,0,0,0,0,0}, //   LiFePo4 .1 [87]
										{0,0,0,0,0,0,0,0}, //   LiFePo4 .2 [88]
										{0,0,0,0,0,0,0,0}, //   Sla-2v .1 [89]
										{0,0,0,0,0,0,0,0}, //   Sla-2v .2 [90]
										{0,0,0,0,0,0,0,0}, //   Sla-4v .1 [91]
										{0,0,0,0,0,0,0,0}, //   Sla-4v .2 [92]
										{0,0,0,0,0,0,0,0}, //   Sla-6v .1 [93]
										{0,0,0,0,0,0,0,0}, //   Sla-6v .2 [94]
										{0,0,0,0,0,0,0,0}, //   Sla-12v .1 [95]
										{0,0,0,0,0,0,0,0}}; //   Sla-12v .2 [96]
										 

void OWI_InitializeBuses(void) //   1-Wire 
	{
	bit indxinitialize_tmp=FALSE; //  
	word measuredvalue_tmp=0; 
	_delay_loop_2(OWIDELAY_RANGE10M); // 10 
	while(indxinitialize_tmp==FALSE) //          
		{
		measuredvalue_tmp=OWI_MeasuredTemperature(TRUE,0); //   
		if(measuredvalue_tmp<1360) indxinitialize_tmp=TRUE; //     85* 
		}
	}

byte OWI_DetectPresence(void) //     
	{
	byte readbytedata_tmp=0; // 
	SetBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //     
	_delay_loop_2(OWIDELAY_RANGE500U); // 500 
	ClearBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //    
	_delay_loop_2(OWIDELAY_RANGE65U); // 65 
	if(bit_is_set(OWIBUS_INPUT,OWIBUS_BITDATA)) readbytedata_tmp=1; //       .1
	_delay_loop_2(OWIDELAY_RANGE435U); // 435 
	return readbytedata_tmp; //  
	}

void OWI_TransferByte(byte transferdata_prm) //    
	{
	byte sendbytedata_tmp=0; //  
	byte countcycle_tmp=0;
	byte transferdata_tmp=0; 
	transferdata_tmp=transferdata_prm; //   
	while(countcycle_tmp<8) //   
		{
		sendbytedata_tmp=transferdata_tmp&1; //    
		OWI_TransferBit(sendbytedata_tmp); //   
		transferdata_tmp>>=1; //      
		countcycle_tmp++; //  
		}
	}

void OWI_TransferBit(byte transferbitdata_prm) //     
	{
	switch(transferbitdata_prm) //    
		{
		case 0: SetBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //     
				_delay_loop_2(OWIDELAY_RANGE60U); // 60 
				ClearBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //     
				_delay_loop_2(OWIDELAY_RANGE10U); // 10 
				break;
		case 1: SetBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //     
				_delay_loop_2(OWIDELAY_RANGE5U); // 5 
				ClearBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //     
				_delay_loop_2(OWIDELAY_RANGE65U); // 65 
		}
	}

byte OWI_ReceiveByte(void) //    
	{
	byte receivedata_tmp=0; //  
	byte countcycle_tmp=0;
	while(countcycle_tmp<8) //    
		{
		if(OWI_ReceiveBit()==1) receivedata_tmp|=128; //      .1 
		if(countcycle_tmp<7) receivedata_tmp>>=1; //   
		countcycle_tmp++; //  
		}
	return receivedata_tmp; //  
	}

byte OWI_ReceiveBit(void) //     
	{
	byte receivebitdata_tmp=0; //  
	SetBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //    
	_delay_loop_2(OWIDELAY_RANGE5U); // 5 
	ClearBit(OWIBUS_CONTROL,OWIBUS_CONTDATA); //    
	_delay_loop_2(OWIDELAY_RANGE10U); // 10 
	if(bit_is_set(OWIBUS_INPUT,OWIBUS_BITDATA)) receivebitdata_tmp=1; //     .1
	_delay_loop_2(OWIDELAY_RANGE60U); // 60 
	return receivebitdata_tmp; //  
	}

void OWI_TransferIdentifi(byte numbersensor_prm) //   
	{
	byte countnumberbyte_tmp=0; //  
	byte identifierdata_tmp=0;
	OWI_TransferByte(OWIORDER_MATCHROM); //    
	while(countnumberbyte_tmp<8) //   
		{
		identifierdata_tmp=eeprom_read_byte(&Owi_SensorIdentifier[numbersensor_prm][countnumberbyte_tmp]); //   eeprom
		OWI_TransferByte(identifierdata_tmp); //   
		countnumberbyte_tmp++; //  
		}
	}

bit OWI_ReceiveIdentifi(void) //   
	{
	bit indxstatusread_tmp=FALSE; // 
	byte countnumberbyte_tmp=0; 
	byte currentamount_tmp=0;
	OWI_TransferByte(OWIORDER_READROM); //     
	while(countnumberbyte_tmp<8) //  
		{
		buffermemorydata[countnumberbyte_tmp]=OWI_ReceiveByte(); //  
		currentamount_tmp=OWI_CheckBytesum(currentamount_tmp,buffermemorydata[countnumberbyte_tmp]); //   
		countnumberbyte_tmp++; //  
		}
	if(currentamount_tmp==0) indxstatusread_tmp=TRUE; //       
	return indxstatusread_tmp; //   
	}

void OWI_ConservIdentifi(byte numbersensor_prm) //    eeprom 
	{
	byte countnumberbyte_tmp=0; // 
	while(countnumberbyte_tmp<8) //    eeprom 
		{
		eeprom_write_byte(&Owi_SensorIdentifier[numbersensor_prm][countnumberbyte_tmp],buffermemorydata[countnumberbyte_tmp]); //   eeprom 
		countnumberbyte_tmp++; //  
		}
	}

byte OWI_CheckBytesum(byte currentamount_prm,byte checksumdata_prm) //   
	{
	byte countercycle_tmp=0; //  
	byte temporarydata_tmp=0; 
	byte currentamount_tmp=0; 
	byte checksumdata_tmp=0; 
	checksumdata_tmp=checksumdata_prm; //     
	currentamount_tmp=currentamount_prm; //   
	while(countercycle_tmp<8) //   
		{
		temporarydata_tmp=(currentamount_tmp^checksumdata_tmp)&1; //     
		if (temporarydata_tmp==0) currentamount_tmp>>=1; //        
		else //   
			{
			currentamount_tmp^=24; //      24
			currentamount_tmp>>=1; //   
			currentamount_tmp|=128; //    
			}
		checksumdata_tmp>>=1; //   
		countercycle_tmp++; //  
		}
	return currentamount_tmp; //   
	}

bit OWI_ReadramSensor(void) //   
	{
	bit indxstatusread_tmp=FALSE; //  
	byte countcycle_tmp=0; 
	byte currentamount_tmp=0; 
	OWI_TransferByte(OWIORDER_READSCR); //    
	while(countcycle_tmp<9) //  
		{
		buffermemorydata[countcycle_tmp]=OWI_ReceiveByte(); //  
		currentamount_tmp=OWI_CheckBytesum(currentamount_tmp,buffermemorydata[countcycle_tmp]); //  
		countcycle_tmp++; //  
		}
	if(currentamount_tmp==0) indxstatusread_tmp=TRUE; //      
	return indxstatusread_tmp; //   
	}

word OWI_ConversionDecimal (void) //        
	{
	word bufferdataram_tmp[2]={0,0}; //  
	word temperaturedata_tmp=0; 
	bufferdataram_tmp[0]=buffermemorydata[0]; //   
	bufferdataram_tmp[1]=buffermemorydata[1]; //   
	temperaturedata_tmp=bufferdataram_tmp[1]*256+bufferdataram_tmp[0]; //    
	return temperaturedata_tmp; //    
	}

void OWI_TransferConverting(bit indxtimewaiting_prm,byte numbersensor_prm) //    
	{
	OWI_TransferIdentifi(numbersensor_prm); //  
	OWI_TransferByte(OWIORDER_CONVERT); //   
	_delay_loop_2(OWIDELAY_RANGE10U); // 10      
	if(indxtimewaiting_prm==TRUE) loop_until_bit_is_set(OWIBUS_INPUT,OWIBUS_BITDATA); //      
	}

void OWI_TransferRecall(void) //    eeprom    
	{
	OWI_TransferByte(OWIORDER_RECALL); //  
	_delay_loop_2(OWIDELAY_RANGE10U); // 10  
	loop_until_bit_is_set(OWIBUS_INPUT,OWIBUS_BITDATA); //  
	}

byte OWI_ReadbyteBuffer(byte indxarraydata_prm) //     
	{
	byte bufferdataram_tmp=0; //  
	bufferdataram_tmp=buffermemorydata[indxarraydata_prm]; //   
	return bufferdataram_tmp; //  
	}

word OWI_MeasuredTemperature(bit indxtimewaiting_prm,byte numbersensors_prm) //  
	{
	word measuredvalue_tmp=0; // 
	if(OWI_DetectPresence()==0) //    
		{
		OWI_TransferConverting(indxtimewaiting_prm,numbersensors_prm); //      
		OWI_DetectPresence(); //   
		OWI_TransferIdentifi(numbersensors_prm); //     
		if(OWI_ReadramSensor()==TRUE) measuredvalue_tmp=OWI_ConversionDecimal(); //       
		}
	return measuredvalue_tmp; //    
	}














