/**********************************************************************
* Sla12battery.c
*      Sla-12v 
* : 03.03.2023 17:52:36
* :  .
***********************************************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Sla12battery.h"
#include "Operatingmode.h"
#include "Slagroupbattery.h"

EEMEM static byte Sl6_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Sl6_CurrentStatusprocess[2]={0,0}; //      
EEMEM static byte Sl6_AlgorithmEmergency[2]={0,0}; //      
EEMEM static byte Sl6_CurrentstatusEmergency[2]={0,0}; //      

word SL6_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Sla-12v 
	{
	byte currentmethodbattery_tmp=0; //  
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: if(SLG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						SLG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,SL6NUMBER_BATTERY); //    1
						}
					settingcurrentbattery_tmp=SLG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(SLG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						SLG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,SL6NUMBER_BATTERY); //    2
						}
					settingcurrentbattery_tmp=SLG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //   
	}

void SL6_WriteDeferred(bit indxnumberbattery_prm) //     Sla-12v 
	{
	byte datadeferred_tmp=0; // 
	datadeferred_tmp=SLG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Sl6_CountcycleAlgorithm[indxnumberbattery_prm],datadeferred_tmp); //    
	datadeferred_tmp=SLG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Sl6_CurrentStatusprocess[indxnumberbattery_prm],datadeferred_tmp); //  
	}

void SL6_ReadDeferred(bit indxnumberbattery_prm) //     Sla-12v 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Sl6_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Sl6_CurrentStatusprocess[indxnumberbattery_prm]); //   
	SLG_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp); //        
	}

void SL6_WriteEmergency(bit indxnumberbattery_prm) //     Sla-12v 
	{
	byte dataemergency_tmp=0; // 
	dataemergency_tmp=SLG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Sl6_AlgorithmEmergency[indxnumberbattery_prm],dataemergency_tmp); //    
	dataemergency_tmp=SLG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Sl6_CurrentstatusEmergency[indxnumberbattery_prm],dataemergency_tmp); //  
	}

void SL6_ReadEmergency(bit indxnumberbattery_prm) //     Sla-12v 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Sl6_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Sl6_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	SLG_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp); //        
	}










