/**********************************************************************
* Sla2battery.c
*      Sla-2v 
* : 06.03.2023 12:08:58
* :  .
***********************************************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Sla2battery.h"
#include "Operatingmode.h"
#include "Slagroupbattery.h"

EEMEM static byte Sl1_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Sl1_CurrentStatusprocess[2]={0,0}; //      
EEMEM static byte Sl1_AlgorithmEmergency[2]={0,0}; //      
EEMEM static byte Sl1_CurrentstatusEmergency[2]={0,0}; //     

word SL1_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Sla-2v 
	{
	byte currentmethodbattery_tmp=0; // 
	word settingcurrentbattery_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: if(SLG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      1 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     1
						SLG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,SL1NUMBER_BATTERY); //    1
						}
					settingcurrentbattery_tmp=SLG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1
					break;
		case TRUE: if(SLG_ReadindxUpdatig(indxnumberbattery_prm)==FALSE) //      2 
						{
						currentmethodbattery_tmp=OPR_ReadmethodBattery(indxnumberbattery_prm); //     2
						SLG_DefiningParameters(indxnumberbattery_prm,indxchargedischarge_prm,settcapacitybattery_prm,currentmethodbattery_tmp,SL1NUMBER_BATTERY); //    2
						}
					settingcurrentbattery_tmp=SLG_DetermCurrentcontrol(indxnumberbattery_prm,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2
		}
	return settingcurrentbattery_tmp; //   
	}

void SL1_WriteDeferred(bit indxnumberbattery_prm) //     Sla-2v 
	{
	byte datadeferred_tmp=0; // 
	datadeferred_tmp=SLG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Sl1_CountcycleAlgorithm[indxnumberbattery_prm],datadeferred_tmp); //    
	datadeferred_tmp=SLG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Sl1_CurrentStatusprocess[indxnumberbattery_prm],datadeferred_tmp); //  
	}

void SL1_ReadDeferred(bit indxnumberbattery_prm) //     Sla-2v 
	{
	byte datadeferred_tmp=0; // 
	byte statusdeferred_tmp=0;
	datadeferred_tmp=eeprom_read_byte(&Sl1_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	statusdeferred_tmp=eeprom_read_byte(&Sl1_CurrentStatusprocess[indxnumberbattery_prm]); //   
	SLG_WritedataAlgorithm(indxnumberbattery_prm,datadeferred_tmp,statusdeferred_tmp); //       
	}

void SL1_WriteEmergency(bit indxnumberbattery_prm) //     Sla-2v 
	{
	byte dataemergency_tmp=0; // 
	dataemergency_tmp=SLG_ReadcurrentAlgorithm(indxnumberbattery_prm); //     
	eeprom_write_byte(&Sl1_AlgorithmEmergency[indxnumberbattery_prm],dataemergency_tmp); //    
	dataemergency_tmp=SLG_ReadcurrentStatus(indxnumberbattery_prm,FALSE); //   
	eeprom_write_byte(&Sl1_CurrentstatusEmergency[indxnumberbattery_prm],dataemergency_tmp); //  
	}

void SL1_ReadEmergency(bit indxnumberbattery_prm) //     Sla-2v 
	{
	byte dataemergency_tmp=0; // 
	byte statusemergency_tmp=0;
	dataemergency_tmp=eeprom_read_byte(&Sl1_AlgorithmEmergency[indxnumberbattery_prm]); //    
	statusemergency_tmp=eeprom_read_byte(&Sl1_CurrentstatusEmergency[indxnumberbattery_prm]); //  
	SLG_WritedataAlgorithm(indxnumberbattery_prm,dataemergency_tmp,statusemergency_tmp); //        
	}















