/*********************************************************************
* Slagroupbattery.c
*      
* : 03.03.2023 17:48:45
* :  .
**********************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Slagroupbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_slg indx_slg={0,0}; // 
var_slg alter_slg={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0,0,0},{0,0,0,0}}; // 
	
PROGMEM const byte Slg_DischargeBattery[3][2][4]={{{10,0,64,0}, //   : I<=0,1 U>=1850  <40*
												{10,1,0,100}}, // : I=0,1C U>=1800   I<0.01C  10   
												{{5,0,64,0}, //   : I<=0,2 U>=1850  <40*
												{10,1,0,100}}, // : I=0,1C U>=1800   I<0.01C  10   
												{{3,0,64,0}, //   : I<=0,33 U>=1850  <40*
												{7,1,0,100}}}; // : I=0,15C U>=1800   I<0.01C  10   
PROGMEM const byte Slg_ChargeBattery[3][2][4]={{{10,0,64,0}, //    1: I<=0,1C U<=2300  <40*C
												{10,1,0,100}}, // : I<=0,1C U<=2400   I<0,01C  10   
												{{5,0,64,0}, //    1: I<=0,2C U<=2300  <40*C
												{10,1,0,100}}, // : I<=0,1C U<=2400   I<0,01C  10   
												{{3,0,64,0}, //    1: I<=0,33C U<=2300  <40*C
												{7,1,0,100}}}; // : I<=0,15C U<=2400   I<0,01C  10   

void SLG_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm) //    
	{
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indx_slg.updatingfirstdata=TRUE; //       1
					alter_slg.currentmethodbattery[indxnumberbattery_prm]=currentmethodbattery_prm; //    1
					if(alter_slg.numbercellsbattery[indxnumberbattery_prm]==0) alter_slg.numbercellsbattery[indxnumberbattery_prm]=numberbatterysources_prm; //    
					break;
		case TRUE: indx_slg.updatingseconddata=TRUE; //       2
					alter_slg.currentmethodbattery[indxnumberbattery_prm]=currentmethodbattery_prm; //    2
					if(alter_slg.numbercellsbattery[indxnumberbattery_prm]==0) alter_slg.numbercellsbattery[indxnumberbattery_prm]=numberbatterysources_prm; //    
		}
	switch(indxchargedischarge_prm) //  /
		{
		case FALSE: SLG_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //   
					break;
		case TRUE: SLG_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //   
		}
	}

word SLG_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //     
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: settingcurrentbattery_tmp=SLG_ChargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=SLG_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    /
	}

void SLG_ResetVariables(bit indxnumberbattery_prm) //  
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: while(counterindxarray_tmp<4) //     1
						{
						alter_slg.limitfirstparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_slg.updatingfirstdata==TRUE) indx_slg.updatingfirstdata=FALSE; //     
					break;
		case TRUE: while(counterindxarray_tmp<4) //     2
						{
						alter_slg.limitsecondparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_slg.updatingseconddata==TRUE) indx_slg.updatingseconddata=FALSE; //     
		}
	alter_slg.countergeneralusage[indxnumberbattery_prm]=0; //   
	alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   / 
	alter_slg.currentstatusprocess[indxnumberbattery_prm]=0; //  
	alter_slg.currentmethodbattery[indxnumberbattery_prm]=0; //   
	alter_slg.numbercellsbattery[indxnumberbattery_prm]=0; //      
	}

void SLG_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][0]); //     1
					alter_slg.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_slg.limitfirstparameters[0]>SLGMAXLIMIT_CURRENT) alter_slg.limitfirstparameters[0]=SLGMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_slg.limitfirstparameters[1]=SLGMAXBATT_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					else alter_slg.limitfirstparameters[1]=SLGMAXFINAL_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //             
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_slg.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_slg.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_slg.limitfirstparameters[3]<SLGMINLIMIT_CURRENT) alter_slg.limitfirstparameters[3]=SLGMINLIMIT_CURRENT; //      10  
						}
					else alter_slg.limitfirstparameters[3]=algoritmdata_tmp; //   
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][0]); //     2
					alter_slg.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_slg.limitsecondparameters[0]>SLGMAXLIMIT_CURRENT) alter_slg.limitsecondparameters[0]=SLGMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_slg.limitsecondparameters[1]=SLGMAXBATT_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					else alter_slg.limitsecondparameters[1]=SLGMAXFINAL_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //             
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_slg.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Slg_ChargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_slg.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   
						if(alter_slg.limitsecondparameters[3]<SLGMINLIMIT_CURRENT) alter_slg.limitsecondparameters[3]=SLGMINLIMIT_CURRENT; //      10  
						}
					else alter_slg.limitsecondparameters[3]=algoritmdata_tmp; //   
		}
	}

void SLG_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][0]); //     1
					alter_slg.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_slg.limitfirstparameters[0]>SLGMAXLIMIT_CURRENT) alter_slg.limitfirstparameters[0]=SLGMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_slg.limitfirstparameters[1]=SLGMINBATT_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					else alter_slg.limitfirstparameters[1]=SLGMINFINAL_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_slg.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_slg.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_slg.limitfirstparameters[3]<SLGMINLIMIT_CURRENT) alter_slg.limitfirstparameters[3]=SLGMINLIMIT_CURRENT; //      10  
						}
					else alter_slg.limitfirstparameters[3]=algoritmdata_tmp; //  
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][0]); //   
					alter_slg.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_slg.limitsecondparameters[0]>SLGMAXLIMIT_CURRENT) alter_slg.limitsecondparameters[0]=SLGMAXLIMIT_CURRENT; //     2300 
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][1]); //   
					if(algoritmdata_tmp==0) alter_slg.limitsecondparameters[1]=SLGMINBATT_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					else alter_slg.limitsecondparameters[1]=SLGMINFINAL_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]; //            
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][2]); //   
					alter_slg.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40*
					algoritmdata_tmp=pgm_read_byte(&Slg_DischargeBattery[alter_slg.currentmethodbattery[indxnumberbattery_prm]][alter_slg.countercyclesalgorithm[indxnumberbattery_prm]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_slg.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_slg.limitsecondparameters[3]<SLGMINLIMIT_CURRENT) alter_slg.limitsecondparameters[3]=SLGMINLIMIT_CURRENT; //      10  
						}
					else alter_slg.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word SLG_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; //  
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //      
	switch(indxnumberbattery_prm) //  
		{
		case FALSE:	switch(alter_slg.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0:	switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //        
											break;
									case 2: if(measuredtemperature_prm>=alter_slg.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]/2; //    2     40*     
											else //    40*   
												{
												if(OPR_ReadintResistance(indxnumberbattery_prm)<300) limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]*2/3; //   1,5      0,3     
												}
									}
								if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=2) alter_slg.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								limitvoltageparameters_tmp=alter_slg.limitfirstparameters[1]; //       
								settingcurrentbattery_tmp=SLG_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(measuredvoltagebattery_prm>=alter_slg.limitfirstparameters[1]) //           
									{
									if((alter_slg.currentmethodbattery[indxnumberbattery_prm]>0)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //           
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_slg.updatingfirstdata=FALSE; //    
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<SLGMINFINAL_VOLTAGE)) //   5     1   
									{
									settingcurrentbattery_tmp=0; //         
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_slg.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=3) alter_slg.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //  
								limitvoltageparameters_tmp=alter_slg.limitfirstparameters[1]; //   
								settingcurrentbattery_tmp=SLG_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if((measuredcurrentbattery_prm<=alter_slg.limitfirstparameters[3])&&(measuredvoltagebattery_prm>=alter_slg.limitfirstparameters[1])) //             
									{
									settingcurrentbattery_tmp=0; //          1
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=4; // :    
									indx_slg.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE: switch(alter_slg.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //        
											break;
									case 2: if(measuredtemperature_prm>=alter_slg.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]/2; //   2     40*     
											else //    40*   
												{
												if(OPR_ReadintResistance(indxnumberbattery_prm)<300) limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //         0,3 
												else limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]*2/3; //   1,5      0,3     
												}
									}
								if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=2) alter_slg.currentstatusprocess[indxnumberbattery_prm]=2; // :  
								limitvoltageparameters_tmp=alter_slg.limitsecondparameters[1]; //        
								settingcurrentbattery_tmp=SLG_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(measuredvoltagebattery_prm>=alter_slg.limitsecondparameters[1]) //           
									{
									if((alter_slg.currentmethodbattery[indxnumberbattery_prm]>0)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //            
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]++; //       
									indx_slg.updatingseconddata=FALSE; //     
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<SLGMINFINAL_VOLTAGE)) //   5       
									{
									settingcurrentbattery_tmp=0; //          2
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=9; // :  
									indx_slg.updatingseconddata=FALSE; //    
									}
								break;
						case 1: if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=3) alter_slg.currentstatusprocess[indxnumberbattery_prm]=3; // : 
								limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //  
								limitvoltageparameters_tmp=alter_slg.limitsecondparameters[1]; //   
								settingcurrentbattery_tmp=SLG_ChargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if((measuredcurrentbattery_prm<=alter_slg.limitsecondparameters[3])&&(measuredvoltagebattery_prm>=alter_slg.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=4; // :   
									indx_slg.updatingseconddata=FALSE; //    
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word SLG_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; //  
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE:	switch(alter_slg.countercyclesalgorithm[indxnumberbattery_prm]) //    1
						{
						case 0: switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //        
											break;
									case 2: if(measuredtemperature_prm>=alter_slg.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]/2; //    2     40*     
											else //    40*   
												{
												if(OPR_ReadintResistance(indxnumberbattery_prm)<300) limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //         0,3  
												else limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]*2/3; //    1,5      0,3   
												}
									}
								if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=6) alter_slg.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								limitvoltageparameters_tmp=alter_slg.limitfirstparameters[1]; //        
								settingcurrentbattery_tmp=SLG_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(measuredvoltagebattery_prm<=alter_slg.limitfirstparameters[1]) //         
									{
									if((alter_slg.currentmethodbattery[indxnumberbattery_prm]>0)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //            
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_slg.updatingfirstdata=FALSE; //    
									}
								break;
						case 1: if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=7) alter_slg.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								limitcurrentparameters_tmp=alter_slg.limitfirstparameters[0]; //  
								limitvoltageparameters_tmp=alter_slg.limitfirstparameters[1]; //       
								settingcurrentbattery_tmp=SLG_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if((measuredcurrentbattery_prm<=alter_slg.limitfirstparameters[3])&&(measuredvoltagebattery_prm<=alter_slg.limitfirstparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          1
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_slg.updatingfirstdata=FALSE; //    
									}
						}
					break;
		case TRUE:	switch(alter_slg.countercyclesalgorithm[indxnumberbattery_prm]) //    2
						{
						case 0: switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
									{
									case 0 ... 1: limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //         
											break;
									case 2: if(measuredtemperature_prm>=alter_slg.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]/2; //    2     2 40*      
											else //    40*   
												{
												if(OPR_ReadintResistance(indxnumberbattery_prm)<300) limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //         0,3  
												else limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]*2/3; //    1,5      0,3   
												}
									}
								if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=6) alter_slg.currentstatusprocess[indxnumberbattery_prm]=6; // :  
								limitvoltageparameters_tmp=alter_slg.limitsecondparameters[1]; //       
								settingcurrentbattery_tmp=SLG_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(measuredvoltagebattery_prm<=alter_slg.limitsecondparameters[1]) //   2        
									{
									if((alter_slg.currentmethodbattery[indxnumberbattery_prm]>0)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //     
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]++; //      
									indx_slg.updatingseconddata=FALSE; //    
									}
								break;
						case 1: if(alter_slg.currentstatusprocess[indxnumberbattery_prm]!=7) alter_slg.currentstatusprocess[indxnumberbattery_prm]=7; // : 
								limitcurrentparameters_tmp=alter_slg.limitsecondparameters[0]; //  
								limitvoltageparameters_tmp=alter_slg.limitsecondparameters[1]; //      
								settingcurrentbattery_tmp=SLG_DischargingCurrent(indxnumberbattery_prm,measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if((measuredcurrentbattery_prm<=alter_slg.limitsecondparameters[3])&&(measuredvoltagebattery_prm<=alter_slg.limitsecondparameters[1])) //            
									{
									settingcurrentbattery_tmp=0; //          2
									alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=0; //   
									alter_slg.currentstatusprocess[indxnumberbattery_prm]=8; // :   
									indx_slg.updatingseconddata=FALSE; //     
									}
						}
		}
	return settingcurrentbattery_tmp; //     
	}

word SLG_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=SLG_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm<(SLGMAXLOAD_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]))&&(currentvaluepower_tmp<SLGMAXPOWER_CHARGE)) //          
		{
		switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=3; //          33%       3
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=5; //          50%       5
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==2)) stepincreasecurrent_tmp=3; //          33%       3
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //     
		}
	else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm>limitvoltageparameters_prm)||(measvoltageloadedbattery_prm>=(SLGMAXLOAD_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]))||(currentvaluepower_tmp>SLGMAXPOWER_CHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //               
	else asm("nop"); //  
	return settingcurrentbattery_tmp; //   
	}

word SLG_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	byte stepincreasecurrent_tmp=0; // 
	word settingcurrentbattery_tmp=0; 
	word currentvaluepower_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	currentvaluepower_tmp=SLG_DefinitionPower(measuredcurrentbattery_prm,measuredvoltagebattery_prm); //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm>limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm>(SLGMINLOAD_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]))&&(currentvaluepower_tmp<SLGMAXPOWER_DISCHARGE)) //          
		{
		switch(alter_slg.currentmethodbattery[indxnumberbattery_prm]) //  
			{
			case 0: stepincreasecurrent_tmp=1; //        1
					break;
			case 1: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
					break;
			case 2: if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/2))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=3; //          50%       3
					else if((measuredcurrentbattery_prm<(limitcurrentparameters_prm-limitcurrentparameters_prm/3))&&(alter_slg.currentstatusprocess[indxnumberbattery_prm]==6)) stepincreasecurrent_tmp=2; //          33%       2
					else stepincreasecurrent_tmp=1; //   33%       1
			}
		settingcurrentbattery_tmp+=stepincreasecurrent_tmp; //      
		}
	else //    
		{
		if((limitvoltageparameters_prm==(SLGMINFINAL_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]))&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //        
		else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm<limitvoltageparameters_prm)||(measvoltageloadedbattery_prm<=(SLGMINLOAD_VOLTAGE*alter_slg.numbercellsbattery[indxnumberbattery_prm]))||(currentvaluepower_tmp>SLGMAXPOWER_DISCHARGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //         
		else asm("nop"); //  
		}
	return settingcurrentbattery_tmp; //    
	}

byte SLG_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm) //   
	{
	byte currentparameters_tmp=0; // 
	switch(indxparameters_prm) // 
		{
		case FALSE: currentparameters_tmp=alter_slg.currentstatusprocess[indxnumberbattery_prm]; //   
					break;
		case TRUE: currentparameters_tmp=alter_slg.numbercellsbattery[indxnumberbattery_prm]; //    
		}
	return currentparameters_tmp; //  
	}

void SLG_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm) //       
	{
	alter_slg.countercyclesalgorithm[indxnumberbattery_prm]=datadeferred_prm; //    
	alter_slg.currentstatusprocess[indxnumberbattery_prm]=statusdeferred_prm; //  
	}

byte SLG_ReadcurrentAlgorithm(bit indxnumberbattery_prm) //       
	{
	return alter_slg.countercyclesalgorithm[indxnumberbattery_prm]; //    
	}

bit SLG_ReadindxUpdatig(bit indxnumberbattery_prm) //     
	{
	bit indxupdatingdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indxupdatingdata_tmp=indx_slg.updatingfirstdata; //      1
					break;
		case TRUE: indxupdatingdata_tmp=indx_slg.updatingseconddata; //      2
		}
	return indxupdatingdata_tmp;
	}

word SLG_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm) //     
	{
	dword currentvaluepower_tmp=0; // 
	currentvaluepower_tmp=(dword)measuredcurrentbattery_prm*(dword)measuredvoltagebattery_prm/1000; //  
	return (word)currentvaluepower_tmp; //   
	}















