/**************************************************************
* Slagroupbattery.h
*      
* : 03.03.2023 17:49:55
* :  .
***************************************************************/

#pragma once

#include "Main.h"

#define SLGMINBATT_VOLTAGE 1850 //       
#define SLGMINFINAL_VOLTAGE 1800 //     
#define SLGMAXBATT_VOLTAGE 2300 //       
#define SLGMAXFINAL_VOLTAGE 2400 //     
#define SLGMINLOAD_VOLTAGE 1700 //   
#define SLGMAXLOAD_VOLTAGE 2500 //    
#define SLGMAXLIMIT_CURRENT 2300 //   /
#define SLGMINLIMIT_CURRENT 10 //   /
#define SLGMAXPOWER_CHARGE 8000 //     
#define SLGMAXPOWER_DISCHARGE 10000 //     

typedef struct
{
bit updatingfirstdata:1; //      1
bit updatingseconddata:1; //      2
}bit_slg;

typedef struct
{
byte countergeneralusage[2]; //  
byte countercyclesalgorithm[2]; //    / 
byte currentstatusprocess[2]; //     1[0]  2[1]
byte currentmethodbattery[2]; //     1[0]  2[1]
word numbercellsbattery[2]; //     1[0]  2[1]
word limitfirstparameters[4]; //   ,     1
word limitsecondparameters[4]; //   ,     2
}var_slg;

void SLG_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm,byte currentmethodbattery_prm,word numberbatterysources_prm); //   
void SLG_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void SLG_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void SLG_ResetVariables(bit indxnumberbattery_prm); //  
void SLG_WritedataAlgorithm(bit indxnumberbattery_prm,byte datadeferred_prm,byte statusdeferred_prm); //      
bit SLG_ReadindxUpdatig(bit indxnumberbattery_prm); //     
byte SLG_ReadcurrentAlgorithm(bit indxnumberbattery_prm); //       
byte SLG_ReadcurrentStatus(bit indxnumberbattery_prm,bit indxparameters_prm); //   
word SLG_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word SLG_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word SLG_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word SLG_ChargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word SLG_DischargingCurrent(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word SLG_DefinitionPower(word measuredcurrentbattery_prm,word measuredvoltagebattery_prm); //      













