/***********************************************
* Systemcontrol.c
*     
* : 10.06.2022 17:39:18
* :  .
************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <math.h>
#include "Main.h"
#include "Systemcontrol.h"
#include "Operatingmode.h"
#include "Calibrationmode.h"
#include "Marksensors.h"

var_sys alter_sys={0,1}; // 

EEMEM static word Sys_MaschineCycle=0; //      
EEMEM static word Sys_HalfperiodBeep=0; //        
EEMEM static dword Sys_FrequencyPiezo=SYSFREQU_PIEZO; //  

void SYS_TimeWaiting(word milliseconds_prm) //    
	{
	word milliseconds_tmp; // 
	milliseconds_tmp=milliseconds_prm; //  
	while(milliseconds_tmp>0) //   
		{
		_delay_loop_2(4000); // 1    
		milliseconds_tmp--; //  
		}
	}

void SYS_InitializeBeep(void) //   
	{
	dword halfperiodbeep_tmp; // 
	dword maschinecycle_tmp;
	if(eeprom_read_word(&Sys_HalfperiodBeep)==0) //   
		{
		maschinecycle_tmp=400000/(SYSFREQU_CRYSTAL/1000); //      
		halfperiodbeep_tmp=50000000/eeprom_read_dword(&Sys_FrequencyPiezo); //    
		halfperiodbeep_tmp/=maschinecycle_tmp; //       
		eeprom_write_word(&Sys_MaschineCycle,(word)maschinecycle_tmp); //       
		eeprom_write_word(&Sys_HalfperiodBeep,(word)halfperiodbeep_tmp); //        
		}
	}

void SYS_OutsignalBeep(byte durationofbeep_prm,byte numbersignals_prm) //         
	{
	byte numbersignals_tmp=0; // 
	byte durationofbeep_tmp=0; 
	word halfperiodbeep_tmp=0; 
	dword countduration_tmp;
	numbersignals_tmp=numbersignals_prm; //  
	halfperiodbeep_tmp=eeprom_read_word(&Sys_HalfperiodBeep); //    
	durationofbeep_tmp=durationofbeep_prm*50000/halfperiodbeep_tmp/eeprom_read_word(&Sys_MaschineCycle); //   
	countduration_tmp=durationofbeep_tmp; //     
	while(numbersignals_tmp>0) //    
		{
		while(countduration_tmp>0) //    
			{
			SetBit(SYSCONTROL_BEEP,SYSOUTBIT_BEEP); //      
			_delay_loop_2(halfperiodbeep_tmp); //      
			ClearBit(SYSCONTROL_BEEP,SYSOUTBIT_BEEP); //      
			_delay_loop_2(halfperiodbeep_tmp); //      
			countduration_tmp--; //    
			}
		numbersignals_tmp--; //  
		if(numbersignals_tmp>0) //     
			{
			SYS_TimeWaiting(30); // 30  
			countduration_tmp=durationofbeep_tmp; //       
			}
		}
	}

void SYS_InitializePwmcontrol(void) //   
	{
	TCNT0=0; // 0
	TCNT1=0; // 1
	TCNT2=0; // 2 
	TCNT3=0; // 3 
	OCR0=254; //   0 (   1) 
	TCCR0=105; // 0 FastPWM       F_CPU 
	TCCR2=2; // 2 Normal    F_CPU/8 
	OCR1A=255; //   A 1 (  2)
	OCR1B=255; //   B 1 (  1) 
	OCR1C=10; //   C 1 ( ) 
	TCCR1A=169; // 1 FastPWM 8       OC1A,OC1B,OCR1C 
	TCCR1B=9; // 1   F_CPU 
	OCR3A=0; //   A 3 (  1) 
	OCR3B=0; //   B 3 (  2) 
	OCR3C=1020; //   C 3 (   2)
	TCCR3A=171; // 3 FastPWM 10       OC3A,OC3B,OCR3C 
	TCCR3B=9; // 3   F_CPU
	}

void SYS_MainMode(void) //   
	{
	bit indxupdatestring_tmp=FALSE; // 
	if(alter_sys.updatelinemode==1) //     
		{
		indxupdatestring_tmp=TRUE; //       
		alter_sys.updatelinemode=0; //     
		}
	switch(alter_sys.counteroperating) //   
		{
		case 0: OPR_MainMode(indxupdatestring_tmp); //    
				break;
		case 1: CAL_MainMode(indxupdatestring_tmp); //   
				break;
		case 2: MSN_MainMode(indxupdatestring_tmp); //   
		}
	}

void SYS_SwitchWorkmode(void) //   
	{
	alter_sys.counteroperating++; //  
	if(alter_sys.counteroperating>2) alter_sys.counteroperating=0; //    
	alter_sys.updatelinemode=1; //      
	}













