/****************************************************************************
* Multicharger.c
* : 06.12.2022 21:21:53
* :  .
* :     v_2.3
* : ATMega128A
*  : 16000000 
*  :
* FuseHB=CF:
			OCDEN=1;   
			JTAGEN=1;  JTAG  
			SPIEN=0;  SPI 
			CKOPT=0;   
			EESAVE=1;   EEPROM 
			BOOTSZ1=1;    
			BOOTSZ0=1;    
			BOOTRST=1;      
* FuseLB=BF:
			BODLEVEL=0;   BOD 2,7 
			BODEN=0;   BOD
			SUT1-0=11;    
			CKSEL3-0=1111;    8   
* FuseExtB=FF:
			M103C=1;   
			WDTON=1;   
*******************************************************************************/

#include <avr/io.h>
#include "Main.h"
#include "Lcdworkunit.h"
#include "Symbolout.h"
#include "Systemcontrol.h"
#include "Adconverter.h"
#include "Owids18b20.h"

int main(void)
	{
	DDRA=0; // 
	PORTA=8; // PA3   
	DDRB=240; //PB4-PB7 ,  
	PORTB=98; // PB4,PB7 .0,  PB5,PB6 .1, PB1  
	DDRC=241; //PC0,PC4-PC7 ,  
	PORTC=8; // PC0,PC4-PC7 .0, PC3   
	DDRD=239; //PD4 ,  
	PORTD=15; // PD0-PD3 .1,   .0
	DDRF=0; // 
	PORTF=0;
	DDRE=56; //PE3-PE5 ,  
	PORTE=2; // PE3-PE5 .0, PE1  
	DDRG=0; // 
	PORTG=0;
	LCD_InitializeDevice(); // LCD
	SYS_InitializeBeep(); //  
	ADC_InitializeDevice(); // 
	OWI_InitializeBuses(); //  1-wire   
	SYS_InitializePwmcontrol(); //  
	SYM_LoadingDegrees(); //  
	SYM_MessageOutword(0); // :  v_2.3 2023
	SYS_TimeWaiting(2000); // 2 
	SYS_OutsignalBeep(50,1); //    50  
	
    while(1) 
		{
		SYS_MainMode(); //  
		}
	}

