/************************************
* Operatingmode.c
*    
* : 02.11.2021 20:02:56
* :  .
*************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>
#include <avr/wdt.h>
#include "Main.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"
#include "Symbolout.h"
#include "Adconverter.h"
#include "Keybuttscan.h"
#include "Nigroupbattery.h"
#include "Nimhbattery.h"
#include "Nicdbattery.h"
#include "Niznbattery.h"
#include "Owids18b20.h"
#include "Lithiumgroup.h"
#include "Lipobattery.h"
#include "Lionbattery.h"
#include "Limnbattery.h"
#include "Licobattery.h"
#include "Lincabattery.h"
#include "Linmcbattery.h"
#include "Liferrumgroup.h"
#include "Lifebattery.h"
#include "Lifepobattery.h"
#include "Litibattery.h"
#include "Nimh2battery.h"
#include "Nimh3battery.h"
#include "Nimh4battery.h"
#include "Nimh5battery.h"
#include "Nimh6battery.h"
#include "Nimh7battery.h"
#include "Nimh8battery.h"
#include "Slagroupbattery.h"
#include "Sla2battery.h"
#include "Sla4battery.h"
#include "Sla6battery.h"
#include "Sla12battery.h"

bit_opr indx_opr={0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // 
var_opr alter_opr={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{1,1},0,0,{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{100,100},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; // 

EEMEM static byte Opr_IndxonlyCharging[2]={0,0}; //    
EEMEM static byte Opr_IndxfullCharging[2]={0,0}; //    /  
EEMEM static byte Opr_IndxoutDeferred[2]={0,0}; //    
EEMEM static byte Opr_TypemodeBattery[5][2]={{0,0},{0,0},{0,0},{0,0},{0,0}}; // , , ,        
EEMEM static word Opr_ParametersDeferred[6][2]={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; //   
EEMEM static word Opr_DataitemsProtocol[19][2]={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; //     
EEMEM static word Opr_SettingCapacity[2]={0,0}; //   
EEMEM static dword Opr_SummaChargedischarge[2]={0,0}; // /  /  
EEMEM static byte Opr_OnlychargeEmergency[2]={0,0}; //     
EEMEM static byte Opr_FullchargeEmergency[2]={0,0}; //     /  
EEMEM static byte Opr_IndxoutEmergency[2]={0,0}; //     
EEMEM static byte Opr_TypemodeEmergency[5][2]={{0,0},{0,0},{0,0},{0,0},{0,0}}; //  , , ,        
EEMEM static word Opr_ParametersEmergency[7][2]={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; //    
EEMEM static dword Opr_SummchargeEmergency[2]={0,0}; //  /   

ISR(TIMER2_OVF_vect) //     2
	{
	alter_opr.counterinterrupt++; //     128  
	if(alter_opr.counterinterrupt>=6250) //     0,8  
		{
		alter_opr.counterinterrupt=0; //  
		indx_opr.startingworkcycle=TRUE; //      
		wdt_reset(); //   
		}
	if(bit_is_clear(OPRPORT_ACDETECT,OPRBITAC220_DETECT)) indx_opr.emergencycasenoac=TRUE; //       220   
	}

void OPR_StartstopWorkcycle(bit indxstartstop_prm) //       
	{
	switch(indxstartstop_prm) //  /
		{
		case FALSE: if(indx_opr.onoffworkingservice==TRUE) //      
						{
						cli(); //  
						ClearBit(TIMSK,TOIE2); //    2 
						indx_opr.onoffworkingservice=FALSE; //     
						wdt_disable(); //  
						}
					break;
		case TRUE: if(indx_opr.onoffworkingservice==FALSE) //       
						{
						alter_opr.counterinterrupt=0; //   
						indx_opr.onoffworkingservice=TRUE; //      
						wdt_reset(); //   
						wdt_enable(WDTO_1S); //      1  
						TCNT2=0; // 2
						SetBit(TIMSK,TOIE2); //    2
						sei(); //  
						}
		}
	}

void OPR_MainMode(bit indxupdateline_prm) //      
	{
	byte datacodecontrol_tmp=0; //  
	if(indx_opr.emergencycasenoac==FALSE) //    220    
		{
		if(indxupdateline_prm==TRUE) indx_opr.updatetextstring=TRUE; //         
		datacodecontrol_tmp=KEY_DecoderButton(); //  
		if(datacodecontrol_tmp>0) OPR_ControlWorkcycle(datacodecontrol_tmp); //    
		switch(alter_opr.counterworkcycle[indx_opr.processnumber]) //        
			{
			case 0: OPR_SettingParameters(); //     
					break;
			case 1: OPR_SearchconnectBattery(); //   
					break;
			case 2: OPR_NotconnectBattery(); //   
					break;
			case 3: OPR_DefineModeservice(); //        
					break;
			case 4: OPR_OperationalBattery(); //   
					break;
			case 5: OPR_CancellOperational(); //    
					break;
			case 6: OPR_CompleteOperational(); //    
			}
		switch(indx_opr.processnumber) //     
			{
			case FALSE: indx_opr.processnumber=TRUE; //    2 
						break;
			case TRUE: indx_opr.processnumber=FALSE; //    1 
			}
		SYM_CursorPosition(alter_opr.locationcursorline[indx_opr.settingnumber]); //   
		OPR_WorkcycleService(); //   
		SYS_TimeWaiting(10); // 10 
		}
	else //        220 
		{
		OPR_StartstopWorkcycle(FALSE); //   
		if(indx_opr.startfirstservices==TRUE) OPR_WritevalueEmergency(FALSE); //     1      
		if(indx_opr.startsecondservices==TRUE) OPR_WritevalueEmergency(TRUE); //     2      
		OPR_ResetVariables(); //  
		}
	}

void OPR_SettingParameters(void) //    
	{
	bit indxcorrectpolarity_tmp=FALSE; //  
	if(bit_is_set(OPRPORT_ACDETECT,OPRBITAC220_DETECT)) indxcorrectpolarity_tmp=OPR_ControlPolarity(); //      
	if((indx_opr.updatetextstring==TRUE)&&(indx_opr.processnumber==indx_opr.settingnumber)&&(indx_opr.prioritycomplete==FALSE)&&(indxcorrectpolarity_tmp==FALSE)) //    ,   ,       
		{
		indx_opr.updatetextstring=FALSE; //  
		switch(alter_opr.counteroutitems[indx_opr.processnumber]) //    
			{
			case 0: OPR_OutitemBatterytype(); //     
					break;
			case 1: SYM_ByteLineout(indx_opr.settingnumber,4,27,37,0,0); //     : :      
					SYM_OutdataNumber0000(alter_opr.settcapacitybattery[indx_opr.processnumber],8); //     100 
					break; 
			case 2: OPR_OutitemBatterymode(); //     
					break;
			case 3: OPR_OutitemBatterymethod(); //     
					break;
			case 4: SYM_WordLineout(indx_opr.processnumber,9,1); //    : : 
					if(((indx_opr.startsecondservices==TRUE)&&(indx_opr.processnumber==TRUE))||((indx_opr.startfirstservices==TRUE)&&(indx_opr.processnumber==FALSE))) //      
						{
						OPR_SettpermitControl(indx_opr.processnumber,FALSE,TRUE); //    
						alter_opr.counterworkcycle[indx_opr.processnumber]++; //       
						indx_opr.updatetextstring=TRUE; //     
						}
					break;
			case 5: switch(indx_opr.processnumber) //      
						{
						case FALSE: switch(indx_opr.outputfirstprotocol) //    1 
										{
										case FALSE: SYM_WordLineout(FALSE,22,1); //  : :  
													break;
										case TRUE: OPR_OutputitemsProtocol(FALSE); //    1 
										}
									break;
						case TRUE: switch(indx_opr.outputsecondprotocol) //    2 
										{
										case FALSE: SYM_WordLineout(TRUE,22,1); //  : : 
													break;
										case TRUE: OPR_OutputitemsProtocol(TRUE); //    2
										}
						} 
			}
		}
	}

bit OPR_ControlPolarity(void) //     
	{
	static bit indxfixationpolarity_tmp=FALSE; //  
	bit indxcorrectpolarity_tmp=FALSE; 
	if((indx_opr.startfirstservices==FALSE)||(indx_opr.startsecondservices==FALSE)) //     1  2  
		{
		if((bit_is_set(OPRONOFF_PORTCONTROL,OPRCONTROL_POLARITY))&&(indxfixationpolarity_tmp==FALSE)) //          
			{
			indxfixationpolarity_tmp=TRUE; //    
			SYM_WordLineout(FALSE,24,0); // : : ! 
			}
		else if((bit_is_clear(OPRONOFF_PORTCONTROL,OPRCONTROL_POLARITY))&&(indxfixationpolarity_tmp==TRUE)) //        
			{
			indxfixationpolarity_tmp=FALSE; //    
			if(indx_opr.updatetextstring==FALSE) indx_opr.updatetextstring=TRUE; //       
			}
		if(indxfixationpolarity_tmp==TRUE) //     
			{
			indxcorrectpolarity_tmp=TRUE; //          
			SYS_OutsignalBeep(10,2); //     10  
			}
		}
	return indxcorrectpolarity_tmp; //   
	}

void OPR_SearchtypesBattery(bit indxnumberbattery_prm) //      
	{
	bit indxendsearch_tmp=FALSE; // 
	byte countersensors_tmp=0;
	byte numbersensors_tmp=0;
	byte numbertypebattery_tmp=0;
	countersensors_tmp=1; //    
	numbertypebattery_tmp=30; //        
	SYM_WordLineout(indxnumberbattery_prm,10,1); // : : 
	while(indxendsearch_tmp==FALSE) //   
		{
		numbersensors_tmp=OPR_SearchnumberSensors(countersensors_tmp,1); //    
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: switch(numbersensors_tmp) //     1
							{
							case 1 ... 4: numbertypebattery_tmp=0; // Ni-Mh 
									break;
							case 9 ... 10: numbertypebattery_tmp=1; // Ni-Cd 
									break;
							case 13: numbertypebattery_tmp=2; // 2Ni-Mh 
									break;
							case 15: numbertypebattery_tmp=3; // 3Ni-Mh 
									break;
							case 17: numbertypebattery_tmp=4; // 4Ni-Mh 
									break;
							case 19: numbertypebattery_tmp=5; // 5Ni-Mh 
									break;
							case 21: numbertypebattery_tmp=6; // 6Ni-Mh 
									break;
							case 23: numbertypebattery_tmp=7; // 7Ni-Mh 
									break;
							case 25: numbertypebattery_tmp=8; // 8Ni-Mh 
									break;
							case 27 ... 28: numbertypebattery_tmp=9; // Ni-Zn 
									break;
							case 31 ... 35: numbertypebattery_tmp=10; // Li-Po 
									break;
							case 41 ... 45: numbertypebattery_tmp=11; // Li-Ion 
									break;
							case 51 ... 53: numbertypebattery_tmp=12; // Li-Mn 
									break;
							case 57 ... 59: numbertypebattery_tmp=13; // Li-Co 
									break;
							case 63 ... 65: numbertypebattery_tmp=14; // Li-Nca 
									break;
							case 69 ... 71: numbertypebattery_tmp=15; // Li-Nmc 
									break;
							case 75 ... 77: numbertypebattery_tmp=16; // Li-Ti 
									break;
							case 81 ... 83: numbertypebattery_tmp=17; // Li-Fe 
									break;
							case 87: numbertypebattery_tmp=18; // LiFePo4 
									break;
							case 89: numbertypebattery_tmp=19; // Sla-2v 
									break;
							case 91: numbertypebattery_tmp=20; // Sla-4v 
									break;
							case 93: numbertypebattery_tmp=21; // Sla-6v 
									break;
							case 95: numbertypebattery_tmp=22; // Sla-12v 
							}
						if(numbertypebattery_tmp<=22) indxendsearch_tmp=TRUE; //          
						break;
			case TRUE: switch(numbersensors_tmp) //     2 
							{
							case 5 ... 8: numbertypebattery_tmp=0; // Ni-Mh 
									break;
							case 11 ... 12: numbertypebattery_tmp=1; // Ni-Cd 
									break;
							case 14: numbertypebattery_tmp=2; // 2Ni-Mh 
									break;
							case 16: numbertypebattery_tmp=3; // 3Ni-Mh 
									break;
							case 18: numbertypebattery_tmp=4; // 4Ni-Mh 
									break;
							case 20: numbertypebattery_tmp=5; // 5Ni-Mh 
									break;
							case 22: numbertypebattery_tmp=6; // 6Ni-Mh 
									break;
							case 24: numbertypebattery_tmp=7; // 7Ni-Mh 
									break;
							case 26: numbertypebattery_tmp=8; // 8Ni-Mh 
									break;
							case 29 ... 30: numbertypebattery_tmp=9; // Ni-Zn 
									break;
							case 36 ... 40: numbertypebattery_tmp=10; // Li-Po 
									break;
							case 46 ... 50: numbertypebattery_tmp=11; // Li-Ion 
									break;
							case 54 ... 56: numbertypebattery_tmp=12; // Li-Mn 
									break;
							case 60 ... 62: numbertypebattery_tmp=13; // Li-Co 
									break;
							case 66 ... 68: numbertypebattery_tmp=14; // Li-Nca 
									break;
							case 72 ... 74: numbertypebattery_tmp=15; // Li-Nmc 
									break;
							case 78 ... 80: numbertypebattery_tmp=16; // Li-Ti 
									break;
							case 84 ... 86: numbertypebattery_tmp=17; // Li-Fe 
									break;
							case 88: numbertypebattery_tmp=18; // LiFePo4 
									break;
							case 90: numbertypebattery_tmp=19; // Sla-2v 
									break;
							case 92: numbertypebattery_tmp=20; // Sla-4v 
									break;
							case 94: numbertypebattery_tmp=21; // Sla-6v 
									break;
							case 96: numbertypebattery_tmp=22; // Sla-12v 
							}
						if(numbertypebattery_tmp<=22) indxendsearch_tmp=TRUE; //          
			}
		if(indxendsearch_tmp==TRUE) alter_opr.countertypebattery[indxnumberbattery_prm]=numbertypebattery_tmp; //       
		else //     
			{
			countersensors_tmp++; //   
			if(countersensors_tmp>OPRMAXTYPES_BATTERY) //    
				{
				alter_opr.countertypebattery[indxnumberbattery_prm]=0; //    
				indxendsearch_tmp=TRUE; //      
				}
			}
		}
	}

void OPR_SearchconnectBattery(void) //   
	{
	bit indxconnectbattery_tmp=0; // 
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(indx_opr.updatetextstring==TRUE) //    
			{
			indx_opr.updatetextstring=FALSE; // 
			SYM_WordLineout(indx_opr.processnumber,10,1); // : : 
			}
		indxconnectbattery_tmp=OPR_DetectconnectBattery(); //  
		if(indxconnectbattery_tmp==TRUE) //     
			{
			if(alter_opr.countgeneralpurpose[0]<34) alter_opr.countgeneralpurpose[0]++; //    2      
			else //   
				{
				OPR_SettpermitControl(indx_opr.processnumber,FALSE,FALSE); //    
				while(OWI_MeasuredTemperature(TRUE,alter_opr.datanumbersensors[indx_opr.processnumber])>=1360) //        
				alter_opr.countgeneralpurpose[0]=0; //   
				alter_opr.counterworkcycle[indx_opr.processnumber]=3; //      
				SYS_OutsignalBeep(10,2); //     10 
				}
			}
		else //   
			{
			if(alter_opr.countgeneralpurpose[0]<34) alter_opr.countgeneralpurpose[0]++; //      2 
			else //   
				{
				alter_opr.countgeneralpurpose[0]=0; //   
				alter_opr.counterworkcycle[indx_opr.processnumber]++; //         
				indx_opr.updatetextstring=TRUE; //   
				}
			}
		}
	}

void OPR_NotconnectBattery(void) //    
	{
	bit indxconnectbattery_tmp=0; // 
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(indx_opr.updatetextstring==TRUE) //    
			{
			indx_opr.updatetextstring=FALSE; // 
			SYM_WordLineout(indx_opr.processnumber,15,1); // : : 
			}
		indxconnectbattery_tmp=OPR_DetectconnectBattery(); //  
		if(indxconnectbattery_tmp==TRUE) //  
			{
			OPR_SettpermitControl(indx_opr.processnumber,FALSE,FALSE); //    
			alter_opr.countgeneralpurpose[0]=0; //    1 
			alter_opr.countgeneralpurpose[1]=0; //    2 
			alter_opr.counterworkcycle[indx_opr.processnumber]++; //      
			}
		else //   
			{
			if(alter_opr.countgeneralpurpose[0]<167) //     10  
				{
				if(alter_opr.countgeneralpurpose[1]<8) alter_opr.countgeneralpurpose[1]++; //    
				else //    
					{
					SYS_OutsignalBeep(10,4); //     10 
					alter_opr.countgeneralpurpose[1]=0; //    
					}
				alter_opr.countgeneralpurpose[0]++; //      
				}
			else //     
				{
				OPR_SettpermitControl(indx_opr.processnumber,FALSE,FALSE); //    
				OPR_ResetVariables(); //        
				}
			}
		}
	}

void OPR_SettingLimitvoltage(bit indxnumberbattery_prm) //   
	{
	word maxlimitvoltage_tmp=0; //  
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //   
		{
		case 0 ... 1: maxlimitvoltage_tmp=OPRMAXLIMIT_NIMHCD; //    Ni-Mh  Ni-Cd  
				break;
		case 2 ... 8: maxlimitvoltage_tmp=OPRMAXLIMIT_NIMHCD*(word)alter_opr.countertypebattery[indxnumberbattery_prm]; //     Ni-Mh  Ni-Cd  
				break;
		case 9: maxlimitvoltage_tmp=OPRMAXLIMIT_NIZN; //    Ni-Zn 
				break;
		case 10 ... 15: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM1; //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
				break;
		case 16: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM3; //    Li-Ti   
				break;
		case 17: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM2; //    Li-Fe  
				break;
		case 18: maxlimitvoltage_tmp=OPRMAXLIMIT_LIFEPO4; //    LiFePo4 
				break;
		case 19: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA2V; //    Sla-2v 
				break;
		case 20: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA4V; //    Sla-4v 
				break;
		case 21: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA6V; //    Sla-6v 
				break;
		case 22: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA12V; //    Sla-12v 
		}
	maxlimitvoltage_tmp=maxlimitvoltage_tmp+(maxlimitvoltage_tmp/20)+OPRADDLIMIT_VOLTAGE; //    
	maxlimitvoltage_tmp-=OPRMINOUT_VOLTAGE; //      
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: maxlimitvoltage_tmp/=OPRFIRSTVOLTAGE_RATIO; //      /    
					maxlimitvoltage_tmp+=OPRMINFIRST_SETTBYTE; //         
					OCR0=(byte)maxlimitvoltage_tmp; //     1    0 
					break;
		case TRUE: maxlimitvoltage_tmp/=OPRSECONDVOLTAGE_RATIO; //      /    
					maxlimitvoltage_tmp+=OPRMINSECOND_SETTBYTE; //         
					OCR3C=maxlimitvoltage_tmp; //     2    3 
		}
	}

void OPR_DefineModeservice(void) //    
	{
	switch(indx_opr.processnumber) //  
		{
		case FALSE: switch(alter_opr.countermodebattery[FALSE]) //    1
						{
						case 0: if(indx_opr.firstfullservice==FALSE) indx_opr.firstfullservice=TRUE; //    /
								if(indx_opr.firstchargedischarge==FALSE) indx_opr.firstchargedischarge=TRUE; //    
								OPR_SettpermitControl(FALSE,TRUE,TRUE); //      1 
								break;
						case 1: if(indx_opr.firstchargedischarge==FALSE) indx_opr.firstchargedischarge=TRUE; //    
								OPR_SettpermitControl(FALSE,TRUE,TRUE); //      1 
								break;
						case 2: if(indx_opr.firstchargedischarge==TRUE) indx_opr.firstchargedischarge=FALSE; //    
								OPR_SettpermitControl(FALSE,FALSE,TRUE); //       1 
								break;
						case 3 ... 4: asm("nop"); // 
						}
					if(indx_opr.firstchargedischarge==FALSE) OPR_SettingLimitvoltage(indx_opr.processnumber); //     1     
					indx_opr.connectfirstbattery=TRUE; //    1
					break;
		case TRUE: switch(alter_opr.countermodebattery[TRUE]) //    2
						{
						case 0: if(indx_opr.secondfullservice==FALSE) indx_opr.secondfullservice=TRUE; //    /
								if(indx_opr.secondchargedischarge==FALSE) indx_opr.secondchargedischarge=TRUE; //    
								OPR_SettpermitControl(TRUE,TRUE,TRUE); //      2 
								break;
						case 1: if(indx_opr.secondchargedischarge==FALSE) indx_opr.secondchargedischarge=TRUE; //    
								OPR_SettpermitControl(TRUE,TRUE,TRUE); //       2 
								break;
						case 2: if(indx_opr.secondchargedischarge==TRUE) indx_opr.secondchargedischarge=FALSE; //    
								OPR_SettpermitControl(TRUE,FALSE,TRUE); //       2 
								break;
						case 3 ... 4: asm("nop"); //  
						}
					if(indx_opr.secondchargedischarge==FALSE) OPR_SettingLimitvoltage(indx_opr.processnumber); //     2    
					indx_opr.connectsecondbattery=TRUE; //    2
		}
	OPR_StartstopWorkcycle(TRUE); //        
	indx_opr.updatetextstring=TRUE; //    
	indx_opr.updateparameters=TRUE; //    
	alter_opr.counterworkcycle[indx_opr.processnumber]++; //       
	}

void OPR_OperationalBattery(void) //     
	{
	if((indx_opr.firstviolacontact==FALSE)&&(indx_opr.secondviolacontact==FALSE)&&(indx_opr.prioritycomplete==FALSE)) //         
		{
		if(indx_opr.processnumber==indx_opr.settingnumber) //     
			{
			if(indx_opr.updatetextstring==TRUE) //     
				{
				indx_opr.updatetextstring=FALSE; // 
				OPR_OutserviceBatterymode(); //    
				}
			if(indx_opr.updateparameters==TRUE) //    
				{
				indx_opr.updateparameters=FALSE; // 
				OPR_OutserviceParameters(); //     
				}
			}
		}
	else if(((indx_opr.firstviolacontact==TRUE)||(indx_opr.secondviolacontact==TRUE))&&(indx_opr.prioritycomplete==FALSE)) OPR_NocontactBattery(); //               
	if((indx_opr.processnumber==FALSE)&&(indx_opr.finishfirstonecycle==TRUE)&&(indx_opr.startfirstservices==TRUE)) //     1      
		{
		indx_opr.finishfirstonecycle=FALSE; //      
		alter_opr.settingcurrentbattery[FALSE]=OPR_MonitoringParameters(); //    1 
		if(alter_opr.settingcurrentbattery[FALSE]==0) indx_opr.startfirstservices=FALSE;  //         1       
		}
	else if((indx_opr.processnumber==FALSE)&&(indx_opr.finishfirstonecycle==FALSE)&&(indx_opr.startfirstservices==FALSE)) //    1  
		{
		if(indx_opr.prioritycomplete==FALSE) //      
			{
			indx_opr.prioritycomplete=TRUE; //         1 
			indx_opr.updatetextstring=TRUE; //    
			alter_opr.counterworkcycle[FALSE]+=2; //      1 
			}
		else asm("nop"); //     
		}
	if((indx_opr.processnumber==TRUE)&&(indx_opr.finishsecondonecycle==TRUE)&&(indx_opr.startsecondservices==TRUE)) //     2      
		{
		indx_opr.finishsecondonecycle=FALSE; //      
		alter_opr.settingcurrentbattery[TRUE]=OPR_MonitoringParameters(); //    2 
		if(alter_opr.settingcurrentbattery[TRUE]==0) indx_opr.startsecondservices=FALSE;  //         2       
		}
	else if((indx_opr.finishsecondonecycle==FALSE)&&(indx_opr.processnumber==TRUE)&&(indx_opr.startsecondservices==FALSE)) //    2  
		{
		if(indx_opr.prioritycomplete==FALSE) //      
			{
			indx_opr.prioritycomplete=TRUE; //         2
			indx_opr.updatetextstring=TRUE; //    
			alter_opr.counterworkcycle[TRUE]+=2; //      2 
			}
		else asm("nop"); //     
		}
	}

word OPR_MonitoringParameters(void) //      
	{
	word settingcurrentbattery_tmp=0; //  
	if(OPR_ControlStopindex()==TRUE) //        
		{
		SYM_WordLineout(indx_opr.settingnumber,13,1); // : :  
		indx_opr.updatetextstring=TRUE; //   
		alter_opr.counterworkcycle[indx_opr.processnumber]++; //      
		}
	else //   
		{
		switch(indx_opr.processnumber) //  
			{
			case FALSE: if(indx_opr.firstviolacontact==FALSE) //      1  
							{
							OPR_CalculationParameters(); //   , / ,     
							settingcurrentbattery_tmp=OPR_MonitoringTypebattery(); //     
							}
						else settingcurrentbattery_tmp=alter_opr.settingcurrentbattery[FALSE]; //         
						break;
			case TRUE: if(indx_opr.secondviolacontact==FALSE) //      2  
							{
							OPR_CalculationParameters(); //   , / ,     
							settingcurrentbattery_tmp=OPR_MonitoringTypebattery(); //     
							}
						else settingcurrentbattery_tmp=alter_opr.settingcurrentbattery[TRUE]; //         
			}
		indx_opr.updateparameters=TRUE; //    
		}
	return settingcurrentbattery_tmp; //         
	}

word OPR_MonitoringTypebattery(void) //      
	{
	bit indxchargedischarge_tmp=FALSE; //  
	bit indxonlycharging_tmp=FALSE; 
	word currentstatus_tmp=0; 
	word settingcurrentbattery_tmp=0; 
	switch(indx_opr.processnumber) //  
		{
		case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1 
					indxonlycharging_tmp=indx_opr.onlyfirstcharging; //     1 
					break;
		case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2 
					indxonlycharging_tmp=indx_opr.onlysecondcharging; //     2 
		}
	switch(alter_opr.countertypebattery[indx_opr.processnumber]) //    
		{
		case 0 ... 8: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //    
							{
							case 0: settingcurrentbattery_tmp=NMH_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Ni-Mh  
									break;
							case 1: settingcurrentbattery_tmp=NCD_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Ni-Cd 
									break;
							case 2: settingcurrentbattery_tmp=NM2_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      2- Ni-Mh 
									break;
							case 3: settingcurrentbattery_tmp=NM3_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      3- Ni-Mh 
									break;
							case 4: settingcurrentbattery_tmp=NM4_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      4- Ni-Mh 
									break;
							case 5: settingcurrentbattery_tmp=NM5_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      5- Ni-Mh 
									break;
							case 6: settingcurrentbattery_tmp=NM6_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      6- Ni-Mh 
									break;
							case 7: settingcurrentbattery_tmp=NM7_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      7- Ni-Mh 
									break;
							case 8: settingcurrentbattery_tmp=NM8_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //      8- Ni-Mh 
							}
					currentstatus_tmp=NGR_ReadcurrentStatus(indx_opr.processnumber,0); //  
					alter_opr.increaseratevoltage[indx_opr.processnumber]=NGR_ReadcurrentStatus(indx_opr.processnumber,1); //    
					alter_opr.increasetemperature[indx_opr.processnumber]=NGR_ReadcurrentStatus(indx_opr.processnumber,2); //    
					alter_opr.numbercellsbattery[indx_opr.processnumber]=NGR_ReadcurrentStatus(indx_opr.processnumber,3); //     
				break;
		case 9: settingcurrentbattery_tmp=NZN_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Ni-Zn 
				currentstatus_tmp=NZN_ReadcurrentStatus(indx_opr.processnumber,FALSE); //  
				alter_opr.numbercellsbattery[indx_opr.processnumber]=(word)NZN_ReadcurrentStatus(indx_opr.processnumber,TRUE); //     
				break;
		case 10 ... 15: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //    
							{
							case 10: settingcurrentbattery_tmp=LPO_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Po 
									break;
							case 11: settingcurrentbattery_tmp=LIO_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Ion 
									break;
							case 12: settingcurrentbattery_tmp=LMN_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Mn 
									break;
							case 13: settingcurrentbattery_tmp=LCO_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Co 
									break;
							case 14: settingcurrentbattery_tmp=LCA_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Nca 
									break;
							case 15: settingcurrentbattery_tmp=LMC_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Nmc 
							}
					currentstatus_tmp=LGR_ReadcurrentStatus(indx_opr.processnumber,FALSE); //   
					alter_opr.numbercellsbattery[indx_opr.processnumber]=(word)LGR_ReadcurrentStatus(indx_opr.processnumber,TRUE); //     
				break;
		case 16: settingcurrentbattery_tmp=LTI_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Ti 
				currentstatus_tmp=LTI_ReadcurrentStatus(indx_opr.processnumber,FALSE); //  
				alter_opr.numbercellsbattery[indx_opr.processnumber]=(word)LTI_ReadcurrentStatus(indx_opr.processnumber,TRUE); //     
				break;
		case 17 ... 18: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //   
							{
							case 17: settingcurrentbattery_tmp=LFE_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Fe 
									break;
							case 18: settingcurrentbattery_tmp=LFP_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   LiFePo4 
							}
				currentstatus_tmp=LFG_ReadcurrentStatus(indx_opr.processnumber,FALSE); //   
				alter_opr.numbercellsbattery[indx_opr.processnumber]=(word)LFG_ReadcurrentStatus(indx_opr.processnumber,TRUE); //     
				break;
		case 19 ... 22: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //   
							{
							case 19: settingcurrentbattery_tmp=SL1_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Sla-2v 
									break;
							case 20: settingcurrentbattery_tmp=SL2_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Sla-4v 
									break; 
							case 21: settingcurrentbattery_tmp=SL3_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Sla-6v 
									break; 
							case 22: settingcurrentbattery_tmp=SL6_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Sla-12v 
							}
				currentstatus_tmp=SLG_ReadcurrentStatus(indx_opr.processnumber,FALSE); //  
				alter_opr.numbercellsbattery[indx_opr.processnumber]=(word)SLG_ReadcurrentStatus(indx_opr.processnumber,TRUE); //     
		}
	if(currentstatus_tmp!=alter_opr.currentstatusprocess[indx_opr.processnumber]) //     
		{
		indx_opr.updatetextstring=TRUE; //   
		alter_opr.currentstatusprocess[indx_opr.processnumber]=(byte)currentstatus_tmp; //  
		}
	return settingcurrentbattery_tmp; //     
	}

void OPR_CancellOperational() //     
	{
	bit indxconnectbattery_tmp=FALSE; //  
	if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.onoffworkingservice==TRUE)) OPR_StartstopWorkcycle(FALSE); //        
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(alter_opr.countgeneralpurpose[0]<70) alter_opr.countgeneralpurpose[0]++; //      2 
		else //  
			{
			indxconnectbattery_tmp=OPR_DetectconnectBattery(); //   
			if(indxconnectbattery_tmp==FALSE) //  
				{
				switch(indx_opr.settingnumber) //   
					{
					case FALSE: OPR_SettpermitControl(FALSE,FALSE,FALSE); //      1 
								break;
					case TRUE: OPR_SettpermitControl(TRUE,FALSE,FALSE); //      2 
					}
				SYS_OutsignalBeep(10,2); //     10  
				OPR_ResetVariables(); //  
				}
			else //   
				{
				if(indx_opr.updatetextstring==TRUE) //     
					{
					indx_opr.updatetextstring=FALSE; // 
					SYM_WordLineout(indx_opr.settingnumber,14,1); // : : 
					}
				if(alter_opr.countgeneralpurpose[1]<8) alter_opr.countgeneralpurpose[1]++; //     
				else //    
					{
					SYS_OutsignalBeep(10,4); //     10  
					alter_opr.countgeneralpurpose[1]=0; //     
					}
				}
			}
		}
	}

void OPR_CompleteOperational(void) //      
	{
	if(alter_opr.countermodebattery[indx_opr.processnumber]==0) //    /
		{
		switch(indx_opr.processnumber) //  
			{
			case FALSE: OPR_SettpermitControl(FALSE,FALSE,FALSE); //      1 
						OPR_WritedataProtocol(FALSE); //      1
						indx_opr.startfirstservices=TRUE; //      1
						break;
			case TRUE: OPR_SettpermitControl(TRUE,FALSE,FALSE); //      2 
						OPR_WritedataProtocol(TRUE); //      2
						indx_opr.startsecondservices=TRUE; //      2
			}
		OPR_ResetExternaldata(indx_opr.processnumber); //      
		alter_opr.summachargebattery[indx_opr.processnumber]=0; //   / 
		alter_opr.initialvoltagebattery[indx_opr.processnumber]=0; //         
		alter_opr.maximumcurrentbattery[indx_opr.processnumber]=0; //         
		alter_opr.miniresistancebattery[indx_opr.processnumber]=0; //          
		alter_opr.maximumtemperature[indx_opr.processnumber]=0; //         
		alter_opr.maximumoverheating[indx_opr.processnumber]=0; //          
		alter_opr.countermodebattery[indx_opr.processnumber]=2; //          
		alter_opr.counterworkcycle[indx_opr.processnumber]=3; //           
		indx_opr.prioritycomplete=FALSE; //  
		}
	else //      
		{
		if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.onoffworkingservice==TRUE)) OPR_StartstopWorkcycle(FALSE); //        
		if((indx_opr.processnumber==FALSE)&&(indx_opr.startfirstservices==FALSE)&&(indx_opr.connectfirstbattery==TRUE)) //    1
			{
			if(indx_opr.updatetextstring==TRUE) //    
				{
				indx_opr.updatetextstring=FALSE; // 
				indx_opr.settingnumber=FALSE; //      
				switch(indx_opr.firstchargedischarge) //  /
					{
					case FALSE: OPR_WritedataProtocol(FALSE); //     1
								if(alter_opr.currentstatusprocess[FALSE]==4) SYM_WordLineout(FALSE,12,1); // : : 
								else if(alter_opr.currentstatusprocess[FALSE]==9) SYM_WordLineout(FALSE,16,1); // : : !
								break;
					case TRUE: OPR_WritedataProtocol(FALSE); //     1
								SYM_WordLineout(FALSE,11,1); // : : 
					}
				}
			OPR_DisconnectBattery(); //  
			}
		else if((indx_opr.processnumber==TRUE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.connectsecondbattery==TRUE)) //    2
			{
			if(indx_opr.updatetextstring==TRUE) //    
				{
				indx_opr.updatetextstring=FALSE; // 
				indx_opr.settingnumber=TRUE; //      
				switch(indx_opr.secondchargedischarge) //  /
					{
					case FALSE: OPR_WritedataProtocol(TRUE); //     2
								if(alter_opr.currentstatusprocess[TRUE]==4) SYM_WordLineout(TRUE,12,1); // : : 
								else if(alter_opr.currentstatusprocess[TRUE]==9) SYM_WordLineout(TRUE,16,1); // : : !
								break;
					case TRUE: OPR_WritedataProtocol(TRUE); //     2
								SYM_WordLineout(TRUE,11,1); // : : 
					}
				}
			OPR_DisconnectBattery(); //  
			}
		}
	}

void OPR_DisconnectBattery(void) //   
	{
	bit indxconnectbattery_tmp=FALSE; // 
	indxconnectbattery_tmp=OPR_DetectconnectBattery(); //  
	if(indxconnectbattery_tmp==FALSE) //  
		{
		indx_opr.prioritycomplete=FALSE; //   
		switch(indx_opr.settingnumber) //  
			{
			case FALSE: OPR_SettpermitControl(FALSE,FALSE,FALSE); //      1
						break;
			case TRUE: OPR_SettpermitControl(TRUE,FALSE,FALSE); //      2
			}
		SYS_OutsignalBeep(10,2); //     10 
		OPR_ResetVariables(); // 
		}
	else //   
		{
		if(alter_opr.countgeneralpurpose[0]<150) alter_opr.countgeneralpurpose[0]++; //     
		else //   
			{
			SYS_OutsignalBeep(10,4); //     10 
			alter_opr.countgeneralpurpose[0]=0; //   
			}
		}
	}

void OPR_NocontactBattery(void) //     
	{
	if(indx_opr.firstviolacontact==TRUE) OPR_NocontactMessage(FALSE); //          1
	else if(indx_opr.secondviolacontact==TRUE) OPR_NocontactMessage(TRUE); //          2
	}

void OPR_NocontactMessage(bit numberbattery_prm) //     
	{
	if(indx_opr.updatetextstring==TRUE) //    
		{
		indx_opr.updatetextstring=FALSE; //   
		indx_opr.settingnumber=numberbattery_prm; //    
		SYM_WordLineout(indx_opr.settingnumber,15,1); // : : 
		}
	if((indx_opr.stopfirstservices==FALSE)&&(indx_opr.stopsecondservices==FALSE)) //           
		{
		if(alter_opr.countgeneralpurpose[1]<16) alter_opr.countgeneralpurpose[1]++; //    
		else //   
			{
			SYS_OutsignalBeep(10,4); //     10 
			alter_opr.countgeneralpurpose[1]=0; //    
			}
		}
	
	}

bit OPR_ControlStopindex(void) //      
	{
	bit indxstoppostpone_tmp=FALSE; //  
	switch(indx_opr.processnumber) //   
		{
		case FALSE: if((indx_opr.stopfirstservices==TRUE)||(indx_opr.postponefirstservice==TRUE)) //        1 
						{
						if(indx_opr.postponefirstservice==TRUE) //      1 
							{
							indx_opr.postponefirstservice=FALSE; //  
							OPR_WritevalueDeferred(FALSE); //     1 
							}
						else if((indx_opr.stopfirstservices==TRUE)&&(indx_opr.firstviolacontact==TRUE)) //          1  
							{
							OPR_WritedataProtocol(FALSE); //     1 
							}
						indxstoppostpone_tmp=TRUE; //    
						}
					break;
		case TRUE: if((indx_opr.stopsecondservices==TRUE)||(indx_opr.postponesecondservice==TRUE)) //        2 
						{
						if(indx_opr.postponesecondservice==TRUE) //      2 
							{
							indx_opr.postponesecondservice=FALSE; //  
							OPR_WritevalueDeferred(TRUE); //     2 
							}
						else if((indx_opr.stopsecondservices==TRUE)&&(indx_opr.secondviolacontact==TRUE)) //          2  
							{
							OPR_WritedataProtocol(TRUE); //     2 
							}
						indxstoppostpone_tmp=TRUE; //    
						}
		}
	return indxstoppostpone_tmp; //  
	}

void OPR_WorkcycleService(void) //     
	{
	static bit indxfirstcontact_tmp=FALSE; //  
	static bit indxsecondcontact_tmp=FALSE; 
	word measurecurrentbattery_tmp=0; 
	if(indx_opr.startingworkcycle==TRUE) //      
		{
		indx_opr.startingworkcycle=FALSE; //  
		if((indx_opr.connectfirstbattery==TRUE)&&(indx_opr.startfirstservices==TRUE)) //  1     
			{
			switch(alter_opr.countercycleservice[FALSE]) //     1
				{
				case 0: if(alter_opr.settingcurrentbattery[FALSE]==0) alter_opr.settingcurrentbattery[FALSE]=1; //           
						switch(indx_opr.firstchargedischarge) // /
							{
							case FALSE: OPR_SmootCurrcharge(FALSE,FALSE,alter_opr.settingcurrentbattery[FALSE]); //   
										break;
							case TRUE: OPR_SmootCurrdischarge(FALSE,FALSE,alter_opr.settingcurrentbattery[FALSE]); //   
							}
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 1 ... 8: switch(indx_opr.firstchargedischarge) // /
								{
								case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=2; //         
											alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //   
											break;
								case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=2; //         
											alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //   
								}
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 9: alter_opr.measvoltageloadedbattery[FALSE]=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //    1
						switch(indx_opr.firstchargedischarge) // /
							{
							case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=2; //         
										alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[FALSE]>0) //    
											{
											OPR_SmootCurrcharge(FALSE,TRUE,alter_opr.settingcurrentbattery[FALSE]); //     
											}
										break;
							case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=2; //         
										alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[FALSE]>0) //    
											{
											OPR_SmootCurrdischarge(FALSE,TRUE,alter_opr.settingcurrentbattery[FALSE]); //      
											}
							}
						indxfirstcontact_tmp=OPR_ControlViolconnect(FALSE,measurecurrentbattery_tmp); //      1 
						OPR_StartConverting(FALSE,alter_opr.datanumbersensors[FALSE]); //    1 
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 10: alter_opr.measuredvoltagebattery[FALSE]=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //     1
						if(indx_opr.firstviolacontact!=indxfirstcontact_tmp) //        1 
							{
							indx_opr.firstviolacontact=indxfirstcontact_tmp; //   
							indx_opr.updatetextstring=TRUE; //    
							}
						alter_opr.countercycleservice[FALSE]=0; //    
						indx_opr.finishfirstonecycle=TRUE; //     
				}
			}
		if((indx_opr.connectsecondbattery==TRUE)&&(indx_opr.startsecondservices==TRUE)) //  2     
			{
			switch(alter_opr.countercycleservice[TRUE]) //     2
				{
				case 0: if(alter_opr.settingcurrentbattery[TRUE]==0) alter_opr.settingcurrentbattery[TRUE]=1; //           
						switch(indx_opr.secondchargedischarge) // /
							{
							case FALSE: OPR_SmootCurrcharge(TRUE,FALSE,alter_opr.settingcurrentbattery[TRUE]); //   
										break;
							case TRUE: OPR_SmootCurrdischarge(TRUE,FALSE,alter_opr.settingcurrentbattery[TRUE]); //   
							}
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 1 ... 8: switch(indx_opr.secondchargedischarge) // /
								{
								case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=2; //         
											alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
											break;
								case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //  
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=2; //         
											alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
								}
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 9: alter_opr.measvoltageloadedbattery[TRUE]=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //    2
						switch(indx_opr.secondchargedischarge) // /
							{
							case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=2; //         
										alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[TRUE]>0) //    
											{
											OPR_SmootCurrcharge(TRUE,TRUE,alter_opr.settingcurrentbattery[TRUE]); //     
											}
										break;
							case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //    2 
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=2; //         
										alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[TRUE]>0) //    
											{
											OPR_SmootCurrdischarge(TRUE,TRUE,alter_opr.settingcurrentbattery[TRUE]); //     
											}
							}
						indxsecondcontact_tmp=OPR_ControlViolconnect(TRUE,measurecurrentbattery_tmp); //      2 
						OPR_StartConverting(FALSE,alter_opr.datanumbersensors[TRUE]); //    2 
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 10: alter_opr.measuredvoltagebattery[TRUE]=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //     2
						if(indx_opr.secondviolacontact!=indxsecondcontact_tmp) //        2 
							{
							indx_opr.secondviolacontact=indxsecondcontact_tmp; //   
							indx_opr.updatetextstring=TRUE; //    
							}
						alter_opr.countercycleservice[TRUE]=0; //     
						indx_opr.finishsecondonecycle=TRUE; //     
				}
			}
		OPR_ControlAircooler(); //     
		}
	}

void OPR_ControlAircooler(void) //     
	{
	static byte counterworkcycles_tmp=0; // 
	byte  comparisondata_tmp=0; 
	word temperatureheatsink_tmp=0; 
	
	if(counterworkcycles_tmp==0) //    
		{
		comparisondata_tmp=OPRCOOLFAN_CONTROL; //    
		temperatureheatsink_tmp=OPR_ReadTemperature(0); //   
		if((temperatureheatsink_tmp<640)&&(comparisondata_tmp<95)&&(((indx_opr.firstchargedischarge==FALSE)&&(indx_opr.startfirstservices==TRUE))||((indx_opr.secondchargedischarge==FALSE)&&(indx_opr.startsecondservices==TRUE)))) comparisondata_tmp+=5; //               40* 
		else if((temperatureheatsink_tmp<640)&&(comparisondata_tmp>100)&&(((indx_opr.firstchargedischarge==FALSE)&&(indx_opr.startfirstservices==TRUE))||((indx_opr.secondchargedischarge==FALSE)&&(indx_opr.startsecondservices==TRUE)))) comparisondata_tmp-=5; //               40* 
		else if((temperatureheatsink_tmp>=640)&&(comparisondata_tmp<156)) comparisondata_tmp+=5; //         40*      
		else if((temperatureheatsink_tmp<640)&&(comparisondata_tmp>14)&&(indx_opr.firstchargedischarge==TRUE)&&(indx_opr.secondchargedischarge==TRUE)) comparisondata_tmp-=5; //           40*      
		OPRCOOLFAN_CONTROL=comparisondata_tmp; //            
		}
	counterworkcycles_tmp++; //    
	if(counterworkcycles_tmp==6) OPR_StartConverting(FALSE,0); //       5  
	else if(counterworkcycles_tmp>=12) counterworkcycles_tmp=0; //         10  
	}

void OPR_CalculationParameters(void) //      
	{
	word basicnumberdata_tmp=0; //  
	dword generalpurpose_tmp=0; 
	if(alter_opr.initialvoltagebattery[indx_opr.processnumber]==0) alter_opr.initialvoltagebattery[indx_opr.processnumber]=alter_opr.measuredvoltagebattery[indx_opr.processnumber]; //    
	generalpurpose_tmp=alter_opr.summacurrentbattery[indx_opr.processnumber]/9; //      
	alter_opr.measuredcurrentbattery[indx_opr.processnumber]=(word)generalpurpose_tmp; //     
	generalpurpose_tmp=alter_opr.summacurrentbattery[indx_opr.processnumber]*720/32400; // /      
	alter_opr.summachargebattery[indx_opr.processnumber]+=generalpurpose_tmp; // /   
	generalpurpose_tmp=alter_opr.summachargebattery[indx_opr.processnumber]/100; // /   
	alter_opr.measuredchargebattery[indx_opr.processnumber]=(word)generalpurpose_tmp; //  /     
	alter_opr.summacurrentbattery[indx_opr.processnumber]=0; //      
	alter_opr.measuredtemperature[indx_opr.processnumber]=OPR_ReadTemperature(alter_opr.datanumbersensors[indx_opr.processnumber]); //    
	if(alter_opr.initialtemperature[indx_opr.processnumber]==0) alter_opr.initialtemperature[indx_opr.processnumber]=alter_opr.measuredtemperature[indx_opr.processnumber]; //           
	generalpurpose_tmp=(dword)alter_opr.measuredtemperature[indx_opr.processnumber]*625/10000; //      
	if((word)generalpurpose_tmp>alter_opr.maximumtemperature[indx_opr.processnumber]) alter_opr.maximumtemperature[indx_opr.processnumber]=(word)generalpurpose_tmp; //   
	alter_opr.displaytemperature[indx_opr.processnumber]=(byte)generalpurpose_tmp; //     
	if(alter_opr.measuredtemperature[indx_opr.processnumber]>alter_opr.initialtemperature[indx_opr.processnumber]) //       
		{
		basicnumberdata_tmp=alter_opr.measuredtemperature[indx_opr.processnumber]-alter_opr.initialtemperature[indx_opr.processnumber]; //         
		generalpurpose_tmp=(dword)basicnumberdata_tmp*625/10000; //      
		if((word)generalpurpose_tmp>alter_opr.maximumoverheating[indx_opr.processnumber]) alter_opr.maximumoverheating[indx_opr.processnumber]=(word)generalpurpose_tmp; //     
		}
	switch(indx_opr.processnumber) //   
		{
		case FALSE: generalpurpose_tmp=(ADC_ReadingParameters(1)+OPRCIRCUIT_RESISTANCE)*(dword)alter_opr.measuredcurrentbattery[FALSE]/10000; //         1
					switch(indx_opr.firstchargedischarge) // /  1
						{
						case FALSE:	alter_opr.measvoltageloadedbattery[FALSE]-=(word)generalpurpose_tmp; //        
									if(alter_opr.measvoltageloadedbattery[FALSE]>alter_opr.measuredvoltagebattery[FALSE]) //     
										{
										basicnumberdata_tmp=alter_opr.measvoltageloadedbattery[FALSE]-alter_opr.measuredvoltagebattery[FALSE]; //     1
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[FALSE]; //    
										generalpurpose_tmp/=(dword)alter_opr.numbercellsbattery[FALSE]; //         1
										if(generalpurpose_tmp>=10000) alter_opr.intresistancebattery[FALSE]=9999; //      10    
										else alter_opr.intresistancebattery[FALSE]=(alter_opr.intresistancebattery[FALSE]+(word)generalpurpose_tmp)/2; //        10  
										}
									else alter_opr.intresistancebattery[FALSE]=0; //   
									break;
						case TRUE: alter_opr.measvoltageloadedbattery[FALSE]+=(word)generalpurpose_tmp; //        
									if(alter_opr.measuredvoltagebattery[FALSE]>alter_opr.measvoltageloadedbattery[FALSE]) //      
										{
										basicnumberdata_tmp=alter_opr.measuredvoltagebattery[FALSE]-alter_opr.measvoltageloadedbattery[FALSE]; //     2
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[FALSE]; //    
										generalpurpose_tmp/=(dword)alter_opr.numbercellsbattery[FALSE]; //         2 
										if(generalpurpose_tmp>=10000) alter_opr.intresistancebattery[FALSE]=9999; //      10    
										else alter_opr.intresistancebattery[FALSE]=(alter_opr.intresistancebattery[FALSE]+(word)generalpurpose_tmp)/2; //        10  
										}
									else alter_opr.intresistancebattery[FALSE]=0; //   
						}
					if(((alter_opr.currentstatusprocess[FALSE]==2)||(alter_opr.currentstatusprocess[FALSE]==6))&&(alter_opr.measuredcurrentbattery[FALSE]>(alter_opr.settcapacitybattery[FALSE]/20))) //   /      0,05   1 
						{
						if((alter_opr.miniresistancebattery[FALSE]==0)&&(alter_opr.intresistancebattery[FALSE]>0)) alter_opr.miniresistancebattery[FALSE]=alter_opr.intresistancebattery[FALSE]; //      1
						else if((alter_opr.intresistancebattery[FALSE]>0)&&(alter_opr.miniresistancebattery[FALSE]>alter_opr.intresistancebattery[FALSE])) alter_opr.miniresistancebattery[FALSE]=(alter_opr.miniresistancebattery[FALSE]+alter_opr.intresistancebattery[FALSE])/2; //       1 
						if(alter_opr.maximumcurrentbattery[FALSE]<alter_opr.measuredcurrentbattery[FALSE]) alter_opr.maximumcurrentbattery[FALSE]=alter_opr.measuredcurrentbattery[FALSE]; //   /  1 
						}
					break;
		case TRUE: generalpurpose_tmp=(ADC_ReadingParameters(2)+OPRCIRCUIT_RESISTANCE)*(dword)alter_opr.measuredcurrentbattery[TRUE]/10000; //         2
					switch(indx_opr.secondchargedischarge) // /  2
						{
						case FALSE: alter_opr.measvoltageloadedbattery[TRUE]-=(word)generalpurpose_tmp; //        
									if(alter_opr.measvoltageloadedbattery[TRUE]>alter_opr.measuredvoltagebattery[TRUE]) //     
										{
										basicnumberdata_tmp=alter_opr.measvoltageloadedbattery[TRUE]-alter_opr.measuredvoltagebattery[TRUE]; //     2
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[TRUE]; //    
										generalpurpose_tmp/=(dword)alter_opr.numbercellsbattery[TRUE]; //         2
										if(generalpurpose_tmp>=10000) alter_opr.intresistancebattery[TRUE]=9999; //      10    
										else alter_opr.intresistancebattery[TRUE]=(alter_opr.intresistancebattery[TRUE]+(word)generalpurpose_tmp)/2; //    
										}
									else alter_opr.intresistancebattery[TRUE]=0; //  
									break;
						case TRUE: alter_opr.measvoltageloadedbattery[TRUE]+=(word)generalpurpose_tmp; //        
									if(alter_opr.measuredvoltagebattery[TRUE]>alter_opr.measvoltageloadedbattery[TRUE]) //     
										{
										basicnumberdata_tmp=alter_opr.measuredvoltagebattery[TRUE]-alter_opr.measvoltageloadedbattery[TRUE]; //     2
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[TRUE]; //    
										generalpurpose_tmp/=(dword)alter_opr.numbercellsbattery[TRUE]; //         2
										if(generalpurpose_tmp>=10000) alter_opr.intresistancebattery[TRUE]=9999; //      10    
										else alter_opr.intresistancebattery[TRUE]=(alter_opr.intresistancebattery[TRUE]+(word)generalpurpose_tmp)/2; //    
										}
									else alter_opr.intresistancebattery[TRUE]=0; //   
						}
					if(((alter_opr.currentstatusprocess[TRUE]==2)||(alter_opr.currentstatusprocess[TRUE]==6))&&(alter_opr.measuredcurrentbattery[TRUE]>(alter_opr.settcapacitybattery[TRUE]/20))) //   /      0,05   2 
						{
						if((alter_opr.miniresistancebattery[TRUE]==0)&&(alter_opr.intresistancebattery[TRUE]>0)) alter_opr.miniresistancebattery[TRUE]=alter_opr.intresistancebattery[TRUE]; //      2 
						else if((alter_opr.intresistancebattery[TRUE]>0)&&(alter_opr.miniresistancebattery[TRUE]>alter_opr.intresistancebattery[TRUE])) alter_opr.miniresistancebattery[TRUE]=(alter_opr.miniresistancebattery[TRUE]+alter_opr.intresistancebattery[TRUE])/2; //       2 
						if(alter_opr.maximumcurrentbattery[TRUE]<alter_opr.measuredcurrentbattery[TRUE]) alter_opr.maximumcurrentbattery[indx_opr.processnumber]=alter_opr.measuredcurrentbattery[indx_opr.processnumber]; //   /  2 
						}
		}
	}

bit OPR_DetectconnectBattery(void) //    
	{
	bit indxconnectbattery_tmp=FALSE; //  
	bit indxcancellsearch_tmp=FALSE; 
	word settingcurrent_tmp=1; 
	word measurevoltage_tmp=0; 
	word measurecurrent_tmp=0; 
	word detectvoltage_tmp=0;
	switch(alter_opr.countertypebattery[indx_opr.processnumber]) //  
		{
		case 0 ... 8: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //     
							{
							case 0 ... 1: detectvoltage_tmp=OPRDETECTION_NIMHCD; //     Ni-Mh  Ni-Cd  
									break;
							case 2: detectvoltage_tmp=OPRDETECTION_NIMHCD*2; //      2- Ni-Mh  Ni-Cd  
									break;
							case 3: detectvoltage_tmp=OPRDETECTION_NIMHCD*3; //      3- Ni-Mh  Ni-Cd 
									break;
							case 4: detectvoltage_tmp=OPRDETECTION_NIMHCD*4; //      4- Ni-Mh  Ni-Cd 
									break;
							case 5: detectvoltage_tmp=OPRDETECTION_NIMHCD*5; //      5- Ni-Mh  Ni-Cd 
									break;
							case 6: detectvoltage_tmp=OPRDETECTION_NIMHCD*6; //      6- Ni-Mh  Ni-Cd 
									break;
							case 7: detectvoltage_tmp=OPRDETECTION_NIMHCD*7; //      7- Ni-Mh  Ni-Cd 
									break;
							case 8: detectvoltage_tmp=OPRDETECTION_NIMHCD*8; //      8- Ni-Mh  Ni-Cd 
							}
				break;
		case 9: detectvoltage_tmp=OPRDETECTION_NIZN; //    Ni-Zn 
				break;
		case 10 ... 15: detectvoltage_tmp=OPRDETECTION_LITHIUM1; //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
				break;
		case 16: detectvoltage_tmp=OPRDETECTION_LITHIUM3; //    Li-Ti  
				break;
		case 17: detectvoltage_tmp=OPRDETECTION_LITHIUM2; //    Li-Fe  
				break;
		case 18: detectvoltage_tmp=OPRDETECTION_LIFEPO4; //    LiFePo4 
				break;
		case 19 ... 22: switch(alter_opr.countertypebattery[indx_opr.processnumber]) //     
							{
							case 19: detectvoltage_tmp=OPRDETECTION_SLA2V; //    Sla-2v 
									break;
							case 20: detectvoltage_tmp=OPRDETECTION_SLA2V*2; //    Sla-4v 
									break;
							case 21: detectvoltage_tmp=OPRDETECTION_SLA2V*3; //    Sla-6v 
									break;
							case 22: detectvoltage_tmp=OPRDETECTION_SLA2V*6; //    Sla-12v 
							}
		}
	while(indxcancellsearch_tmp==FALSE) //    
		{
		OPR_SmootCurrcharge(indx_opr.settingnumber,FALSE,settingcurrent_tmp); //      
		SYS_TimeWaiting(10); // 10    
		switch(indx_opr.processnumber) //   
			{
			case FALSE: measurevoltage_tmp=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //   1 
						measurecurrent_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //   1 
						break;
			case TRUE: measurevoltage_tmp=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //   2 
						measurecurrent_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //   2 
			}
		if(measurevoltage_tmp<detectvoltage_tmp) //       
			{
			if(measurecurrent_tmp>10) //   10  
				{
				indxcancellsearch_tmp=TRUE; //        
				indxconnectbattery_tmp=TRUE; //    
				}
			else //   10  
				{
				OPR_SmootCurrcharge(indx_opr.settingnumber,TRUE,settingcurrent_tmp); //      
				settingcurrent_tmp++; //         
				}
			}
		else indxcancellsearch_tmp=TRUE; //             1700  
		}
	OPR_SmootCurrcharge(indx_opr.settingnumber,TRUE,settingcurrent_tmp); //      
	return indxconnectbattery_tmp; //  /  
	}

void OPR_ControlWorkcycle(byte datacodecontrol_prm) //     
	{
	switch(datacodecontrol_prm) //    
		{
		case 1: switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //       
					{
					case 0: OPR_DecodeLeftbutton(); //  Left      
							break;
					case 1 ... 3: break; // 
					case 4: OPR_DecodeLeftbutton(); //  Left       
							indx_opr.updateparameters=TRUE; //    
							break;
					case 5 ... 6: asm("nop"); // 
					}
				break;
		case 2: switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //       
					{
					case 0: OPR_DecodeRigtbutton(); //  Rigt      
							break;
					case 1 ... 3: break; // 
					case 4: OPR_DecodeRigtbutton(); //  Rigt       
							indx_opr.updateparameters=TRUE; //    
							break;
					case 5 ... 6: asm("nop"); // 
					}
				break;
		case 3: OPR_DecodeUpbutton(); //  Up 
				break;
		case 4: OPR_DecodeDownbutton(); //  Down 
				break;
		case 5: OPR_DecodeEnterbutton(); //  Enter 
		}
	if(indx_opr.updatetextstring==TRUE) //     1 
		{
		switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //    
			{
			case 0: alter_opr.locationcursorline[indx_opr.settingnumber]=0; //  
					break;
			case 1: alter_opr.locationcursorline[indx_opr.settingnumber]=3; //    
					break;
			case 2: if(alter_opr.counteroutitems[indx_opr.settingnumber]==0) alter_opr.locationcursorline[indx_opr.settingnumber]=9; //   
					else if(alter_opr.counteroutitems[indx_opr.settingnumber]==1) alter_opr.locationcursorline[indx_opr.settingnumber]=8; //      
					else alter_opr.locationcursorline[indx_opr.settingnumber]=6; //     
					break;
			case 3: alter_opr.locationcursorline[indx_opr.settingnumber]=9; //      
					break;
			case 4: alter_opr.locationcursorline[indx_opr.settingnumber]=10; //      
			}
		}
	}

void OPR_SmootCurrcharge(bit numberbattery_prm,bit settingdirect_prm,word numbercycles_prm) //     
	{
	byte countcycledirect_tmp=0; // 
	word comparedata_tmp=0;
	switch(numberbattery_prm) //  
		{
		case FALSE:	comparedata_tmp=OPRFIRST_CHARGE; //       1
					break;
		case TRUE:	comparedata_tmp=OPRSECOND_CHARGE; //       2
		}
	switch(settingdirect_prm) //   
		{
		case FALSE:	while(countcycledirect_tmp<numbercycles_prm) //     
							{
							if(comparedata_tmp<1023) comparedata_tmp++; //     
							switch(numberbattery_prm) //   
								{
								case FALSE:	OPRFIRST_CHARGE=comparedata_tmp; //      1
											break;
								case TRUE: OPRSECOND_CHARGE=comparedata_tmp; //      2
								}
							SYS_TimeWaiting(1); // 1 
							countcycledirect_tmp++; //  
							} 
					break;
		case TRUE:  while(countcycledirect_tmp<numbercycles_prm) //     
							{
							if(comparedata_tmp>0) comparedata_tmp--; //      
							switch(numberbattery_prm) //     
								{
								case FALSE: OPRFIRST_CHARGE=comparedata_tmp; //      1
											break;
								case TRUE: OPRSECOND_CHARGE=comparedata_tmp; //      2
								}
							SYS_TimeWaiting(1); // 1 
							countcycledirect_tmp++; //  
							}
		}
	}

void OPR_SmootCurrdischarge(bit indxnumberbattery_prm,bit indxsettingdirect_prm,word numbercycles_prm) //    
	{
	byte countcycledirect_tmp=0; // 
	word comparedata_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE:	comparedata_tmp=OPRFIRST_DISCHARGE; //       1
					break;
		case TRUE:	comparedata_tmp=OPRSECOND_DISCHARGE; //       2
		}
	switch(indxsettingdirect_prm) //   
		{
		case FALSE:	while(countcycledirect_tmp<numbercycles_prm) //    
						{
						if(comparedata_tmp>1) comparedata_tmp--; //      
						switch(indxnumberbattery_prm) //   
							{
							case FALSE:	OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
							case TRUE: OPRSECOND_DISCHARGE=comparedata_tmp; //      2
							}
						SYS_TimeWaiting(1); // 1 
						countcycledirect_tmp++; //  
						}
					break;
		case TRUE:  while(countcycledirect_tmp<numbercycles_prm) //     
						{
						if(comparedata_tmp<255) comparedata_tmp++; //     255 
						switch(indxnumberbattery_prm) //   
							{
							case FALSE: OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
							case TRUE: OPRSECOND_DISCHARGE=comparedata_tmp; //      2
							}
						SYS_TimeWaiting(1); // 1 
						countcycledirect_tmp++; //  
						}
		}
	}

void OPR_OutitemBatterytype(void) //    
	{
	byte datanumbersensors_tmp=0; // 
	if(indx_opr.searchtypesbattery==TRUE) //     
		{
		indx_opr.searchtypesbattery=FALSE; //    
		OPR_SearchtypesBattery(indx_opr.settingnumber); //     
		if(alter_opr.datanumbersensors[indx_opr.settingnumber]>0) alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //      
		}
	switch(alter_opr.countertypebattery[indx_opr.settingnumber]) //   
		{
		case 0: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Ni-Mh ,      
					{
					switch(indx_opr.settingnumber) //   
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(1,4); //  Ni-Mh  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(5,4); //  Ni-Mh  2 
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Ni-Mh  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0: SYM_ByteLineout(indx_opr.settingnumber,4,0,1,0,2); //      : : .?? Ni-Mh 
							OPR_BlockingOutitems(); //     
							break;
					case 1 ... 8: SYM_ByteLineout(indx_opr.settingnumber,4,0,1,0,1); //      1  8   : : .   Ni-Mh 
							OPR_UnblockingOutitems(); //     
							break;
					case 9 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,1,0,2); //      : : .?? Ni-Mh
							OPR_BlockingOutitems(); //    
					}
				break;
		case 1: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Ni-Cd ,      
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(9,2); //  Ni-Cd  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(11,2); //  Ni-Cd  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Ni-Cd  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0 ... 8: SYM_ByteLineout(indx_opr.settingnumber,4,0,2,0,2); //      : : .?? Ni-Cd 
							OPR_BlockingOutitems(); //     
							break;
					case 9 ... 12: SYM_ByteLineout(indx_opr.settingnumber,4,0,2,0,1); //      9  12   : : .  Ni-Cd  
							OPR_UnblockingOutitems(); //     
							break;
					case 13 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,2,0,2); //      : : .?? Ni-Cd
							OPR_BlockingOutitems(); //    
					}
				break;
		case 2: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   2- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(13,1); //    2- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(14,1); //    2- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     2- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 12: SYM_ByteLineout(indx_opr.settingnumber,4,0,11,0,2); //      : : .?? 2Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 13 ... 14: SYM_ByteLineout(indx_opr.settingnumber,4,0,11,0,1); //      13  14   : : .  2Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 15 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,11,0,2); //      : : .?? 2Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 3: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   3- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(15,1); //    3- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(16,1); //    3- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     3- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 14: SYM_ByteLineout(indx_opr.settingnumber,4,0,12,0,2); //      : : .?? 3Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 15 ... 16: SYM_ByteLineout(indx_opr.settingnumber,4,0,12,0,1); //      15  16   : : .  3Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 17 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,12,0,2); //      : : .?? 3Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 4: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   4- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(17,1); //    4- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(18,1); //    4- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     4- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 16: SYM_ByteLineout(indx_opr.settingnumber,4,0,13,0,2); //      : : .?? 4Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 17 ... 18: SYM_ByteLineout(indx_opr.settingnumber,4,0,13,0,1); //      17  18   : : .  4Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 19 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,13,0,2); //      : : .?? 4Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 5: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   5- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(19,1); //    5- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(20,1); //    5- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     5- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 18: SYM_ByteLineout(indx_opr.settingnumber,4,0,14,0,2); //      : : .?? 5Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 19 ... 20: SYM_ByteLineout(indx_opr.settingnumber,4,0,14,0,1); //      19  20   : : .  5Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 21 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,14,0,2); //      : : .?? 5Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 6: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   6- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(21,1); //    6- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(22,1); //    6- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     6- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 20: SYM_ByteLineout(indx_opr.settingnumber,4,0,15,0,2); //      : : .?? 6Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 21 ... 22: SYM_ByteLineout(indx_opr.settingnumber,4,0,15,0,1); //      21  22   : : .  6Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 23 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,15,0,2); //      : : .?? 6Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 7: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   7- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(23,1); //    7- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(24,1); //    7- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     7- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 22: SYM_ByteLineout(indx_opr.settingnumber,4,0,16,0,2); //      : : .?? 7Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 23 ... 24: SYM_ByteLineout(indx_opr.settingnumber,4,0,16,0,1); //      23  24   : : .  7Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 25 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,16,0,2); //      : : .?? 7Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 8: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) //   8- Ni-xx ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(25,1); //    8- Ni-xx  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(26,1); //    8- Ni-xx  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //     8- Ni-xx 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 24: SYM_ByteLineout(indx_opr.settingnumber,4,0,17,0,2); //      : : .?? 8Ni-Gr
							OPR_BlockingOutitems(); //    
							break;
					case 25 ... 26: SYM_ByteLineout(indx_opr.settingnumber,4,0,17,0,1); //      25  26   : : .  8Ni-Gr
							OPR_UnblockingOutitems(); //    
							break;
					case 27 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,17,0,2); //      : : .?? 8Ni-Gr
							OPR_BlockingOutitems(); //    
					}
				break;
		case 9: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Ni-Zn ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(27,2); //  Ni-Zn  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(29,2); //  Ni-Zn  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Ni-Zn 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 26: SYM_ByteLineout(indx_opr.settingnumber,4,0,45,0,2); //  Ni-Zn     : : .?? Ni-Zn
							OPR_BlockingOutitems(); //    
							break;
					case 27 ... 30: SYM_ByteLineout(indx_opr.settingnumber,4,0,45,0,1); //      27  30   : : .  Ni-Zn
							OPR_UnblockingOutitems(); //    
							break;
					case 31 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,45,0,2); //      : : .?? Ni-Zn
							OPR_BlockingOutitems(); //    
					}
				break;
		case 10: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Po ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(31,5); //  Li-Po  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(36,5); //  Li-Po  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Po  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0 ... 30: SYM_ByteLineout(indx_opr.settingnumber,4,0,3,0,2); //  Li-Po     : : .?? Li-Po 
							OPR_BlockingOutitems(); //     
							break;
					case 31 ... 40: SYM_ByteLineout(indx_opr.settingnumber,4,0,3,0,1); //      31  40   : : .  Li-Po 
							OPR_UnblockingOutitems(); //     
							break;
					case 41 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,3,0,2); //      : : .?? Li-Po
							OPR_BlockingOutitems(); //    
					}
				break;
		case 11: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Ion ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(41,5); //  Li-Ion  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(46,5); //  Li-Ion  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Ion 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 40: SYM_ByteLineout(indx_opr.settingnumber,4,0,4,0,2); //      : : .?? Li-Ion 
							OPR_BlockingOutitems(); //     
							break;
					case 41 ... 50: SYM_ByteLineout(indx_opr.settingnumber,4,0,4,0,1); //      41  50   : : .  Li-Ion 
							OPR_UnblockingOutitems(); //     
							break;
					case 51 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,4,0,2); //      : : .?? Li-Ion
							OPR_BlockingOutitems(); //    
					}
				break;
		case 12: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Mn ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(51,3); //  Li-Mn  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(54,3); //  Li-Mn  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Mn 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 50: SYM_ByteLineout(indx_opr.settingnumber,4,0,7,0,2); //      : : .?? Li-Mn 
							OPR_BlockingOutitems(); //    
							break;
					case 51 ... 56: SYM_ByteLineout(indx_opr.settingnumber,4,0,7,0,1); //      51  56   : : .  Li-Mn 
							OPR_UnblockingOutitems(); //    
							break;
					case 57 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,7,0,2); //      : : .?? Li-Mn
							OPR_BlockingOutitems(); //    
					}
				break;
		case 13: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Co ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(57,3); //  Li-Co  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(60,3); //  Li-Co  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Co 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 56: SYM_ByteLineout(indx_opr.settingnumber,4,0,8,0,2); //      : : .?? Li-Co
							OPR_BlockingOutitems(); //    
							break;
					case 57 ... 62: SYM_ByteLineout(indx_opr.settingnumber,4,0,8,0,1); //      57  62   : : .  Li-Co
							OPR_UnblockingOutitems(); //    
							break;
					case 63 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,8,0,2); //      : : .?? Li-Co
							OPR_BlockingOutitems(); //    
					}
				break;
		case 14: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Nca ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(63,3); //  Li-Nca  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(66,3); //  Li-Nca  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Nca 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 62: SYM_ByteLineout(indx_opr.settingnumber,4,0,9,0,2); //      : : .?? Li-Nca
							OPR_BlockingOutitems(); //    
							break;
					case 63 ... 68: SYM_ByteLineout(indx_opr.settingnumber,4,0,9,0,1); //      63  68   : : .  Li-Nca
							OPR_UnblockingOutitems(); //    
							break;
					case 69 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,9,0,2); //      : : .?? Li-Nca
							OPR_BlockingOutitems(); //    
					}
				break;
		case 15: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Nmc ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(69,3); //  Li-Nmc  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(72,3); //  Li-Nmc  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Nmc 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 68: SYM_ByteLineout(indx_opr.settingnumber,4,0,10,0,2); //      : : .?? Li-Nmc
							OPR_BlockingOutitems(); //    
							break;
					case 69 ... 74: SYM_ByteLineout(indx_opr.settingnumber,4,0,10,0,1); //      69  74   : : .  Li-Nmc
							OPR_UnblockingOutitems(); //    
							break;
					case 75 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,10,0,2); //      : : .?? Li-Nmc
							OPR_BlockingOutitems(); //    
					}
				break;
		case 16: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Ti ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(75,3); //  Li-Ti  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(78,3); //  Li-Ti  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Ti 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 74: SYM_ByteLineout(indx_opr.settingnumber,4,0,6,0,2); //      : : .?? Li-Ti
							OPR_BlockingOutitems(); //    
							break;
					case 75 ... 80: SYM_ByteLineout(indx_opr.settingnumber,4,0,6,0,1); //      75  80   : : .  Li-Ti
							OPR_UnblockingOutitems(); //    
							break;
					case 81 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,6,0,2); //      : : .?? Li-Ti
							OPR_BlockingOutitems(); //    
					}
				break;
		case 17: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Fe ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(81,3); //  Li-Fe  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(84,3); //  Li-Fe  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Fe 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 80: SYM_ByteLineout(indx_opr.settingnumber,4,0,5,0,2); //      : : .?? Li-Fe
							OPR_BlockingOutitems(); //    
							break;
					case 81 ... 86: SYM_ByteLineout(indx_opr.settingnumber,4,0,5,0,1); //      81  86   : : .  Li-Fe
							OPR_UnblockingOutitems(); //    
							break;
					case 87 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,5,0,2); //      : : .?? Li-Fe
							OPR_BlockingOutitems(); //    
					}
				break;
		
		case 18: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // LiFePo4 ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(87,1); //  LiFePo4  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(88,1); //  LiFePo4  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   LiFePo4 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 86: SYM_ByteLineout(indx_opr.settingnumber,4,0,22,0,2); //      : : .?? LiFePo4
							OPR_BlockingOutitems(); //    
							break;
					case 87 ... 88: SYM_ByteLineout(indx_opr.settingnumber,4,0,22,0,1); //      87  88   : : .  LiFePo4
							OPR_UnblockingOutitems(); //    
							break;
					case 89 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,22,0,2); //      : : .?? LiFePo4
							OPR_BlockingOutitems(); //    
					}
				break;
		case 19: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Sla-2v ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(89,1); //  Sla-2v  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(90,1); //  Sla-2v  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Sla-2v 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 88: SYM_ByteLineout(indx_opr.settingnumber,4,0,18,0,2); //      : : .?? Sla-2v
							OPR_BlockingOutitems(); //    
							break;
					case 89 ... 90: SYM_ByteLineout(indx_opr.settingnumber,4,0,18,0,1); //      89  90   : : .  Sla-2v
							OPR_UnblockingOutitems(); //    
							break;
					case 91 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,18,0,2); //      : : .?? Sla-2v
							OPR_BlockingOutitems(); //    
					}
				break;
		case 20: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Sla-4v ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(91,1); //  Sla-4v  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(92,1); //  Sla-4v  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Sla-4v 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 90: SYM_ByteLineout(indx_opr.settingnumber,4,0,19,0,2); //      : : .?? Sla-4v
							OPR_BlockingOutitems(); //    
							break;
					case 91 ... 92: SYM_ByteLineout(indx_opr.settingnumber,4,0,19,0,1); //      91  92   : : .  Sla-4v
							OPR_UnblockingOutitems(); //    
							break;
					case 93 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,19,0,2); //      : : .?? Sla-4v
							OPR_BlockingOutitems(); //    
					}
				break;
		case 21: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Sla-6v ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(93,1); //  Sla-6v  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(94,1); //  Sla-6v  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Sla-6v 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 92: SYM_ByteLineout(indx_opr.settingnumber,4,0,20,0,2); //      : : .?? Sla-6v
							OPR_BlockingOutitems(); //    
							break;
					case 93 ... 94: SYM_ByteLineout(indx_opr.settingnumber,4,0,20,0,1); //      93  94   : : .  Sla-6v
							OPR_UnblockingOutitems(); //    
							break;
					case 95 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,20,0,2); //      : : .?? Sla-6v
							OPR_BlockingOutitems(); //    
					}
				break;
		case 22: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Sla-12v ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchnumberSensors(95,1); //  Sla-12v  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchnumberSensors(96,1); //  Sla-12v  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Sla-12v 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0 ... 94: SYM_ByteLineout(indx_opr.settingnumber,4,0,21,0,2); //      : : .?? Sla-12v
							OPR_BlockingOutitems(); //    
							break;
					case 95 ... 96: SYM_ByteLineout(indx_opr.settingnumber,4,0,21,0,1); //      95  96   : : .  Sla-12v
							OPR_UnblockingOutitems(); //    
					}
		}
	}

void OPR_OutitemBatterymode(void) //     
	{
	switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //     
		{
		case 0: SYM_WordLineout(indx_opr.settingnumber,1,1); // : :  ./.
				break;
		case 1: SYM_WordLineout(indx_opr.settingnumber,2,1); // : :  
				break;
		case 2: SYM_WordLineout(indx_opr.settingnumber,3,1); // : :   
				break;
		case 3: SYM_WordLineout(indx_opr.settingnumber,4,1); // : :  
				break;
		case 4: SYM_WordLineout(indx_opr.settingnumber,5,1); // : :   
				break;
		case 5: SYM_WordLineout(indx_opr.settingnumber,23,1); // : :   
		}
	switch(indx_opr.settingnumber) //  
		{
		case FALSE: if(indx_opr.lockfirstonlycharge==FALSE) //   
						{
						if(alter_opr.countermodebattery[FALSE]==2) indx_opr.onlyfirstcharging=TRUE; //         1
						else indx_opr.onlyfirstcharging=FALSE; //     
						}
					break;
		case TRUE: if(indx_opr.locksecondonlycharge==FALSE) //   
						{
						if(alter_opr.countermodebattery[TRUE]==2) indx_opr.onlysecondcharging=TRUE; //         2
						else indx_opr.onlysecondcharging=FALSE; //     
						}
		}
	}

void OPR_OutitemBatterymethod(void) //    
	{
	switch(alter_opr.countermethodbattery[indx_opr.settingnumber]) //     
		{
		case 0: SYM_WordLineout(indx_opr.settingnumber,6,1); // : : 
				break;
		case 1: SYM_WordLineout(indx_opr.settingnumber,7,1); // : : 
				break;
		case 2: SYM_WordLineout(indx_opr.settingnumber,8,1); // : : 
		}
	}

void OPR_OutserviceBatterymode(void) //     
	{
	bit indxchargedischarge_tmp=FALSE; //  
	switch(indx_opr.settingnumber) //  
		{
		case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1
					break;
		case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2
		}
	switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //   
		{
		case 0: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,29,36,alter_opr.currentstatusprocess[indx_opr.settingnumber],0); //  : :        
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,28,36,alter_opr.currentstatusprocess[indx_opr.settingnumber],0); //  : :   -     
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 1: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,29,34,alter_opr.currentstatusprocess[indx_opr.settingnumber],0); //  : :    ,    
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,30,34,alter_opr.currentstatusprocess[indx_opr.settingnumber],0); //  : :    ,    
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 2: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,32,37,0,0); //  : :       
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,33,37,0,0); //  : :  -     
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 3: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,32,41,0,0); //  : :   ,    
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,31,41,0,0); //  : :   ,    
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 4: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,32,39,0,0); //  : :     
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,31,39,0,0); //  : :      
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 5: SYM_ByteLineout(indx_opr.settingnumber,4,27,37,0,0); //  : :       
				indx_opr.updateparameters=TRUE; //   
				break;
		case 6: OPR_OutitemBatterymethod(); //   
				break;
		case 7: OPR_OutitemBatterytype(); //  
				break;
		case 8: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,32,43,0,0); //  : :  
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,31,43,0,0); //  : :  
					}
				break;
		case 9: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: SYM_ByteLineout(indx_opr.settingnumber,4,32,44,0,0); //  : :  
								break;
					case TRUE: SYM_ByteLineout(indx_opr.settingnumber,4,31,44,0,0); //  : :  
					}
		}
	}

void OPR_OutserviceParameters(void) //     
  	{
	switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //   
		{
		case 0: SYM_OutdataNumber0000(alter_opr.measuredcurrentbattery[indx_opr.settingnumber],8); // /   
				break;
		case 1: SYM_OutdataNumber00_000(alter_opr.measuredvoltagebattery[indx_opr.settingnumber],8); //   
				break;
		case 2: SYM_OutdataNumber0000(alter_opr.measuredchargebattery[indx_opr.settingnumber],8); //      
				break;
		case 3: SYM_OutdataNumber0_000(alter_opr.intresistancebattery[indx_opr.settingnumber],8); //    
				break;
		case 4: SYM_OutdataNumber00(alter_opr.displaytemperature[indx_opr.settingnumber],12); //   
				break;
		case 5: SYM_OutdataNumber0000(alter_opr.settcapacitybattery[indx_opr.settingnumber],8); //   
				break;
		case 6 ... 9: asm("nop"); //  
		}
	} 

void OPR_DecodeLeftbutton(void) //   Left
	{
	byte countposition_tmp=0; // 
	countposition_tmp=alter_opr.counterpositioncursor[indx_opr.settingnumber]; //    
	switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
		{
		case 0: if(countposition_tmp>0) countposition_tmp--; //         
				else countposition_tmp=2; //     
				break;
		case 1: if(countposition_tmp>0) countposition_tmp--; //         
				else countposition_tmp=4; //     
				break;
		
		case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //     
					{
					case 0 ... 2: if(countposition_tmp>0) countposition_tmp--; //          
							else countposition_tmp=2; //      
							break;
					case 3 ... 4: asm("nop"); //  
					}
				break;
		case 3: switch(alter_opr.countermethodbattery[indx_opr.settingnumber]) //     
					{
					case 0 ... 2: if(countposition_tmp>0) countposition_tmp--; //         
							else countposition_tmp=2; //     
					}
				break;
		case 4 ... 5: switch(countposition_tmp) //            
						{
						case 0: countposition_tmp=1; //   
								break;
						case 1: countposition_tmp=0; //   
						}
		}
	indx_opr.updatetextstring=TRUE; //    
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=countposition_tmp; //        
	}

void OPR_DecodeRigtbutton(void) //   Rigt 
	{
	byte countposition_tmp=0; // 
	countposition_tmp=alter_opr.counterpositioncursor[indx_opr.settingnumber]; //   
	switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
		{
		case 0: countposition_tmp++; //      
				if(countposition_tmp>2) countposition_tmp=0; //    
				break;
		case 1: countposition_tmp++; //      
				if(countposition_tmp>4)  countposition_tmp=0; //    4-x
				break;
		case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //    
					{
					case 0 ... 2: countposition_tmp++; //       
							if(countposition_tmp>2)  countposition_tmp=0; //    
							break;
					case 3 ... 4: asm("nop"); //  
					}
				break;
		case 3: switch(alter_opr.countermethodbattery[indx_opr.settingnumber]) //     
					{
					case 0 ... 2: countposition_tmp++; //       
							if(countposition_tmp>2)  countposition_tmp=0; //    
					}
				break;
		case 4 ... 5: switch(countposition_tmp) //            
						{
						case 0: countposition_tmp=1; //   
								break;
						case 1: countposition_tmp=0; //   
						}
		}
	indx_opr.updatetextstring=TRUE; //    
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=countposition_tmp; //       
	}

void OPR_DecodeUpbutton(void) //   Up 
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //    
		{
		case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
					{
					case 0: if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2
							else indx_opr.settingnumber=FALSE; //      1
							break;
					case 1: switch(indx_opr.settingnumber) //   
								{
								case FALSE:	switch(indx_opr.outputfirstprotocol) //  /  1 
												{
												case FALSE:	if(indx_opr.blockfirstoutitems==TRUE) //        1  
																{
																alter_opr.counteroutitems[FALSE]++; //     
																if(alter_opr.counteroutitems[FALSE]>5) alter_opr.counteroutitems[FALSE]=0; //    5-
																}
															break;
												case TRUE: alter_opr.counteritemprotocol[FALSE]++; //     1 
															if(alter_opr.counteritemprotocol[FALSE]>18) alter_opr.counteritemprotocol[FALSE]=0; //      18-
												}
											break;
								case TRUE: switch(indx_opr.outputsecondprotocol) //  /  2 
												{			
												case FALSE: if(indx_opr.blocksecondoutitems==TRUE) //        2  
																{
																alter_opr.counteroutitems[TRUE]++; //    
																if(alter_opr.counteroutitems[TRUE]>5) alter_opr.counteroutitems[TRUE]=0; //    5-
																} 
															break;
												case TRUE: alter_opr.counteritemprotocol[TRUE]++; //     2 
															if(alter_opr.counteritemprotocol[TRUE]>18) alter_opr.counteritemprotocol[TRUE]=0; //      18-
												}
								}
							break;
					case 2: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
								{
								case 0: alter_opr.countertypebattery[indx_opr.settingnumber]++; //   
										if(alter_opr.countertypebattery[indx_opr.settingnumber]>22) alter_opr.countertypebattery[indx_opr.settingnumber]=0; //    22  
										alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //       
										break;
								case 1: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<9000) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=1000; //     1000 
										break;
								case 2: alter_opr.countermodebattery[indx_opr.settingnumber]++; //     
										if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])==0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>2)) //       
											{
											alter_opr.countermodebattery[indx_opr.settingnumber]=0; //      
											}
										else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])==0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>4)) //          
											{
											alter_opr.countermodebattery[indx_opr.settingnumber]=0; //      
											}
										else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])>0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0)) ////          
											{
											if((alter_opr.countermodebattery[indx_opr.settingnumber]>2)&&(alter_opr.countermodebattery[indx_opr.settingnumber]<5)) alter_opr.countermodebattery[indx_opr.settingnumber]=5; //             
											else if(alter_opr.countermodebattery[indx_opr.settingnumber]>5) alter_opr.countermodebattery[indx_opr.settingnumber]=0; //      
											}
										else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])>0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>5)) //       
											{
											alter_opr.countermodebattery[indx_opr.settingnumber]=0; //      
											}
										break;
								case 3: alter_opr.countermethodbattery[indx_opr.settingnumber]++; //     
										if(alter_opr.countermethodbattery[indx_opr.settingnumber]>2) alter_opr.countermethodbattery[indx_opr.settingnumber]=0; //      
										break;
								case 4 ... 5: asm("nop"); //  
								}
							break; 
					case 3: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<9900) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=100; //     100 
							break; 
					case 4: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<9990) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=10; //     10 
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 1 ... 3: break; // 
		case 4: if(alter_opr.counterpositioncursor[indx_opr.settingnumber]==0) //   
					{
					if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2
					else indx_opr.settingnumber=FALSE; //      1
					}
				else //     
					{
					alter_opr.counteroutparameter[indx_opr.settingnumber]++; //      
					if(((eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0)&&(alter_opr.counteroutparameter[indx_opr.settingnumber]>8))||((eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0)&&(alter_opr.counteroutparameter[indx_opr.settingnumber]>9))) 
						{
						alter_opr.counteroutparameter[indx_opr.settingnumber]=0; //    9-    ,      8- 
						}
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_DecodeDownbutton(void) //   Down
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //     
		{
		case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //      
					{
					case 0: if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2 
							else indx_opr.settingnumber=FALSE; //      1 
							break;
					case 1: switch(indx_opr.settingnumber) //   
								{
								case FALSE: switch(indx_opr.outputfirstprotocol) //  /  1 
												{
												case FALSE:	if(indx_opr.blockfirstoutitems==TRUE) //        1  
																{
																if(alter_opr.counteroutitems[FALSE]>0) alter_opr.counteroutitems[FALSE]--; //      
																else alter_opr.counteroutitems[FALSE]=5; //    
																}
															break;
												case TRUE: if(alter_opr.counteritemprotocol[FALSE]>0) alter_opr.counteritemprotocol[FALSE]--; //     1    
															else alter_opr.counteritemprotocol[FALSE]=18; //  18-   
												}
											break;
								case TRUE: switch(indx_opr.outputsecondprotocol) //  /  2 
												{
												case FALSE:	if(indx_opr.blocksecondoutitems==TRUE) //        2  
																{
																if(alter_opr.counteroutitems[TRUE]>0) alter_opr.counteroutitems[TRUE]--; //      
																else alter_opr.counteroutitems[TRUE]=5; //    
																}
															break;
												case TRUE: if(alter_opr.counteritemprotocol[TRUE]>0) alter_opr.counteritemprotocol[TRUE]--; //     2    
															else alter_opr.counteritemprotocol[TRUE]=18; //  18-   
												}
								}
							break;
					case 2: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //   
								{
								case 0: if(alter_opr.countertypebattery[indx_opr.settingnumber]>0) alter_opr.countertypebattery[indx_opr.settingnumber]--; //       
										else alter_opr.countertypebattery[indx_opr.settingnumber]=22; //       
										alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //       
										break;
								case 1: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>999) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=1000; //     1000 
										break;
								case 2: if(alter_opr.countermodebattery[indx_opr.settingnumber]>0) //      
											{
											if(eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])==0) alter_opr.countermodebattery[indx_opr.settingnumber]--; //        
											else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])>0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0)) //          
												{
												if((alter_opr.countermodebattery[indx_opr.settingnumber]<6)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>2)) alter_opr.countermodebattery[indx_opr.settingnumber]=2; //       
												else alter_opr.countermodebattery[indx_opr.settingnumber]--; //        
												}
											else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])>0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0)) //       
												{
												alter_opr.countermodebattery[indx_opr.settingnumber]--; //   
												}
											}
										else //     
											{
											if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])==0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0)) //       
												{
												alter_opr.countermodebattery[indx_opr.settingnumber]=2; //   
												}
											else if((eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])==0)&&(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0)) //          
												{
												alter_opr.countermodebattery[indx_opr.settingnumber]=4; //   
												}
											else if(eeprom_read_byte(&Opr_IndxoutEmergency[indx_opr.settingnumber])>0) //      
												{
												alter_opr.countermodebattery[indx_opr.settingnumber]=5; //   
												}
											}
										break; 
								case 3: if(alter_opr.countermethodbattery[indx_opr.settingnumber]>0) alter_opr.countermethodbattery[indx_opr.settingnumber]--; //      
										else alter_opr.countermethodbattery[indx_opr.settingnumber]=2; //      
										break; 
								case 4 ... 5: asm("nop"); //  
								}
							break;
					case 3: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>99) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=100; //     100 
							break;
					case 4: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>9) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=10; //     10 
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 1 ... 3:	break; // 
		case 4: if(alter_opr.counterpositioncursor[indx_opr.settingnumber]==0) //   
					{
					if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2
					else indx_opr.settingnumber=FALSE; //      1 
					}
				else //     
					{
					if(alter_opr.counteroutparameter[indx_opr.settingnumber]>0) alter_opr.counteroutparameter[indx_opr.settingnumber]--; //      
					else //     
						{
						if(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0) alter_opr.counteroutparameter[indx_opr.settingnumber]=8; //  8      
						else if(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])==0) alter_opr.counteroutparameter[indx_opr.settingnumber]=9; //  9      
						}
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_DecodeEnterbutton(void) //   Enter
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //    
		{
		case 0: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //   
					{
					case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
								{
								case 0: SYS_SwitchWorkmode(); //       
										break;
								case 1: break; //  
								case 2: if(indx_opr.searchtypesbattery==FALSE) indx_opr.searchtypesbattery=TRUE; //        
										indx_opr.updatetextstring=TRUE; //    
								}
							break;
					case 1: break; //  
					case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //   
								{
								case 0 ... 2: asm("nop"); //  
										break;
								case 3: OPR_ReadvalueDeferred(); //    : ""
										alter_opr.counteroutitems[indx_opr.settingnumber]+=2; //            
										break;
								case 4: eeprom_write_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber],0); //        : "" 
										alter_opr.counteroutitems[indx_opr.settingnumber]=0; //        
										alter_opr.countermodebattery[indx_opr.settingnumber]=0; //     
										break;
								case 5: OPR_ReadvalueEmergency(indx_opr.settingnumber); //     : "" 
										alter_opr.counteroutitems[indx_opr.settingnumber]+=2; //            
								}
							alter_opr.counterpositioncursor[indx_opr.settingnumber]=1; //      
							indx_opr.updatetextstring=TRUE; //    
							break;
					case 3: break; // 
					case 4: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(alter_opr.settcapacitybattery[FALSE]>49) //   50    
												{
												indx_opr.startfirstservices=TRUE; //     1 
												if(eeprom_read_byte(&Opr_IndxoutEmergency[FALSE])>0) eeprom_write_byte(&Opr_IndxoutEmergency[FALSE],0); //       
												}
											else asm("nop"); //  
											break;
								case TRUE: if(alter_opr.settcapacitybattery[TRUE]>49) //   50    
												{
												indx_opr.startsecondservices=TRUE; //     2  
												if(eeprom_read_byte(&Opr_IndxoutEmergency[TRUE])>0) eeprom_write_byte(&Opr_IndxoutEmergency[TRUE],0); //       
												}
											else asm("nop"); //  
								}
							indx_opr.updatetextstring=TRUE; //    
							break;
					case 5: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
								{
								case 0: break; //  
								case 1:	switch(indx_opr.settingnumber) //   
											{
											case FALSE: if(indx_opr.outputfirstprotocol==FALSE) //       1  
															{
															indx_opr.outputfirstprotocol=TRUE; //      
															if(alter_opr.counteritemprotocol[FALSE]>0) alter_opr.counteritemprotocol[FALSE]=0; //      
															}
														else indx_opr.outputfirstprotocol=FALSE; //       
														break;
											case TRUE: if(indx_opr.outputsecondprotocol==FALSE) //       2  
															{
															indx_opr.outputsecondprotocol=TRUE; //     
															if(alter_opr.counteritemprotocol[TRUE]>0) alter_opr.counteritemprotocol[TRUE]=0; //      
															}
														else indx_opr.outputsecondprotocol=FALSE; //        
											}
										indx_opr.updatetextstring=TRUE; //    
								}
					}
				break;
		case 1 ... 3: break; //  
		case 4: switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //   
					{
					case 0 ... 7: break; // 
					case 8: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(indx_opr.stopfirstservices==FALSE) indx_opr.stopfirstservices=TRUE; //     1
											break;
								case TRUE: if(indx_opr.stopsecondservices==FALSE) indx_opr.stopsecondservices=TRUE; //     2
								}
							break;
					case 9: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(indx_opr.postponefirstservice==FALSE) indx_opr.postponefirstservice=TRUE; //     1
											break;
								case TRUE: if(indx_opr.postponesecondservice==FALSE) indx_opr.postponesecondservice=TRUE; //     2
								}
					}
				switch(indx_opr.settingnumber) //  
					{
					case FALSE: if((indx_opr.firstviolacontact==TRUE)&&(indx_opr.stopfirstservices==FALSE)) indx_opr.stopfirstservices=TRUE; //           1 
								break;
					case TRUE: if((indx_opr.secondviolacontact==TRUE)&&(indx_opr.stopsecondservices==FALSE)) indx_opr.stopsecondservices=TRUE; //           2 
					}
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_ResetVariables(void) //   
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: indx_opr.finishfirstonecycle=FALSE; //   1 
					if(indx_opr.firstchargedischarge==TRUE) indx_opr.firstchargedischarge=FALSE; //       
					else OCR0=254; //    1     
					indx_opr.connectfirstbattery=FALSE; 
					indx_opr.startfirstservices=FALSE; 
					indx_opr.stopfirstservices=FALSE; 
					indx_opr.postponefirstservice=FALSE; 
					indx_opr.onlyfirstcharging=FALSE; 
					indx_opr.lockfirstonlycharge=FALSE; 
					indx_opr.blockfirstoutitems=FALSE; 
					indx_opr.outputfirstprotocol=FALSE; 
					indx_opr.firstfullservice=FALSE; 
					indx_opr.firstviolacontact=FALSE; 
					break;
		case TRUE: indx_opr.finishsecondonecycle=FALSE; //   2 
					if(indx_opr.secondchargedischarge==TRUE) indx_opr.secondchargedischarge=FALSE; //       
					else OCR3C=1022; //    2     
					indx_opr.connectsecondbattery=FALSE; 
					indx_opr.startsecondservices=FALSE; 
					indx_opr.stopsecondservices=FALSE; 
					indx_opr.postponesecondservice=FALSE; 
					indx_opr.onlysecondcharging=FALSE; 
					indx_opr.locksecondonlycharge=FALSE; 
					indx_opr.blocksecondoutitems=FALSE; 
					indx_opr.outputsecondprotocol=FALSE; 
					indx_opr.secondfullservice=FALSE; 
					indx_opr.secondviolacontact=FALSE;
		}
	OPR_ResetExternaldata(indx_opr.settingnumber); //  
	if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)) //    
		{
		if(indx_opr.onoffworkingservice==TRUE) OPR_StartstopWorkcycle(FALSE); //    
		OPRCOOLFAN_CONTROL=10; //    
		}
	indx_opr.updatetextstring=TRUE; //     
	indx_opr.updateparameters=FALSE; //    
	indx_opr.prioritycomplete=FALSE; //     
	alter_opr.counteritemprotocol[indx_opr.settingnumber]=0; //    
	alter_opr.counterworkcycle[indx_opr.settingnumber]=0; //       
	alter_opr.countgeneralpurpose[0]=0; //    1
	alter_opr.countgeneralpurpose[1]=0; //    2 
	alter_opr.currentstatusprocess[indx_opr.settingnumber]=0; //   
	alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //      
	alter_opr.increaseratevoltage[indx_opr.settingnumber]=0; //     
	alter_opr.increasetemperature[indx_opr.settingnumber]=0; //     
	alter_opr.initialtemperature[indx_opr.settingnumber]=0; //     
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=0; //   
	alter_opr.locationcursorline[indx_opr.settingnumber]=0; //   
	alter_opr.counteroutitems[indx_opr.settingnumber]=0; //   
	alter_opr.countertypebattery[indx_opr.settingnumber]=0; //   
	alter_opr.countermodebattery[indx_opr.settingnumber]=0; //   
	alter_opr.countermethodbattery[indx_opr.settingnumber]=0; //     
	alter_opr.counteroutparameter[indx_opr.settingnumber]=0; //       
	alter_opr.measuredtemperature[indx_opr.settingnumber]=0; //    
	alter_opr.displaytemperature[indx_opr.settingnumber]=0; //     
	alter_opr.measuredcurrentbattery[indx_opr.settingnumber]=0; //    
	alter_opr.maximumcurrentbattery[indx_opr.settingnumber]=0; //    /  
	alter_opr.measuredvoltagebattery[indx_opr.settingnumber]=0; //      
	alter_opr.measvoltageloadedbattery[indx_opr.settingnumber]=0; //     
	alter_opr.initialvoltagebattery[indx_opr.settingnumber]=0; //    /  
	alter_opr.measuredchargebattery[indx_opr.settingnumber]=0; //    
	alter_opr.maximumtemperature[indx_opr.settingnumber]=0; //     
	alter_opr.maximumoverheating[indx_opr.settingnumber]=0; //      
	alter_opr.summacurrentbattery[indx_opr.settingnumber]=0; //     
	alter_opr.summachargebattery[indx_opr.settingnumber]=0; //     
	alter_opr.settingcurrentbattery[indx_opr.settingnumber]=0; //    / 
	alter_opr.intresistancebattery[indx_opr.settingnumber]=0; //     
	alter_opr.miniresistancebattery[indx_opr.settingnumber]=0; //      
	alter_opr.countercycleservice[indx_opr.settingnumber]=0; //       
	alter_opr.settcapacitybattery[indx_opr.settingnumber]=100; //     
	alter_opr.numbercellsbattery[indx_opr.settingnumber]=0; //     
	}

void OPR_ResetExternaldata(bit indxnumberbattery_prm) //    
	{
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //   
		{
		case 0 ... 8: NGR_ResetVariables(indxnumberbattery_prm); //   Ni-Mh, Ni-Cd  
				break;
		case 9: NZN_ResetVariables(indxnumberbattery_prm); //   Ni-Zn 
				break;
		case 10 ... 15: LGR_ResetVariables(indxnumberbattery_prm); //   Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
				break;
		case 16: LTI_ResetVariables(indxnumberbattery_prm); //   Li-Ti  
				break;
		case 17 ... 18: LFG_ResetVariables(indxnumberbattery_prm); //   Li-Fe,LiFePo4  
				break;
		case 19 ... 22: SLG_ResetVariables(indxnumberbattery_prm);  //   Sla-2v - Sla-12v  
		}
	}

void OPR_ReadvalueDeferred(void) //      
	{
	bit indxchargedischarge_tmp=FALSE; //  
	byte indxonlycharging_tmp=0; 
	byte indxfullcharging_tmp=0; 
	if(eeprom_read_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber])>0) //     
		{
		alter_opr.countertypebattery[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[0][indx_opr.settingnumber]); //   
		alter_opr.countermodebattery[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[1][indx_opr.settingnumber]); //   
		alter_opr.currentstatusprocess[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[2][indx_opr.settingnumber]); //    
		alter_opr.countermethodbattery[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[4][indx_opr.settingnumber]); //   
		alter_opr.settcapacitybattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_SettingCapacity[indx_opr.settingnumber]); //   
		alter_opr.summachargebattery[indx_opr.settingnumber]=eeprom_read_dword(&Opr_SummaChargedischarge[indx_opr.settingnumber]); // /   
		alter_opr.initialvoltagebattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[0][indx_opr.settingnumber]); //     
		alter_opr.maximumcurrentbattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[1][indx_opr.settingnumber]); //     
		alter_opr.miniresistancebattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[2][indx_opr.settingnumber]); //      
		alter_opr.maximumtemperature[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[3][indx_opr.settingnumber]); //     
		alter_opr.maximumoverheating[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[4][indx_opr.settingnumber]); //      
		alter_opr.numbercellsbattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[5][indx_opr.settingnumber]); //      
		eeprom_write_byte(&Opr_IndxoutDeferred[indx_opr.settingnumber],0); //       
		switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //   
			{
			case 0 ... 1: indxchargedischarge_tmp=TRUE; //     
					break;
			case 2: indxchargedischarge_tmp=FALSE; //     
					break;
			case 3 ... 4: asm("nop"); // 
			}
		switch(indx_opr.settingnumber) //  
			{
			case FALSE: indxonlycharging_tmp=eeprom_read_byte(&Opr_IndxonlyCharging[FALSE]); //      1 
						if(indxonlycharging_tmp==0) indx_opr.onlyfirstcharging=FALSE; //       
						else indx_opr.onlyfirstcharging=TRUE; //   
						indx_opr.lockfirstonlycharge=TRUE; //         1
						indxfullcharging_tmp=eeprom_read_byte(&Opr_IndxfullCharging[FALSE]); //      1 
						if(indxfullcharging_tmp==0) indx_opr.firstfullservice=FALSE; //         
						else indx_opr.firstfullservice=TRUE; //    
						break;
			case TRUE: indxonlycharging_tmp=eeprom_read_byte(&Opr_IndxonlyCharging[TRUE]); //      2 
						if(indxonlycharging_tmp==0) indx_opr.onlysecondcharging=FALSE; //       
						else indx_opr.onlysecondcharging=TRUE; //   
						indx_opr.locksecondonlycharge=TRUE; //         2 
						indxfullcharging_tmp=eeprom_read_byte(&Opr_IndxfullCharging[TRUE]); //      2 
						if(indxfullcharging_tmp==0) indx_opr.secondfullservice=FALSE; //         
						else indx_opr.secondfullservice=TRUE; //   
			}
		switch(alter_opr.countertypebattery[indx_opr.settingnumber]) //   
			{
			case 0: NMH_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //   Ni-Mh  
					break;
			case 1: NCD_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //   Ni-Cd  
					break;
			case 2: NM2_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     2- Ni-Mh 
					break;
			case 3: NM3_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     3- Ni-Mh 
					break;
			case 4: NM4_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     4- Ni-Mh 
					break;
			case 5: NM5_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     5- Ni-Mh 
					break;
			case 6: NM6_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     6- Ni-Mh 
					break;
			case 7: NM7_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     7- Ni-Mh 
					break;
			case 8: NM8_ReadDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //     8- Ni-Mh 
					break;
			case 9: NZN_ReadDeferred(indx_opr.settingnumber); //   Ni-Zn 
					break;
			case 10: LPO_ReadDeferred(indx_opr.settingnumber); //   Li-Po  
					break;
			case 11: LIO_ReadDeferred(indx_opr.settingnumber); //   Li-Ion  
					break;
			case 12: LMN_ReadDeferred(indx_opr.settingnumber); //   Li-Mn 
					break;
			case 13: LCO_ReadDeferred(indx_opr.settingnumber); //   Li-Co 
					break;
			case 14: LCA_ReadDeferred(indx_opr.settingnumber); //   Li-Nca 
					break;
			case 15: LMC_ReadDeferred(indx_opr.settingnumber); //   Li-Nmc 
					break;
			case 16: LTI_ReadDeferred(indx_opr.settingnumber); //   Li-Ti  
					break;
			case 17: LFE_ReadDeferred(indx_opr.settingnumber); //   Li-Fe  
					break;
			case 18: LFP_ReadDeferred(indx_opr.settingnumber); //   LiFePo4  
					break;
			case 19: SL1_ReadDeferred(indx_opr.settingnumber); //   Sla-2v 
					break;
			case 20: SL2_ReadDeferred(indx_opr.settingnumber); //   Sla-4v 
					break;
			case 21: SL3_ReadDeferred(indx_opr.settingnumber); //   Sla-6v 
					break;
			case 22: SL6_ReadDeferred(indx_opr.settingnumber); //   Sla-12v 
			}
		}
	}

void OPR_ReadvalueEmergency(bit indxnumberbattery_prm) //      
	{
	bit indxchargedischarge_tmp=FALSE; // 
	byte indxonlycharging_tmp=0;
	byte indxfullcharging_tmp=0;
	alter_opr.countertypebattery[indxnumberbattery_prm]=eeprom_read_byte(&Opr_TypemodeEmergency[0][indxnumberbattery_prm]); //  
	alter_opr.countermodebattery[indxnumberbattery_prm]=eeprom_read_byte(&Opr_TypemodeEmergency[1][indxnumberbattery_prm]); //  
	alter_opr.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Opr_TypemodeEmergency[2][indxnumberbattery_prm]); //   
	alter_opr.countermethodbattery[indxnumberbattery_prm]=eeprom_read_byte(&Opr_TypemodeEmergency[4][indxnumberbattery_prm]); //  
	alter_opr.summachargebattery[indxnumberbattery_prm]=eeprom_read_dword(&Opr_SummchargeEmergency[indxnumberbattery_prm]); // /  
	alter_opr.settcapacitybattery[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[0][indxnumberbattery_prm]); //   
	alter_opr.initialvoltagebattery[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[1][indxnumberbattery_prm]); //    
	alter_opr.maximumcurrentbattery[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[2][indxnumberbattery_prm]); //    
	alter_opr.miniresistancebattery[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[3][indxnumberbattery_prm]); //     
	alter_opr.maximumtemperature[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[4][indxnumberbattery_prm]); //    
	alter_opr.maximumoverheating[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[5][indxnumberbattery_prm]); //     
	alter_opr.numbercellsbattery[indxnumberbattery_prm]=eeprom_read_word(&Opr_ParametersEmergency[6][indxnumberbattery_prm]); //      
	switch(alter_opr.countermodebattery[indxnumberbattery_prm]) //  
		{
		case 0 ... 1: indxchargedischarge_tmp=TRUE; //    
				break;
		case 2: indxchargedischarge_tmp=FALSE; //    
				break;
		case 3 ... 4: asm("nop"); // 
		}
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indxonlycharging_tmp=eeprom_read_byte(&Opr_OnlychargeEmergency[FALSE]); //      1
					if(indxonlycharging_tmp==0) indx_opr.onlyfirstcharging=FALSE; //      
					else indx_opr.onlyfirstcharging=TRUE; //  
					indx_opr.lockfirstonlycharge=TRUE; //         1
					indxfullcharging_tmp=eeprom_read_byte(&Opr_FullchargeEmergency[FALSE]); //      1
					if(indxfullcharging_tmp==0) indx_opr.firstfullservice=FALSE; //        
					else indx_opr.firstfullservice=TRUE; //  
					break;
		case TRUE: indxonlycharging_tmp=eeprom_read_byte(&Opr_OnlychargeEmergency[TRUE]); //      2
					if(indxonlycharging_tmp==0) indx_opr.onlysecondcharging=FALSE; //      
					else indx_opr.onlysecondcharging=TRUE; //  
					indx_opr.locksecondonlycharge=TRUE; //         2
					indxfullcharging_tmp=eeprom_read_byte(&Opr_FullchargeEmergency[TRUE]); //      2
					if(indxfullcharging_tmp==0) indx_opr.secondfullservice=FALSE; //         
					else indx_opr.secondfullservice=TRUE; //  
		}
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //  
		{
		case 0: NMH_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //  Ni-Mh 
				break;
		case 1: NCD_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //  Ni-Cd 
				break;
		case 2: NM2_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    2- Ni-Mh 
				break;
		case 3: NM3_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    3- Ni-Mh 
				break;
		case 4: NM4_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    4- Ni-Mh 
				break;
		case 5: NM5_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    5- Ni-Mh 
				break;
		case 6: NM6_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    6- Ni-Mh 
				break;
		case 7: NM7_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    7- Ni-Mh 
				break;
		case 8: NM8_ReadEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    8- Ni-Mh 
				break;
		case 9: NZN_ReadEmergency(indxnumberbattery_prm); //  Ni-Zn 
				break;
		case 10: LPO_ReadEmergency(indxnumberbattery_prm); //  Li-Po 
				break;
		case 11: LIO_ReadEmergency(indxnumberbattery_prm); //  Li-Ion 
				break;
		case 12: LMN_ReadEmergency(indxnumberbattery_prm); //  Li-Mn 
				break;
		case 13: LCO_ReadEmergency(indxnumberbattery_prm); //  Li-Co 
				break;
		case 14: LCA_ReadEmergency(indxnumberbattery_prm); //  Li-Nca 
				break;
		case 15: LMC_ReadEmergency(indxnumberbattery_prm); //  Li-Nmc 
				break;
		case 16: LTI_ReadEmergency(indxnumberbattery_prm); //  Li-Ti 
				break;
		case 17: LFE_ReadEmergency(indxnumberbattery_prm); //  Li-Fe 
				break;
		case 18: LFP_ReadEmergency(indxnumberbattery_prm); //  LiFePo4 
				break;
		case 19: SL1_ReadEmergency(indxnumberbattery_prm); //  Sla-2v 
				break;
		case 20: SL2_ReadEmergency(indxnumberbattery_prm); //  Sla-4v 
				break;
		case 21: SL3_ReadEmergency(indxnumberbattery_prm); //  Sla-6v 
				break;
		case 22: SL6_ReadEmergency(indxnumberbattery_prm); //  Sla-12v 
		}
	}

void OPR_WritevalueDeferred(bit indxnumberbattery_prm) //     
	{
	bit indxchargedischarge_tmp=FALSE; // 
	byte indxonlycharging_tmp=0; 
	byte indxfullcharging_tmp=0; 
	if(eeprom_read_byte(&Opr_IndxoutDeferred[indxnumberbattery_prm])==0) //      
		{
		eeprom_write_byte(&Opr_TypemodeBattery[0][indxnumberbattery_prm],alter_opr.countertypebattery[indxnumberbattery_prm]); //   
		eeprom_write_byte(&Opr_TypemodeBattery[1][indxnumberbattery_prm],alter_opr.countermodebattery[indxnumberbattery_prm]); //   
		eeprom_write_byte(&Opr_TypemodeBattery[2][indxnumberbattery_prm],alter_opr.currentstatusprocess[indxnumberbattery_prm]); //    
		eeprom_write_byte(&Opr_TypemodeBattery[4][indxnumberbattery_prm],alter_opr.countermethodbattery[indxnumberbattery_prm]); //   
		eeprom_write_word(&Opr_SettingCapacity[indxnumberbattery_prm],alter_opr.settcapacitybattery[indxnumberbattery_prm]); //   
		eeprom_write_dword(&Opr_SummaChargedischarge[indxnumberbattery_prm],alter_opr.summachargebattery[indxnumberbattery_prm]); // /   
		eeprom_write_word(&Opr_ParametersDeferred[0][indxnumberbattery_prm],alter_opr.initialvoltagebattery[indxnumberbattery_prm]); //   / 
		eeprom_write_word(&Opr_ParametersDeferred[1][indxnumberbattery_prm],alter_opr.maximumcurrentbattery[indxnumberbattery_prm]); //   / 
		eeprom_write_word(&Opr_ParametersDeferred[2][indxnumberbattery_prm],alter_opr.miniresistancebattery[indxnumberbattery_prm]); //      / 
		eeprom_write_word(&Opr_ParametersDeferred[3][indxnumberbattery_prm],alter_opr.maximumtemperature[indxnumberbattery_prm]); //    
		eeprom_write_word(&Opr_ParametersDeferred[4][indxnumberbattery_prm],alter_opr.maximumoverheating[indxnumberbattery_prm]); //     
		eeprom_write_word(&Opr_ParametersDeferred[5][indxnumberbattery_prm],alter_opr.numbercellsbattery[indxnumberbattery_prm]); //      
		eeprom_write_byte(&Opr_IndxoutDeferred[indxnumberbattery_prm],1); //        
		switch(indxnumberbattery_prm) //   
			{
			case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1 
						if(indx_opr.onlyfirstcharging==FALSE) indxonlycharging_tmp=0; //       
						else indxonlycharging_tmp=1; //    
						indxchargedischarge_tmp=indx_opr.firstfullservice; //      1 
						if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //       
						else indxfullcharging_tmp=1; //    
						eeprom_update_byte(&Opr_IndxonlyCharging[FALSE],indxonlycharging_tmp); //     eeprom  
						eeprom_update_byte(&Opr_IndxfullCharging[FALSE],indxfullcharging_tmp); //     eeprom  
						break;
			case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2 
						if(indx_opr.onlysecondcharging==FALSE) indxonlycharging_tmp=0; //      
						else indxonlycharging_tmp=1; //   
						indxchargedischarge_tmp=indx_opr.secondfullservice; //      2 
						if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //      
						else indxfullcharging_tmp=1; //   
						eeprom_update_byte(&Opr_IndxonlyCharging[TRUE],indxonlycharging_tmp); //     eeprom  
						eeprom_update_byte(&Opr_IndxfullCharging[TRUE],indxfullcharging_tmp); //     eeprom  
			}
		switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //   
			{
			case 0: NMH_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //    Ni-Mh  
					break;
			case 1: NCD_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //    Ni-d  
					break;
			case 2: NM2_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     2- Ni-Mh 
					break;
			case 3: NM3_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     3- Ni-Mh 
					break;
			case 4: NM4_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     4- Ni-Mh 
					break;
			case 5: NM5_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     5- Ni-Mh 
					break;
			case 6: NM6_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     6- Ni-Mh 
					break;
			case 7: NM7_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     7- Ni-Mh 
					break;
			case 8: NM8_WriteDeferred(indxnumberbattery_prm,indxchargedischarge_tmp); //     8- Ni-Mh 
					break;
			case 9: NZN_WriteDeferred(indxnumberbattery_prm); //    Ni-Zn  
					break;
			case 10: LPO_WriteDeferred(indxnumberbattery_prm); //    Li-Po 
					break;
			case 11: LIO_WriteDeferred(indxnumberbattery_prm); //    Li-Ion  
					break;
			case 12: LMN_WritDeferred(indxnumberbattery_prm); //    Li-Mn 
					break;
			case 13: LCO_WriteDeferred(indxnumberbattery_prm); //    Li-Co 
					break;
			case 14: LCA_WriteDeferred(indxnumberbattery_prm); //    Li-Nca 
					break;
			case 15: LMC_WriteDeferred(indxnumberbattery_prm); //    Li-Nmc 
					break;
			case 16: LTI_WriteDeferred(indxnumberbattery_prm); //    Li-Ti  
					break;
			case 17: LFE_WriteDeferred(indxnumberbattery_prm); //    Li-Fe  
					break;
			case 18: LFP_WriteDeferred(indxnumberbattery_prm); //    LiFePo4  
					break;
			case 19: SL1_WriteDeferred(indxnumberbattery_prm); //    Sla-2v 
					break;
			case 20: SL2_WriteDeferred(indxnumberbattery_prm); //    Sla-4v 
					break;
			case 21: SL3_WriteDeferred(indxnumberbattery_prm); //    Sla-6v 
					break;
			case 22: SL6_WriteDeferred(indxnumberbattery_prm); //    Sla-12v 
			}
		}
	}

void OPR_WritevalueEmergency(bit indxnumberbattery_prm) //      
	{
	bit indxchargedischarge_tmp=FALSE; // 
	byte indxonlycharging_tmp=0;
	byte indxfullcharging_tmp=0;
	eeprom_write_byte(&Opr_TypemodeEmergency[0][indxnumberbattery_prm],alter_opr.countertypebattery[indxnumberbattery_prm]); //  
	eeprom_write_byte(&Opr_TypemodeEmergency[1][indxnumberbattery_prm],alter_opr.countermodebattery[indxnumberbattery_prm]); //  
	eeprom_write_byte(&Opr_TypemodeEmergency[2][indxnumberbattery_prm],alter_opr.currentstatusprocess[indxnumberbattery_prm]); //   
	eeprom_write_byte(&Opr_TypemodeEmergency[3][indxnumberbattery_prm],alter_opr.datanumbersensors[indxnumberbattery_prm]); //   
	eeprom_write_byte(&Opr_TypemodeEmergency[4][indxnumberbattery_prm],alter_opr.countermethodbattery[indxnumberbattery_prm]); //  
	eeprom_write_dword(&Opr_SummchargeEmergency[indxnumberbattery_prm],alter_opr.summachargebattery[indxnumberbattery_prm]); // /  
	eeprom_write_word(&Opr_ParametersEmergency[0][indxnumberbattery_prm],alter_opr.settcapacitybattery[indxnumberbattery_prm]); //  
	eeprom_write_word(&Opr_ParametersEmergency[1][indxnumberbattery_prm],alter_opr.initialvoltagebattery[indxnumberbattery_prm]); //   /
	eeprom_write_word(&Opr_ParametersEmergency[2][indxnumberbattery_prm],alter_opr.maximumcurrentbattery[indxnumberbattery_prm]); //   /
	eeprom_write_word(&Opr_ParametersEmergency[3][indxnumberbattery_prm],alter_opr.miniresistancebattery[indxnumberbattery_prm]); //      /
	eeprom_write_word(&Opr_ParametersEmergency[4][indxnumberbattery_prm],alter_opr.maximumtemperature[indxnumberbattery_prm]); //   
	eeprom_write_word(&Opr_ParametersEmergency[5][indxnumberbattery_prm],alter_opr.maximumoverheating[indxnumberbattery_prm]); //    
	eeprom_write_word(&Opr_ParametersEmergency[6][indxnumberbattery_prm],alter_opr.numbercellsbattery[indxnumberbattery_prm]); //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1
					if(indx_opr.onlyfirstcharging==FALSE) indxonlycharging_tmp=0; //      
					else indxonlycharging_tmp=1; //   
					indxchargedischarge_tmp=indx_opr.firstfullservice; //      1
					if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //      
					else indxfullcharging_tmp=1; //   
					eeprom_update_byte(&Opr_OnlychargeEmergency[FALSE],indxonlycharging_tmp); //     eeprom 
					eeprom_update_byte(&Opr_FullchargeEmergency[FALSE],indxfullcharging_tmp); //     eeprom 
					break;
		case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2
					if(indx_opr.onlysecondcharging==FALSE) indxonlycharging_tmp=0; //      
					else indxonlycharging_tmp=1; //   
					indxchargedischarge_tmp=indx_opr.secondfullservice; //      2
					if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //      
					else indxfullcharging_tmp=1; //   
					eeprom_update_byte(&Opr_OnlychargeEmergency[TRUE],indxonlycharging_tmp); //     eeprom 
					eeprom_update_byte(&Opr_FullchargeEmergency[TRUE],indxfullcharging_tmp); //     eeprom 
		}
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //  
		{
		case 0: NMH_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    Ni-Mh 
				break;
		case 1: NCD_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //    Ni-d 
				break;
		case 2: NM2_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     2- Ni-Mh 
				break;
		case 3: NM3_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     3- Ni-Mh 
				break;
		case 4: NM4_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     4- Ni-Mh 
				break;
		case 5: NM5_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     5- Ni-Mh 
				break;
		case 6: NM6_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     6- Ni-Mh 
				break;
		case 7: NM7_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     7- Ni-Mh 
				break;
		case 8: NM8_WriteEmergency(indxnumberbattery_prm,indxchargedischarge_tmp); //     8- Ni-Mh 
				break;
		case 9: NZN_WriteEmergency(indxnumberbattery_prm); //    Ni-Zn 
				break;
		case 10: LPO_WriteEmergency(indxnumberbattery_prm); //    Li-Po 
				break;
		case 11: LIO_WriteEmergency(indxnumberbattery_prm); //    Li-Ion 
				break;
		case 12: LMN_WritEmergency(indxnumberbattery_prm); //    Li-Mn 
				break;
		case 13: LCO_WriteEmergency(indxnumberbattery_prm); //    Li-Co 
				break;
		case 14: LCA_WriteEmergency(indxnumberbattery_prm); //    Li-Nca 
				break;
		case 15: LMC_WriteEmergency(indxnumberbattery_prm); //    Li-Nmc 
				break;
		case 16: LTI_WriteEmergency(indxnumberbattery_prm); //    Li-Ti 
				break;
		case 17: LFE_WriteEmergency(indxnumberbattery_prm); //    Li-Fe 
				break;
		case 18: LFP_WriteEmergency(indxnumberbattery_prm); //    LiFePo4 
				break;
		case 19: SL1_WriteEmergency(indxnumberbattery_prm); //    Sla-2v 
				break;
		case 20: SL2_WriteEmergency(indxnumberbattery_prm); //    Sla-4v 
				break;
		case 21: SL3_WriteEmergency(indxnumberbattery_prm); //    Sla-6v 
				break;
		case 22: SL6_WriteEmergency(indxnumberbattery_prm); //    Sla-12v 
		}
	eeprom_write_byte(&Opr_IndxoutEmergency[indxnumberbattery_prm],1); //     
	}

byte OPR_SearchnumberSensors(byte numbersensors_prm,byte roomsnumber_prm) //     
	{
	byte numbersensors_tmp=0; // 
	byte ininumbersensors_tmp=0;
	byte endnumbersensors_tmp=0;
	ininumbersensors_tmp=numbersensors_prm; //   
	endnumbersensors_tmp=ininumbersensors_tmp+roomsnumber_prm; //   
	while((ininumbersensors_tmp<endnumbersensors_tmp)&&(numbersensors_tmp==0)) //  
		{
		if(OWI_DetectPresence()==0) //   
			{
			OWI_TransferIdentifi(ininumbersensors_tmp); //     
			OWI_TransferRecall(); //     eeprom   
			OWI_DetectPresence(); // 
			OWI_TransferIdentifi(ininumbersensors_tmp); // 
			if(OWI_ReadramSensor()==TRUE) numbersensors_tmp=OWI_ReadbyteBuffer(2); //      
			}
		ininumbersensors_tmp++; //  
		}
	return numbersensors_tmp; //  
	}

void OPR_StartConverting(bit indxtimewaiting_prm,byte numbersensors_prm) //   
	{
	if(OWI_DetectPresence()==0) //    
		{
		OWI_TransferConverting(indxtimewaiting_prm,numbersensors_prm); //     
		}
	}

word OPR_ReadTemperature(byte numbersensors_prm) //    
	{
	word measuredvalue_tmp=0; // 
	if(OWI_DetectPresence()==0) //    
		{
		OWI_TransferIdentifi(numbersensors_prm); //     
		if(OWI_ReadramSensor()==TRUE) measuredvalue_tmp=OWI_ConversionDecimal(); //       
		}
	return measuredvalue_tmp; //   
	}

byte OPR_ReadnumberSensor(bit indxnumberbattery_prm) //   
	{
	return alter_opr.datanumbersensors[indxnumberbattery_prm]; //    
	}

byte OPR_ReadnumberProtocol(bit indxnumberbattery_prm) //     
	{
	return eeprom_read_byte(&Opr_TypemodeBattery[3][indxnumberbattery_prm]); //     
	}

byte OPR_ReadmethodBattery(bit indxnumberbattery_prm) //   
	{
	return alter_opr.countermethodbattery[indxnumberbattery_prm]; //     
	}

void OPR_BlockingOutitems(void) //       
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: if(indx_opr.blockfirstoutitems==TRUE) indx_opr.blockfirstoutitems=FALSE; //       1 
					break;
		case TRUE: if(indx_opr.blocksecondoutitems==TRUE) indx_opr.blocksecondoutitems=FALSE; //       2  	
		}
	}

void OPR_UnblockingOutitems(void) //       
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: if(indx_opr.blockfirstoutitems==FALSE) indx_opr.blockfirstoutitems=TRUE; //       1
					break;
		case TRUE: if(indx_opr.blocksecondoutitems==FALSE) indx_opr.blocksecondoutitems=TRUE; //       2
		}
	}

void OPR_OutputitemsProtocol(bit indxnumberbattery_prm) //      
	{
	word dataitemsprotocol_tmp=0; //  
	dataitemsprotocol_tmp=eeprom_read_word(&Opr_DataitemsProtocol[0][indxnumberbattery_prm]); //    
	if(dataitemsprotocol_tmp==0) //      
		{
		switch(indxnumberbattery_prm) //   
			{
			case FALSE: indx_opr.outputfirstprotocol=FALSE; //          1 
						break;
			case TRUE: indx_opr.outputsecondprotocol=FALSE; //          2 
			}
		indx_opr.updatetextstring=TRUE; //    
		}
	else //       
		{
		dataitemsprotocol_tmp=eeprom_read_word(&Opr_DataitemsProtocol[alter_opr.counteritemprotocol[indxnumberbattery_prm]][indxnumberbattery_prm]); //     
		switch(alter_opr.counteritemprotocol[indxnumberbattery_prm]) //    
			{
			case 0: SYM_ByteLineout(indxnumberbattery_prm,4,27,(byte)dataitemsprotocol_tmp,0,0); //  ::
					break;
			case 1: SYM_WordLineout(indxnumberbattery_prm,(byte)dataitemsprotocol_tmp,1); //   
					break;
			case 2: SYM_ByteLineout(indxnumberbattery_prm,4,27,37,0,0); // : :        
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 3: SYM_ByteLineout(indxnumberbattery_prm,4,31,34,0,0); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //     
					break;
			case 4: SYM_ByteLineout(indxnumberbattery_prm,4,31,34,0,0); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //     
					break;
			case 5: SYM_ByteLineout(indxnumberbattery_prm,4,33,36,0,0); // : :  -    
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 6: SYM_ByteLineout(indxnumberbattery_prm,4,33,36,0,0); // : :  -    
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 7: SYM_ByteLineout(indxnumberbattery_prm,4,33,37,0,0); // : :  -      
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 8: SYM_ByteLineout(indxnumberbattery_prm,4,31,41,0,0); // : :   ,    
					SYM_OutdataNumber0_000(dataitemsprotocol_tmp,8); //      
					break;
			case 9: SYM_ByteLineout(indxnumberbattery_prm,4,31,39,0,0); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,12); //     
					break;
			case 10: SYM_ByteLineout(indxnumberbattery_prm,4,31,40,0,0); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,12); //      
					break;
			case 11: SYM_ByteLineout(indxnumberbattery_prm,4,32,34,0,0); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //     
					break;
			case 12: SYM_ByteLineout(indxnumberbattery_prm,4,32,34,0,0); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //     
					break;
			case 13: SYM_ByteLineout(indxnumberbattery_prm,4,32,36,0,0); // : :       
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 14: SYM_ByteLineout(indxnumberbattery_prm,4,32,36,0,0); // : :       
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //   
					break;
			case 15: SYM_ByteLineout(indxnumberbattery_prm,4,32,37,0,0); // : :       
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,8); //     
					break;
			case 16: SYM_ByteLineout(indxnumberbattery_prm,4,32,41,0,0); // : :   ,    
					SYM_OutdataNumber0_000(dataitemsprotocol_tmp,8); //      
					break;
			case 17: SYM_ByteLineout(indxnumberbattery_prm,4,32,39,0,0); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,12); //     
					break;
			case 18: SYM_ByteLineout(indxnumberbattery_prm,4,32,40,0,0); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,12); //      
			}
		}
	}

void OPR_WritedataProtocol(bit indxnumberbattery_prm) //    
	{
	switch(indxnumberbattery_prm) //   
		{
		case FALSE:	switch(alter_opr.countermodebattery[indxnumberbattery_prm]) //    1
						{
						case 0: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: break; // 
									case TRUE: OPR_DatadischargeProtocol(indxnumberbattery_prm,FALSE); //       
									}
								break; 
						case 1: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: break; // 
									case TRUE: OPR_DatadischargeProtocol(indxnumberbattery_prm,TRUE); //      
									}
								break; 
						case 2: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: switch(indx_opr.firstfullservice) //     
													{
													case FALSE: OPR_DatachargeProtocol(indxnumberbattery_prm,TRUE); //  a     
																break; 
													case TRUE: OPR_DatachargeProtocol(indxnumberbattery_prm,FALSE); //  a     
													}
												break; 
									case TRUE: asm("nop"); //  
									}
								break; 
						case 3 ... 4: asm("nop"); // 
						}
					break;
		case TRUE: switch(alter_opr.countermodebattery[indxnumberbattery_prm]) //    2
						{
						case 0: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: break; // 
									case TRUE: OPR_DatadischargeProtocol(indxnumberbattery_prm,FALSE); //      
									}
								break;
						case 1: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: break; // 
									case TRUE: OPR_DatadischargeProtocol(indxnumberbattery_prm,TRUE); //      
									}
								break;
						case 2: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: switch(indx_opr.secondfullservice) //  
													{
													case FALSE: OPR_DatachargeProtocol(indxnumberbattery_prm,TRUE); //  a    
																break;
													case TRUE: OPR_DatachargeProtocol(indxnumberbattery_prm,FALSE); //  a    
													}
												break;
									case TRUE: asm("nop"); // 
									}
								break;
						case 3 ... 4: asm("nop"); // 
						}
		}
	}

void OPR_DatachargeProtocol(bit indxnumberbattery_prm,bit indxresetdata_prm) //          
	{
	eeprom_write_word(&Opr_DataitemsProtocol[11][indxnumberbattery_prm],alter_opr.initialvoltagebattery[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[12][indxnumberbattery_prm],alter_opr.measuredvoltagebattery[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[13][indxnumberbattery_prm],alter_opr.maximumcurrentbattery[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[14][indxnumberbattery_prm],alter_opr.measuredcurrentbattery[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[15][indxnumberbattery_prm],alter_opr.measuredchargebattery[indxnumberbattery_prm]); //       
	eeprom_write_word(&Opr_DataitemsProtocol[16][indxnumberbattery_prm],alter_opr.miniresistancebattery[indxnumberbattery_prm]); //       
	eeprom_write_word(&Opr_DataitemsProtocol[17][indxnumberbattery_prm],alter_opr.maximumtemperature[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[18][indxnumberbattery_prm],alter_opr.maximumoverheating[indxnumberbattery_prm]); //        
	if(indxresetdata_prm==TRUE) OPR_ResetdataProtocol(indxnumberbattery_prm,TRUE); //         
	}

void OPR_DatadischargeProtocol(bit indxnumberbattery_prm,bit indxresetdata_prm) //          
	{
	word dataitemsprotocol_tmp=0; //  
	dataitemsprotocol_tmp=OPR_TypebatteryProtocol(indxnumberbattery_prm); //     
	eeprom_write_byte(&Opr_TypemodeBattery[3][indxnumberbattery_prm],alter_opr.datanumbersensors[indxnumberbattery_prm]); //   
	eeprom_write_word(&Opr_DataitemsProtocol[0][indxnumberbattery_prm],dataitemsprotocol_tmp); //   
	dataitemsprotocol_tmp=OPR_MethodbatteryProtocol(indxnumberbattery_prm); //     
	eeprom_write_word(&Opr_DataitemsProtocol[1][indxnumberbattery_prm],dataitemsprotocol_tmp); //    
	eeprom_write_word(&Opr_DataitemsProtocol[2][indxnumberbattery_prm],alter_opr.settcapacitybattery[indxnumberbattery_prm]); //   
	eeprom_write_word(&Opr_DataitemsProtocol[3][indxnumberbattery_prm],alter_opr.initialvoltagebattery[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[4][indxnumberbattery_prm],alter_opr.measuredvoltagebattery[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[5][indxnumberbattery_prm],alter_opr.maximumcurrentbattery[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[6][indxnumberbattery_prm],alter_opr.measuredcurrentbattery[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[7][indxnumberbattery_prm],alter_opr.measuredchargebattery[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[8][indxnumberbattery_prm],alter_opr.miniresistancebattery[indxnumberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[9][indxnumberbattery_prm],alter_opr.maximumtemperature[indxnumberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[10][indxnumberbattery_prm],alter_opr.maximumoverheating[indxnumberbattery_prm]); //      
	if(indxresetdata_prm==TRUE) OPR_ResetdataProtocol(indxnumberbattery_prm,FALSE); //        
	}

void OPR_ResetdataProtocol(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //    
	{
	bit indxendresetcycle_tmp=FALSE; //  
	byte databeginnarray_tmp=0; 
	byte dataendingarray_tmp=0; 
	word dataitemsprotocol_tmp=0; 
	switch(indxchargedischarge_prm) //  / 
		{
		case FALSE: databeginnarray_tmp=11; //      
					dataendingarray_tmp=18; //      
					while(indxendresetcycle_tmp==FALSE) //     
						{
						eeprom_write_word(&Opr_DataitemsProtocol[databeginnarray_tmp][indxnumberbattery_prm],0); //      
						databeginnarray_tmp++; //  
						if(databeginnarray_tmp>dataendingarray_tmp) indxendresetcycle_tmp=TRUE; //     
						}
					break;
		case TRUE: dataitemsprotocol_tmp=OPR_TypebatteryProtocol(indxnumberbattery_prm); //     
					eeprom_write_byte(&Opr_TypemodeBattery[3][indxnumberbattery_prm],alter_opr.datanumbersensors[indxnumberbattery_prm]); //   
					eeprom_write_word(&Opr_DataitemsProtocol[0][indxnumberbattery_prm],dataitemsprotocol_tmp); //   
					dataitemsprotocol_tmp=OPR_MethodbatteryProtocol(indxnumberbattery_prm); //     
					eeprom_write_word(&Opr_DataitemsProtocol[1][indxnumberbattery_prm],dataitemsprotocol_tmp); //    
					eeprom_write_word(&Opr_DataitemsProtocol[2][indxnumberbattery_prm],alter_opr.settcapacitybattery[indxnumberbattery_prm]); //   
					databeginnarray_tmp=3; //      
					dataendingarray_tmp=10; //      
					while(indxendresetcycle_tmp==FALSE) //     
						{
						eeprom_write_word(&Opr_DataitemsProtocol[databeginnarray_tmp][indxnumberbattery_prm],0); //    
						databeginnarray_tmp++; //  
						if(databeginnarray_tmp>dataendingarray_tmp) indxendresetcycle_tmp=TRUE; //     
						}
		}
	}

bit OPR_ControlViolconnect(bit indxnumberbattery_prm,word measurecurrentbattery_prm) //      
	{
	bit indxconnectbattery_tmp=FALSE; // 
	word maxlimitvoltage_tmp=0;
	word minlimitvoltage_tmp=0;
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //  
		{
		case 0 ... 1: maxlimitvoltage_tmp=OPRMAXLIMIT_NIMHCD; //    Ni-Cd  Ni-Mh 
				minlimitvoltage_tmp=OPRMINLIMIT_NIMHCD; //    Ni-Cd  Ni-Mh 
				break;
		case 2 ... 8: maxlimitvoltage_tmp=OPRMAXLIMIT_NIMHCD*(word)alter_opr.countertypebattery[indxnumberbattery_prm]; //     Ni-Cd  Ni-Mh 
				minlimitvoltage_tmp=OPRMINLIMIT_NIMHCD*(word)alter_opr.countertypebattery[indxnumberbattery_prm]; //     Ni-Cd  Ni-Mh 
				break;
		case 9: maxlimitvoltage_tmp=OPRMAXLIMIT_NIZN; //    Ni-Zn 
				minlimitvoltage_tmp=OPRMINLIMIT_NIZN; //    Ni-Zn 
				break;
		case 10 ... 15: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM1; //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc 
				minlimitvoltage_tmp=OPRMINLIMIT_LITHIUM1; //    Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc 
				break;
		case 16: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM3; //    Li-Ti 
				minlimitvoltage_tmp=OPRMINLIMIT_LITHIUM3; //    Li-Ti 
				break;
		case 17: maxlimitvoltage_tmp=OPRMAXLIMIT_LITHIUM2; //    Li-Fe 
				minlimitvoltage_tmp=OPRMINLIMIT_LITHIUM2; //    Li-Fe 
				break;
		case 18: maxlimitvoltage_tmp=OPRMAXLIMIT_LIFEPO4; //    LiFePo4 
				minlimitvoltage_tmp=OPRMINLIMIT_LIFEPO4; //    LiFePo4 
				break;
		case 19: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA2V; //    Sla-2v 
				minlimitvoltage_tmp=OPRMINLIMIT_SLA2V; //    Sla-2v 
				break;
		case 20: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA4V; //    Sla-4v 
				minlimitvoltage_tmp=OPRMINLIMIT_SLA4V; //    Sla-4v 
				break;
		case 21: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA6V; //    Sla-6v 
				minlimitvoltage_tmp=OPRMINLIMIT_SLA6V; //    Sla-6v 
				break;
		case 22: maxlimitvoltage_tmp=OPRMAXLIMIT_SLA12V; //    Sla-12v 
				minlimitvoltage_tmp=OPRMINLIMIT_SLA12V; //    Sla-12v 
		}
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(indx_opr.firstchargedischarge) // /  1
						{
						case FALSE: if((alter_opr.measvoltageloadedbattery[indxnumberbattery_prm]>=maxlimitvoltage_tmp)&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //        
									break;
						case TRUE: if((alter_opr.measvoltageloadedbattery[indxnumberbattery_prm]<=minlimitvoltage_tmp)&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //        
						}
					break;
		case TRUE: switch(indx_opr.secondchargedischarge) // /  2
						{
						case FALSE: if((alter_opr.measvoltageloadedbattery[indxnumberbattery_prm]>=maxlimitvoltage_tmp)&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //        
									break;
						case TRUE: if((alter_opr.measvoltageloadedbattery[indxnumberbattery_prm]<=minlimitvoltage_tmp)&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //        
						}
		}
	return indxconnectbattery_tmp; //   
	}																													

word OPR_TypebatteryProtocol(bit indxnumberbattery_prm) //     
	{
	word dataitemsprotocol_tmp=0; //  
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //   
		{
		case 0: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //   
					{
					case 1 ... 8: dataitemsprotocol_tmp=1; //    : : .  Ni-Mh 
					}
				break;
		case 1: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //   
					{
					case 9 ... 12: dataitemsprotocol_tmp=2; //    : : .  Ni-Cd 
					}
				break;
		case 2: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 13 ... 14: dataitemsprotocol_tmp=11; //    : : .  2Ni-Gr
					}
				break;
		case 3: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 15 ... 16: dataitemsprotocol_tmp=12; //    : : .  3Ni-Gr
					}
				break;
		case 4: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 17 ... 18: dataitemsprotocol_tmp=13; //    : : .  4Ni-Gr
					}
				break;
		case 5: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 19 ... 20: dataitemsprotocol_tmp=14; //    : : .  5Ni-Gr
					}
				break;
		case 6: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 21 ... 22: dataitemsprotocol_tmp=15; //    : : .  6Ni-Gr
					}
				break;
		case 7: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 23 ... 24: dataitemsprotocol_tmp=16; //    : : .  7Ni-Gr
					}
				break;
		case 8: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 25 ... 26: dataitemsprotocol_tmp=17; //    : : .  8Ni-Gr
					}
				break;
		case 9: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 27 ... 30: dataitemsprotocol_tmp=45; //    : : .  Ni-Zn
					}
				break;
		case 10: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //   
					{
					case 31 ... 40: dataitemsprotocol_tmp=3; //    : : .  Li-Po 
					}
				break;
		case 11: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //   
					{
					case 41 ... 50: dataitemsprotocol_tmp=4; //    : : .  Li-Ion 
					}
				break;
		case 12: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 51 ... 56: dataitemsprotocol_tmp=7; //    : : .  Li-Mn
					}
				break;
		case 13: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 57 ... 62: dataitemsprotocol_tmp=8; //    : : .  Li-Co
					}
				break;
		case 14: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 63 ... 68: dataitemsprotocol_tmp=9; //    : : .  Li-Nca
					}
				break;
		case 15: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 69 ... 74: dataitemsprotocol_tmp=10; //    : : .  Li-Nmc
					}
				break;
		case 16: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 75 ... 80: dataitemsprotocol_tmp=6; //    : : .  Li-Ti
					}
				break;
		case 17: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //   
					{
					case 81 ... 86: dataitemsprotocol_tmp=5; //    : : .  Li-Fe 
					}
				break;
		case 18: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 87 ... 88: dataitemsprotocol_tmp=22; //    : : .  LiFePo4
					}
				break;
		case 19: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 89 ... 90: dataitemsprotocol_tmp=18; //    : : .  Sla-2v
					}
				break;
		case 20: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 91 ... 92: dataitemsprotocol_tmp=19; //    : : .  Sla-4v
					}
				break;
		case 21: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 93 ... 94: dataitemsprotocol_tmp=20; //    : : .  Sla-6v
					}
				break;
		case 22: switch(alter_opr.datanumbersensors[indxnumberbattery_prm]) //  
					{
					case 95 ... 96: dataitemsprotocol_tmp=21; //    : : .  Sla-12v
					}
		}
	return dataitemsprotocol_tmp; //     
	}

word OPR_MethodbatteryProtocol(bit indxnumberbattery_prm) //     
	{
	word methoditemsprotocol_tmp=0; //  
	switch(alter_opr.countermethodbattery[indxnumberbattery_prm]) //    
		{
		case 0: methoditemsprotocol_tmp=6; //    : :  
				break;
		case 1: methoditemsprotocol_tmp=7; //    : :  
				break;
		case 2: methoditemsprotocol_tmp=8; //    : :  
		}
	return methoditemsprotocol_tmp; //     
	}

word OPR_ReadintResistance(bit indxnumberbattery_prm) //    
	{
	word intresistancebattery_tmp=0; //  
	intresistancebattery_tmp=alter_opr.intresistancebattery[indxnumberbattery_prm]; //    
	return intresistancebattery_tmp; //    
	}

void OPR_SettpermitControl(bit indxnumberbattery_prm,bit indxonoffdischarge_prm,bit indxonoffmaincanal_prm) //   
	{
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: switch(indxonoffdischarge_prm) //    
						{
						case FALSE: if(bit_is_set(OPRONOFF_PORTCONTROL,OPRCONTROL_FIRSTDISCH)) ClearBit(OPRONOFF_PERMISSION,OPRBYTE_FIRSTDISCH); //     1   
									break;
						case TRUE: if(bit_is_clear(OPRONOFF_PORTCONTROL,OPRCONTROL_FIRSTDISCH)) SetBit(OPRONOFF_PERMISSION,OPRBYTE_FIRSTDISCH); //     1    
						}
					SYS_TimeWaiting(10); // /  10  
					switch(indxonoffmaincanal_prm) //      1 
						{
						case FALSE: if(bit_is_set(OPRONOFF_PORTCONTROL,OPRCONTROL_FIRSTGRANT)) ClearBit(OPRONOFF_PERMISSION,OPRBYTE_FIRSTGRANT); //      1   
									break;
						case TRUE: if(bit_is_clear(OPRONOFF_PORTCONTROL,OPRCONTROL_FIRSTGRANT)) SetBit(OPRONOFF_PERMISSION,OPRBYTE_FIRSTGRANT); //      1   
						}
					break;
		case TRUE: switch(indxonoffdischarge_prm) //   
						{
						case FALSE: if(bit_is_set(OPRONOFF_PORTCONTROL,OPRCONTROL_SECONDISCH)) ClearBit(OPRONOFF_PERMISSION,OPRBYTE_SECONDISCH); //     2  
									break;
						case TRUE: if(bit_is_clear(OPRONOFF_PORTCONTROL,OPRCONTROL_SECONDISCH)) SetBit(OPRONOFF_PERMISSION,OPRBYTE_SECONDISCH); //     2  
						}
					SYS_TimeWaiting(10); // /  10  
					switch(indxonoffmaincanal_prm) //      2 
						{
						case FALSE: if(bit_is_set(OPRONOFF_PORTCONTROL,OPRCONTROL_SECONDGRANT)) ClearBit(OPRONOFF_PERMISSION,OPRBYTE_SECONDGRANT); //      2  
									break;
						case TRUE: if(bit_is_clear(OPRONOFF_PORTCONTROL,OPRCONTROL_SECONDGRANT)) SetBit(OPRONOFF_PERMISSION,OPRBYTE_SECONDGRANT); //      2  
						}
		}
	SYS_TimeWaiting(20); // /  20  
	}






















